(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_md_egr *)

unit U_md_egr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Table2I_NUMERO: TFloatField;
    Table2I_LIBELLE: TStringField;
    Table2I_PRIX: TFloatField;
    Table2I_QUANTITE: TFloatField;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    Table2I_NUM_FACT: TFloatField;
    Prior_: TButton;
    Next_: TButton;
    Append_: TButton;
    Post_: TButton;
    Edit1: TEdit;
    Table3: TTable;
    Edit2: TEdit;
    procedure Append_Click(Sender: TObject);
    procedure DBGrid2Enter(Sender: TObject);
    procedure DBGrid2Exit(Sender: TObject);
    procedure Post_Click(Sender: TObject);
    procedure Prior_Click(Sender: TObject);
    procedure Next_Click(Sender: TObject);
    procedure Table2I_QUANTITESetText(Sender: TField; const Text: String);
    procedure Table2I_PRIXValidate(Sender: TField);
    procedure Table2BeforeInsert(DataSet: TDataset);
    procedure DataSource2DataChange(Sender: TObject; Field: TField);
    procedure Table2BeforePost(DataSet: TDataset);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Append_Click(Sender: TObject);
begin
  Table1.Append;
  dbEdit1.SetFocus;
end;

procedure TForm1.DBGrid2Enter(Sender: TObject);
begin

  Table2I_NUM_FACT.ReadOnly:= True;

end;

procedure TForm1.DBGrid2Exit(Sender: TObject);
begin

  Table2I_NUM_FACT.ReadOnly:= False;

end;

procedure TForm1.Post_Click(Sender: TObject);
begin
  Table1.Post;
end;

procedure TForm1.Prior_Click(Sender: TObject);
begin
  Table1.Prior;
end;

procedure TForm1.Next_Click(Sender: TObject);
begin
  Table1.Next;
end;

procedure TForm1.Table2I_QUANTITESetText(Sender: TField;
  const Text: String);
begin
  If Table1.FieldByName('F_CLIENT').AsString= 'Gus'
    Then begin
        Table2I_QUANTITE.AsFloat:= ( (StrToInt(Text)+ 4) div 5)* 5
      end
    else Table2I_QUANTITE.AsString:= Text;
end;

procedure TForm1.Table2I_PRIXValidate(Sender: TField);
begin
  If Table1.FieldByName('F_CLIENT').AsString= 'Liz'
    then begin
        if Table2I_PRIX.AsFloat> 100
          then Abort;
      end;
end;

procedure TForm1.Table2BeforeInsert(DataSet: TDataset);
var l_nombre: Integer;
begin
  with Table3 do
  begin
    SetRange([Table1.Fields[0].AsInteger] , [Table1.Fields[0].AsInteger]);

    First;
    l_nombre:= 0;
    While not Eof do
    begin
      inc(l_nombre);
      Next;
    end;
  end;

  If l_nombre> 3
    then Abort;
end;

procedure TForm1.DataSource2DataChange(Sender: TObject; Field: TField);
var l_nombre: Integer;
    l_prix_total: Double;
    l_chaine: String;
    l_nombre_espaces: Double;
begin
  Table3.Open;

  If Field= Nil
    then
      with Table3 do
      begin
        SetRange([Table1.Fields[0].AsInteger] , [Table1.Fields[0].AsInteger]);
        First;

        l_nombre:= 0;
        l_prix_total:= 0;
        While not Eof do
        begin
          inc(l_nombre);
          l_prix_total:= l_prix_total+ (Table3.FieldByName('I_PRIX').AsFloat*
              Table3.FieldByName('I_QUANTITE').AsFloat);

          Next;
        end;
        Edit1.Text:= IntToStr(l_nombre);
{
        Edit2.Text:= FormatFloat('                                  ##,##0.00', l_prix_total);
        Edit2.Text:= FloatToStr(l_prix_total);

        l_chaine:= Format('%25f', [l_prix_total]);
        Edit2.Text:= Format('%'+ IntToStr(15- Length(l_chaine))+ 's', [''])+ l_chaine;
}
        l_chaine:= FloatToStr(l_prix_total);
        l_nombre_espaces:= (Edit2.Width- Canvas.TextWidth(l_chaine+ '00')) / Canvas.TextWidth(' ');
        Edit2.Text:= Format('%'+ IntToStr(Round(l_nombre_espaces))+ 's', [''])+ l_chaine;
      end;
end;

procedure TForm1.Table2BeforePost(DataSet: TDataset);
var l_prix_total: Double;
begin
  with Table3 do
  begin
    SetRange([Table1.Fields[0].AsInteger] , [Table1.Fields[0].AsInteger]);

    First;
    l_prix_total:= 0;
    While not Eof do
    begin
      l_prix_total:= l_prix_total+ (Table3.FieldByName('I_PRIX').AsFloat*
              Table3.FieldByName('I_QUANTITE').AsFloat);
      Next;
    end;
  end;

  If l_prix_total> 1000
    then Abort;
end;

end.


