(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)

(* 001 u_md_cal *)

unit U_md_cal;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Edit1: TEdit;
    Table2I_NUM_FACT: TFloatField;
    Table2I_NUMERO: TFloatField;
    Table2I_LIBELLE: TStringField;
    Table2I_PRIX: TFloatField;
    Table2I_QUANTITE: TFloatField;
    Table1F_NUMERO: TFloatField;
    Table1F_CLIENT: TStringField;
    Table1F_TOTAL: TFloatField;
    Table3: TTable;
    Table1_total: TFloatField;
    procedure Table1CalcFields(DataSet: TDataset);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Table2AfterPost(DataSet: TDataset);
    procedure Table2I_QUANTITEValidate(Sender: TField);
    procedure Table2I_QUANTITEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table2BeforeEdit(DataSet: TDataset);
    procedure Table2BeforePost(DataSet: TDataset);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_prix_total: Double;
begin
  With Table2 do
  begin
    DisableControls;

    l_prix_total:= 0;
    First;
    While not Eof do
    begin
      l_prix_total:= l_prix_total+
        FieldByName('I_PRIX').AsFloat* FieldByName('I_QUANTITE').AsFloat;
      Next;
    end;
    First;
    EnableControls;
  end;

  Edit1.Text:= FloatToStr(l_prix_total);
end;

const vi_quantite_precedente: Integer= 0;
      vi_prix_precedent: Double= 0;

procedure TForm1.Table2BeforeEdit(DataSet: TDataset);
begin
  vi_quantite_precedente:= Table2I_QUANTITE.AsInteger;
  vi_prix_precedent:= Table2I_PRIX.AsFloat;
end;

procedure TForm1.Table2BeforePost(DataSet: TDataset);
var l_prix_total: Double;
begin
  l_prix_total:= StrToFloat(Edit1.Text);
  l_prix_total:= l_prix_total+ Table2I_Quantite.AsInteger* Table2I_PRIX.AsFloat
      - vi_quantite_precedente* vi_prix_precedent;
  Edit1.Text:= FloatToStr(l_prix_total);
end;

procedure TForm1.Table2I_QUANTITEGetText(Sender: TField;
  var Text: OpenString; DisplayText: Boolean);
begin
  Text:= Table2I_QUANTITE.AsString;
  if Text= ''
    then vi_quantite_precedente:= 0
    else vi_quantite_precedente:= StrToInt(Text);
end;

procedure TForm1.Table2I_QUANTITEValidate(Sender: TField);
var l_prix_total: Double;
begin
  l_prix_total:= StrToFloat(Edit1.Text);
  l_prix_total:= l_prix_total+ (Table2I_Quantite.AsInteger- vi_quantite_precedente)
      * Table2I_PRIX.AsFloat;
  Edit1.Text:= FloatToStr(l_prix_total);
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
var l_prix_total: Double;
begin
  With Table3 do
  begin
    (* -- DOIT faire Range car OnCalc intervient AVANT Range *)
    SetRange([Table1F_NUMERO.AsInteger], [Table1F_NUMERO.AsInteger]);
    First;

    l_prix_total:= 0;
    While not Eof do
    begin
      l_prix_total:= l_prix_total
          + FieldByName('II_PRIX').AsFloat* FieldByName('I_QUANTITE').AsFloat;

      Next;
    end; (* While *)
  end;

  Table1.FieldByName('_total').AsFloat:= l_prix_total;
end;

procedure TForm1.Table2AfterPost(DataSet: TDataset);
var l_signet: tBookMark;
    l_prix_total: Double;
begin
  With Table2 do
  begin
    DisableControls;

    l_signet:= Table2.GetBookMark;

    l_prix_total:= 0;
    First;
    While not Eof do
    begin
      l_prix_total:= l_prix_total+
          FieldByName('I_PRIX').AsFloat* FieldByName('I_QUANTITE').AsFloat;
      Next;
    end;

    Table1.Edit;
    Table1.FieldByName('F_TOTAL').AsFloat:= l_prix_total;
    Table1.Post;

    GotoBookMark(l_signet);
    FreeBookMark(l_signet);

    EnableControls;
  end; (* with Table2 *)
end;

end.





