(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_flufic *)

unit U_flufic;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    cree: TButton;
    libere: TButton;
    ecris: TButton;
    Edit1: TEdit;
    lis: TButton;
    repositionne: TButton;
    ListBox1: TListBox;
    ouvre_ecris: TButton;
    ouvre_lis: TButton;
    ouvre_lis_ecris: TButton;
    flux_mem_L_f_S: TButton;
    ListBox_S_t_S: TButton;
    procedure creeClick(Sender: TObject);
    procedure libereClick(Sender: TObject);
    procedure ecrisClick(Sender: TObject);
    procedure lisClick(Sender: TObject);
    procedure repositionneClick(Sender: TObject);
    procedure ListBox1_SaveToStreamClick(Sender: TObject);
    procedure ouvre_ecrisClick(Sender: TObject);
    procedure ouvre_lisClick(Sender: TObject);
    procedure ouvre_lis_ecrisClick(Sender: TObject);
    procedure flux_mem_L_f_SClick(Sender: TObject);
  private
    { Dclarations private }
    flux_memoire: tMemoryStream;
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const k_nom= 'aha';
var g_flux_fichier: tFileStream;

procedure affiche(p_message: String);
  var l_taille_position: String;
  begin
    if g_flux_fichier<> nil
      then Form1.ListBox1.Items.Add(
        Format('%-14s %6d %6d', [p_message, g_flux_fichier.Size, g_flux_fichier.Position]))
      else Form1.ListBox1.Items.Add(p_message);
  end; (* affiche *)

procedure TForm1.creeClick(Sender: TObject);
begin
  g_flux_fichier:= tFileStream.Create(k_nom, fmCreate);
  affiche('Create');
end;

procedure TForm1.ouvre_ecrisClick(Sender: TObject);
begin
  g_flux_fichier:= tFileStream.Create(k_nom, fmOpenWrite);
  affiche('Create fmW');
end;

procedure TForm1.ouvre_lisClick(Sender: TObject);
begin
  g_flux_fichier:= tFileStream.Create(k_nom, fmOpenRead);
  affiche('Create fmR');
end;

procedure TForm1.ouvre_lis_ecrisClick(Sender: TObject);
begin
  g_flux_fichier:= tFileStream.Create(k_nom, fmOpenReadWrite);
  affiche('Create fmRW');
end;

procedure TForm1.ecrisClick(Sender: TObject);
var l_texte: String;
begin
  l_texte:= Edit1.Text+ chr(13)+ chr(10);
  g_flux_fichier.Write(l_texte[1], Length(l_texte));
  affiche('ecris');
end;

procedure TForm1.repositionneClick(Sender: TObject);
begin
  g_flux_fichier.Position:= 0;
  affiche('reposition');
end;

procedure TForm1.lisClick(Sender: TObject);
var l_texte: String;
    l_caractere: Char;
    l_fini: Boolean;
begin
  l_fini:= False; l_texte:= '';
  While not l_fini and (g_flux_fichier.Position< g_flux_fichier.Size) do
  begin
    g_flux_fichier.Read(l_caractere, 1);
    if l_caractere= chr(13)
      then begin
          l_fini:= true;
          g_flux_fichier.Read(l_caractere, 1);
        end
      else l_texte:= l_texte+ l_caractere;
  end;

  affiche('lis >'+ l_texte+ '<');
end;

procedure TForm1.libereClick(Sender: TObject);
begin
  g_flux_fichier.Free;
  g_flux_fichier:= nil;
  affiche('Free');
end;

procedure TForm1.ListBox1_SaveToStreamClick(Sender: TObject);
begin
  ListBox1.Items.SaveToStream(g_flux_fichier);
  affiche('L_Save_T_S');
end;

procedure TForm1.flux_mem_L_f_SClick(Sender: TObject);
var l_flux_memoire: tMemoryStream;
begin
  l_flux_memoire:= tMemoryStream.Create;
  l_flux_memoire.LoadFromStream(g_flux_fichier);
  ListBox1.Items.LoadFromStream(l_flux_memoire);
  affiche(IntToStr(l_flux_memoire.Size));
  l_flux_memoire.Free;
end;

end.
