(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_flumem *)

unit U_flumem;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    cree: TButton;
    libere: TButton;
    ecris: TButton;
    Edit1: TEdit;
    SetSize_: TButton;
    lis: TButton;
    repositionne: TButton;
    ListBox1_SaveToStream: TButton;
    Memo1: TMemo;
    Memo2_LoadFromStream: TButton;
    ListBox1: TListBox;
    ecris_100_K: TButton;
    lis_100_K: TButton;
    SaveToStream_: TButton;
    SaveToFile_: TButton;
    copie_: TButton;
    procedure creeClick(Sender: TObject);
    procedure libereClick(Sender: TObject);
    procedure ecrisClick(Sender: TObject);
    procedure SetSize_Click(Sender: TObject);
    procedure lisClick(Sender: TObject);
    procedure repositionneClick(Sender: TObject);
    procedure ListBox1_SaveToStreamClick(Sender: TObject);
    procedure Memo2_LoadFromStreamClick(Sender: TObject);
    procedure ecris_100_KClick(Sender: TObject);
    procedure lis_100_KClick(Sender: TObject);
    procedure SaveToStream_Click(Sender: TObject);
    procedure SaveToFile_Click(Sender: TObject);
    procedure copie_Click(Sender: TObject);
  private
    { Dclarations private }
    flux_memoire: tMemoryStream;
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var g_flux_memoire: tMemoryStream;

procedure affiche(p_message: String);
  var l_taille_position: String;
  begin
    if g_flux_memoire<> nil
      then Form1.ListBox1.Items.Add(
        Format('%-10s %5s %6d %6d', [p_message, FloatToStrF(GetFreeSpace(0) div 1024, ffFixed, 10, 0),
          g_flux_memoire.Size, g_flux_memoire.Position]))
      else Form1.ListBox1.Items.Add(
        Format('%-10s %5s ', [p_message, FloatToStrF(GetFreeSpace(0) div 1024, ffFixed, 10, 0)]) );
  end; (* affiche *)

procedure TForm1.creeClick(Sender: TObject);
begin
  g_flux_memoire:= tMemoryStream.Create;
  affiche('Create');
end;

procedure TForm1.SetSize_Click(Sender: TObject);
begin
  g_flux_memoire.SetSize(100000);
  affiche('SetSize');
end;

procedure TForm1.ecrisClick(Sender: TObject);
var l_texte: String;
begin
  l_texte:= Edit1.Text;
  g_flux_memoire.Write(l_texte, 1+ Length(l_texte));
  affiche('ecris');
end;

procedure TForm1.repositionneClick(Sender: TObject);
begin
{
  g_flux_memoire.Seek(0, 0);
}
  g_flux_memoire.Position:= 0;
  affiche('reposition');
end;

procedure TForm1.lisClick(Sender: TObject);
var l_texte: String;
    l_taille: Byte;
begin
  g_flux_memoire.Read(l_taille, 1);
  g_flux_memoire.Read(l_texte[1], l_taille);
  l_texte[0]:= chr(l_taille);

  affiche('lis '+ l_texte);
end;

procedure TForm1.libereClick(Sender: TObject);
begin
  g_flux_memoire.Free;
  g_flux_memoire:= nil;
  affiche('Free');
end;

procedure TForm1.ListBox1_SaveToStreamClick(Sender: TObject);
begin
  ListBox1.Items.SaveToStream(g_flux_memoire);
  affiche('L_Save_T_S');
end;

procedure TForm1.Memo2_LoadFromStreamClick(Sender: TObject);
begin
  Memo1.Lines.LoadFromStream(g_flux_memoire);
  affiche('L_Load_F_S');
end;

procedure TForm1.ecris_100_KClick(Sender: TObject);
var l_indice: LongInt;
begin
  For l_indice:= 0 to 99999 div 4 do
    g_flux_memoire.Write(l_indice, 4);
  affiche('cris 100');
end;

procedure TForm1.lis_100_KClick(Sender: TObject);
var l_indice, l_valeur: LongInt;
begin
  For l_indice:= 0 to 99999 div 4 do
  begin
    g_flux_memoire.Read(l_valeur, 4);
    if l_valeur<> l_indice
      then begin
          ShowMessage('pb');
          Abort;
        end;
  end;
  affiche('lis 100');
end;

procedure TForm1.SaveToStream_Click(Sender: TObject);
var l_flux_memoire: tMemoryStream;
begin
  l_flux_memoire:= tMemoryStream.Create;
  g_flux_memoire.SaveToStream(l_flux_memoire);
  affiche(IntToStr(l_flux_memoire.Size));
  l_flux_memoire.Free;
end;

procedure TForm1.SaveToFile_Click(Sender: TObject);
begin
  g_flux_memoire.SaveToFile('aha');
end;

procedure TForm1.copie_Click(Sender: TObject);
const k_max= 1000;
var l_flux_memoire: tMemoryStream;
    l_tampon: array[0..k_max] of Byte;
    l_a_transferer, l_quantite: LongInt;
begin
  l_flux_memoire:= tMemoryStream.Create;

  g_flux_memoire.Position:= 20000;

  l_a_transferer:= StrToInt(Edit1.Text);
  while l_a_transferer<> 0 do
  begin
    l_quantite:= l_a_transferer;
    if l_quantite> k_max
      then l_quantite:= k_max;

    g_flux_memoire.Read(l_tampon, l_quantite);
    l_flux_memoire.Write(l_tampon, l_quantite);

    l_a_transferer:= l_a_transferer- l_quantite;
  end;

  affiche(IntToStr(l_flux_memoire.Size));
  l_flux_memoire.Free;
end;

end.
