(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_g10 *)

unit U_db_g10;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1GRAND: TBooleanField;
    Memo1: TMemo;
    dgTabs_T: TButton;
    Table1POIDS: TFloatField;
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure dgTabs_TClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1Enter(Sender: TObject);
  private
    { Dclarations private }
    procedure list_box_on_exit(Sender: TObject);
    procedure list_box_on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure db_edit_on_exit(Sender: TObject);
    procedure db_edit_on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure db_edit_on_key_press(Sender: TObject; var Key: Char);

    procedure db_combo_box_on_exit(Sender: TObject);
    procedure db_combo_box_on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure db_combo_box_on_key_press(Sender: TObject; var Key: Char);

    procedure db_grille_on_mouse_up(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function f_etats_db_grille(p_etats: tGridDrawState): String;
  var l_texte: String;
  begin
    if gdSelected in p_etats
      then l_texte:= 'gdSelected '
      else l_texte:= '';

    if gdFocused in p_etats
      then l_texte:= l_texte+ 'gdFocused ';
    if gdFixed in p_etats
      then l_texte:= l_texte+ 'gdFided';

    Result:= l_texte;
  end;

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_grille(p_x, p_y: Integer; p_etat: tGridDrawState);
  begin
    with Form1 do
      affiche('('+ IntToStr(tDrawGrid(dbGrid1).Col)+ ','+ IntToStr(tDrawGrid(dbGrid1).Row)
          + ') ('+ IntToStr(p_x)+ ','+ IntToStr(p_y)+ ') '+ f_etats_db_grille(p_etat));
  end;

function f_code_virtuel(p_code: Word): String;
  begin
    case p_code of
      vk_Right : result:= 'vk_Right';
      vk_Left : result:= 'vk_Left';

      vk_Up : result:= 'vk_Up';
      vk_Down : result:= 'vk_Down';

      vk_Prior : result:= 'vk_Prior';
      vk_Next : result:= 'vk_Next';

      vk_Shift : result:= 'vk_Shift';

      vk_Insert : Result:= 'vk_Insert';

      vk_tab : result:= 'vk_tab';
      vk_Return : result:= 'vk_Return';

      Ord('A')..Ord('Z') : Result:= 'vk_'+ chr(p_code);

      else Result:= 'vk_'+ IntToStr(p_code);
    end;
  end; (* f_code_virtuel *)

function f_caractere(p_caractere: Char): String;
  begin
    case p_caractere of
      #8 : Result:= 'Eff';
      #9 : Result:= 'Tab';
      #13 : Result:= 'Return';
      #27 : Result:= 'Esc';

      #0..#7, #10..#12, #14..#26, #28..#31 : Result:= IntToStr(Ord(p_caractere));
      else Result:= p_caractere;
    end;
  end;

function f_booleen(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen:= 'vrai'
      else f_booleen:= 'faux';
  end;

(* -- appli *)

const vi_dg_tabs: Boolean= True;

procedure TForm1.dgTabs_TClick(Sender: TObject);
begin
  if dgTabs in dbGrid1.Options
    then begin
        dbGrid1.Options:= dbGrid1.Options- [dgTabs];
        vi_dg_tabs:= False;
        dgtabs_T.Caption:= 'dgTabs_F';
      end
    else begin
        dbGrid1.Options:= dbGrid1.Options+ [dgTabs];
        vi_dg_tabs:= True;
        dgtabs_T.Caption:= 'dgTabs_T';
      end
end;

procedure cellule_suivante(p_avance_recule: Boolean);
  begin
    with Form1, dbGrid1 do
      if p_avance_recule
        then SelectedIndex:= (SelectedIndex+ 1) mod FieldCount
        else SelectedIndex:= (SelectedIndex+ FieldCount- 1) mod FieldCount;

    affiche(IntToStr(Form1.dbGrid1.SelectedIndex)+ ' av '+ f_booleen(p_avance_recule)
      + ' t '+ f_booleen(vi_dg_tabs) );
  end;

(* -- un dbList sur NOM *)

  type t_list_box= Class(tListBox)
                     private
                       procedure wmGetDlgCode(var pv_message: tMessage); Message wm_GetDlgCode;
                   end;

  procedure t_list_box.wmGetDlgCode(var pv_message: tMessage);
    begin
      inherited;

      pv_message.Result:= pv_message.Result or dlgc_WantTab;
    end;

  var g_list_box: t_list_box;

  procedure TForm1.list_box_on_exit(Sender: TObject);
    begin
      g_list_box.Visible:= False;
    end;

  procedure TForm1.list_box_on_key_down(Sender: TObject; var Key: Word;
        Shift: TShiftState);
    begin
      if Key<> vk_Menu
        then affiche(f_code_virtuel(Key));

      case Key of
        vk_Right: begin
                    cellule_suivante(True);
                    dbGrid1.SetFocus;
                    Key:= 0;
                  end;
        vk_Left: begin
                   cellule_suivante(False);
                   dbGrid1.SetFocus;
                   Key:= 0;
                 end;

        vk_Prior: begin
                    Table1.Prior;
                    dbGrid1.SetFocus;
                    Key:= 0;
                  end;
        vk_Next: begin
                   Table1.Next;
                   dbGrid1.SetFocus;
                   Key:= 0;
                 end;

        vk_Tab : if vi_dg_tabs
                   then begin
                       if (ssShift in Shift)
                         then begin
                             cellule_suivante(False);
                             dbGrid1.SetFocus;
                             Key:= 0;
                           end
                         else begin
                             cellule_suivante(True);
                             dbGrid1.SetFocus;
                             Key:= 0;
                           end;
                     end
                   else begin
                       SelectNext(dbGrid1, not (ssShift in Shift), True);
                       Key:= 0;
                     end;
      end; (* case *)
    end;

  (* -- un dbEdit sur PRENOM *)

  type t_db_edit= Class(tdbEdit)
                    private
                      procedure wmGetDlgCode(var pv_message: tMessage); Message wm_GetDlgCode;
                  end;

  procedure t_db_edit.wmGetDlgCode(var pv_message: tMessage);
    begin
      inherited;

      pv_message.Result:= pv_message.Result or dlgc_WantArrows or dlgc_WantTab;
    end;

  var g_db_edit: t_db_edit;
      g_en_cours_saisie: Boolean;

  procedure TForm1.db_edit_on_exit(Sender: TObject);
    begin
      g_db_edit.Visible:= False;
    end;

  procedure TForm1.db_edit_on_key_down(Sender: TObject; var Key: Word;
        Shift: TShiftState);
    begin
      case Key of
        vk_F2 : if not g_en_cours_saisie
                  then begin
                      g_en_cours_saisie:= True;
                      g_db_edit.Color:= clWhite;
                      g_db_edit.SelectAll;
                    end;
        vk_Right: if not vi_dg_tabs or not g_en_cours_saisie
                    then begin
                        cellule_suivante(True);
                        dbGrid1.SetFocus;
                        Key:= 0;
                      end;
        vk_Left: if not vi_dg_tabs or not g_en_cours_saisie
                   then begin
                       cellule_suivante(False);
                       dbGrid1.SetFocus;
                       Key:= 0;
                     end;

        vk_Prior: begin
                    Table1.Prior;
                    dbGrid1.SetFocus;
                    Key:= 0;
                  end;
        vk_Next: begin
                   Table1.Next;
                   dbGrid1.SetFocus;
                   Key:= 0;
                 end;

        vk_Tab : if vi_dg_tabs
                   then
                     if (ssShift in Shift)
                       then begin
                           cellule_suivante(False);
                           dbGrid1.SetFocus;
                           Key:= 0;
                         end
                       else begin
                           cellule_suivante(True);
                           dbGrid1.SetFocus;
                           Key:= 0;
                         end
                     else begin
                         SelectNext(dbGrid1, not (ssShift in Shift), True);
                         Key:= 0;
                       end;
      end; (* case *)
    end;

  procedure TForm1.db_edit_on_key_press(Sender: TObject; var Key: Char);
  begin
    Case Key of
      chr(13) : begin
                  g_en_cours_saisie:= not g_en_cours_saisie;
                  if g_en_cours_saisie
                    then begin
                        g_db_edit.Color:= clWhite;
                        g_db_edit.SelectAll;
                      end
                    else begin
                        g_db_edit.Color:= clHighLight;
                        g_db_edit.SelLength:= 0;
                      end;
                end;
      else
        if not g_en_cours_saisie
          then Key:= chr(0);
    end; (* case  *)
  end;

  (* -- combo *)

  type t_db_combo_box= Class(tdbComboBox)
                         private
                           procedure wmGetDlgCode(var pv_message: tMessage); Message wm_GetDlgCode;
                       end;

  procedure t_db_combo_box.wmGetDlgCode(var pv_message: tMessage);
    begin
      inherited;

      pv_message.Result:= pv_message.Result or dlgc_WantArrows or dlgc_WantTab;
    end;

  var g_db_combo_box: t_db_combo_box;
      g_affiche_combo: Boolean;
      g_sortie_par_tab: Boolean;

  procedure TForm1.db_combo_box_on_exit(Sender: TObject);
    begin
      if not g_sortie_par_tab
        then g_db_combo_box.Visible:= False;
    end;

  procedure TForm1.db_combo_box_on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    begin
      if Key<> vk_Menu
        then affiche('Combo '+ f_code_virtuel(Key));

      case Key of
        vk_Prior: begin
                    Table1.Prior;
                    dbGrid1.SetFocus;
                    Key:= 0;
                  end;
        vk_Next: begin
                   Table1.Next;
                   dbGrid1.SetFocus;
                   Key:= 0;
                 end;

        vk_Tab : if vi_dg_tabs
                   then
                     if (ssShift in Shift)
                       then begin
                           cellule_suivante(False);
                           dbGrid1.SetFocus;
                           Key:= 0;
                         end
                       else begin
                           cellule_suivante(True);
                           dbGrid1.SetFocus;
                           Key:= 0;
                         end
                     else begin
                         g_sortie_par_tab:= True;
                         SelectNext(dbGrid1, not (ssShift in Shift), True);
                         Key:= 0;
                       end;
      end; (* case *)
    end;

  procedure TForm1.db_combo_box_on_key_press(Sender: TObject; var Key: Char);
    begin
      if key= chr(13)
        then begin
            if g_affiche_combo
              then begin
                  g_affiche_combo:= False;
                  g_db_combo_box.Visible:= False;
                  dbGrid1.SetFocus;
                  Key:= chr(0);
                end;
          end;
    end;

(* -- cration *)

procedure TForm1.FormCreate(Sender: TObject);
begin
  g_list_box:= t_list_box.Create(Self);

  with g_list_box do
  begin
    Parent:= Self;
    Visible:= False;
    Height:= 2* tDrawGrid(dbGrid1).RowHeights[1]+ 1; Width:= 100;

    OnExit:= list_box_on_exit;
    OnKeyDown:= list_box_on_key_down;
  end;

  g_db_edit:= t_db_edit.Create(Self);

  with g_db_edit do
  begin
    Parent:= Self;
    Visible:= False;

    BorderStyle:= bsNone;

    DataSource:= DataSource1;
    DataField:= 'POIDS';
{
    DataField:= 'NOM';
}
    OnExit:= db_edit_on_exit;
    OnKeyDown:= db_edit_on_key_down;
    OnKeyPress:= db_edit_on_key_press;
  end;

  g_db_combo_box:= t_db_combo_box.Create(Self);

  with g_db_combo_box do
  begin
    Parent:= Self;
    Visible:= False;
    Width:= 78;

    DataSource:= DataSource1;
{
    DataField:= 'GRAND';
}
    DataField:= 'NOM';

    OnExit:= db_combo_box_on_exit;
    OnKeyDown:= db_combo_box_on_key_down;
    OnKeyPress:= db_combo_box_on_key_press;
  end;
  g_affiche_combo:= False;

  tDrawGrid(dbGrid1).OnMouseUp:= db_grille_on_mouse_up;
end;

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var l_ligne, l_colonne: LongInt;
    l_rectangle: tRect;
begin
  tDrawGrid(dbGrid1).MouseToCell(Rect.Left, Rect.Top, l_colonne, l_ligne);
  affiche_grille(l_colonne, l_ligne, State);

  if gdFocused in state
    then
      if Field.FieldName= 'NOMs'
        then
          With g_list_box, Items do
            begin
              Left:= dbGrid1.Left+ Rect.Left+ 3;
              Top:= dbGrid1.Top+ Rect.Top+ 3;

              Clear;
              Add(Field.AsString);
              Add(Table1.FieldByName('PRENOM').AsString);
              Visible:= True;

              SetFocus;
            end
          else
            if Field.FieldName= 'POIDSs'
              then
                With g_db_edit do
                  begin
                    Left:= dbGrid1.Left+ Rect.Left+ 2;
                    Top:= dbGrid1.Top+ Rect.Top+ 2;
                    Width:= Rect.Right- Rect.Left- 1;
                    Height:= Rect.Bottom- Rect.Top- 2;

                    With Rect do
                    begin
                      SetRect(l_rectangle, 2, 2, Right- Left- 2, Bottom- Top- 2);
                      SendMessage(Handle, em_SetRectNp, 0, LongInt(@l_rectangle));
                    end;

                    Visible:= True;

                    if vi_dg_tabs
                      then begin
                          g_db_edit.Color:= clWhite;
                          g_en_cours_saisie:= true;
                        end
                      else begin
                          g_en_cours_saisie:= False;
                          g_db_edit.SelLength:= 0;
                          g_db_edit.Color:= clHighLight;
                        end;

                    SetFocus;
                  end
                else
{
                  if g_affiche_combo and (Field.FieldName= 'GRAND')
}
                  if g_affiche_combo and (Field.FieldName= 'NOM')
                    then
                      With g_db_combo_box, Items do
                        begin
                          affiche('active ');
                          Left:= dbGrid1.Left+ Rect.Left+ 1;
                          Top:= dbGrid1.Top+ Rect.Top+ 1;

                          Clear;
                          Add('Vrai');
                          Add('Faux');
                          Visible:= True;

                          SetFocus;
                          affiche('fin act Focus '+ f_booleen(dbGrid1.EditorMode));
                        end
end;

procedure TForm1.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  with dbGrid1 do
{
    if SelectedField.FieldName= 'GRAND'
}
    if SelectedField.FieldName= 'NOM'
      then
        case key of
          chr(13) : begin
                      g_affiche_combo:= true;
                      g_sortie_par_tab:= False;
                      Invalidate; Update;
                      Key:= chr(0);
                    end;
          ' '..#255 : begin
                        affiche('car Focus '+ f_booleen(dbGrid1.EditorMode));
                        dbGrid1.EditorMode:= False;
                        affiche('car Focus '+ f_booleen(dbGrid1.EditorMode));
                        g_affiche_combo:= true;
                        g_sortie_par_tab:= False;

                        g_db_combo_box.SelectAll;
                        SendMessage(g_db_combo_box.Handle, wm_Char, Ord(Key), 0);

                        dbGrid1.Invalidate; dbGrid1.Update;
                        affiche('fin inv Focus '+ f_booleen(dbGrid1.EditorMode));
                        Key:= chr(0);
                      end;
        end; (* case *)
end;

procedure TForm1.DBGrid1Enter(Sender: TObject);
begin
  if g_sortie_par_tab
    then g_db_combo_box.SetFocus;
end;

procedure tForm1.db_grille_on_mouse_up(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  begin
    if dbGrid1.SelectedField.FieldName= 'NOM'
      then begin
          if dbGrid1.EditorMode
            then begin
                affiche('clic '+ f_booleen(dbGrid1.EditorMode));
                dbGrid1.EditorMode:= False;
                g_affiche_combo:= true;
                g_sortie_par_tab:= False;

                g_db_combo_box.SelectAll;

                dbGrid1.Invalidate; dbGrid1.Update;
              end;
        end;
  end;

end.


