(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_gr2 *)

unit U_db_gr2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1GRAND: TBooleanField;
    ListBox1: TListBox;
    Memo1: TMemo;
    Table1POIDS: TFloatField;
    Table1NAISSANCE: TDateField;
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure DBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBGrid1ColEnter(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function f_etats_db_grille(p_etats: tGridDrawState): String;
  var l_texte: String;
  begin
    if gdSelected in p_etats
      then l_texte:= 'gdSelected '
      else l_texte:= '';

    if gdFocused in p_etats
      then l_texte:= l_texte+ 'gdFocused ';
    if gdFixed in p_etats
      then l_texte:= l_texte+ 'gdFided';

    Result:= l_texte;
  end;

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_grille(p_x, p_y: Integer; p_etat: tGridDrawState);
  begin
    with Form1 do
      affiche('('+ IntToStr(tDrawGrid(dbGrid1).Col)+ ','+ IntToStr(tDrawGrid(dbGrid1).Row)
          + ') ('+ IntToStr(p_x)+ ','+ IntToStr(p_y)+ ') '+ f_etats_db_grille(p_etat));
  end;

function f_code_virtuel(p_code: Word): String;
  begin
    case p_code of
      vk_Right : result:= 'vk_Right';
      vk_Left : result:= 'vk_Left';

      vk_Up : result:= 'vk_Up';
      vk_Down : result:= 'vk_Down';

      vk_Prior : result:= 'vk_Prior';
      vk_Next : result:= 'vk_Next';

      vk_Shift : result:= 'vk_Shift';

      vk_Insert : Result:= 'vk_Insert';

      vk_tab : result:= 'vk_tab';
      vk_Return : result:= 'vk_Return';

      Ord('A')..Ord('Z') : Result:= 'vk_'+ chr(p_code);

      else Result:= 'vk_'+ IntToStr(p_code);
    end;
  end; (* f_code_virtuel *)

function f_caractere(p_caractere: Char): String;
  begin
    case p_caractere of
      #8 : Result:= 'Eff';
      #9 : Result:= 'Tab';
      #13 : Result:= 'Return';
      #27 : Result:= 'Esc';

      #0..#7, #10..#12, #14..#26, #28..#31 : Result:= IntToStr(Ord(p_caractere));
      else Result:= p_caractere;
    end;
  end;

function f_booleen(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen:= 'vrai'
      else f_booleen:= 'faux';
  end;

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var l_ligne, l_colonne: LongInt;
begin
  tDrawGrid(dbGrid1).MouseToCell(Rect.Left, Rect.Top, l_colonne, l_ligne);
  affiche_grille(l_colonne, l_ligne, State);

  if gdFocused in state
    then begin
        if Field.FieldName= 'NOM'
          then begin
              With ListBox1, Items do
              begin
{
                Left:= dbGrid1.Left+ Rect.Left+ 3;
                Top:= dbGrid1.Top+ Rect.Top+ 3;
}
                Left:= dbGrid1.Left+ Rect.Left+ 1;
                Top:= dbGrid1.Top+ Rect.Top+ 1;
                Clear;
                Add(Field.AsString);
                Add(Table1.FieldByName('PRENOM').AsString);
                Add(Table1.FieldByName('NAISSANCE').AsString);
                Visible:= True;
              end
            end
          else ListBox1.Visible:= False;
      end;
end;

procedure TForm1.DBGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key<> vk_Menu
    then affiche(f_code_virtuel(Key));
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if Table1.State= dsBrowse
    then begin
        affiche('OnDataChange '+ '('+ IntToStr(tDrawGrid(dbGrid1).Col)+ ','+ IntToStr(tDrawGrid(dbGrid1).Row)+ ')');;
        ListBox1.Visible:= False;
      end;
end;

procedure TForm1.DBGrid1ColEnter(Sender: TObject);
begin
  affiche('OnColEnter '+ '('+ IntToStr(tDrawGrid(dbGrid1).Col)+ ','+ IntToStr(tDrawGrid(dbGrid1).Row)+ ')');;
  If tDrawGrid(dbGrid1).Col<> 2
    then ListBox1.Visible:= False;
end;

end.
