(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_gr6 *)

unit U_db_gr6;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    cree: TButton;
    Memo1: TMemo;
    Table1: TTable;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    MouseUp_: TButton;
    procedure creeClick(Sender: TObject);
    procedure Memo1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Memo1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure MouseUp_Click(Sender: TObject);
    procedure DBGrid1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DBGrid1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations private }
    procedure on_mouse_up(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
    procedure on_mouse_Down(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.on_mouse_up(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
  begin
    with tDrawGrid(dbGrid1), Memo1.Lines do
      Add('Up: X '+ IntToStr(X)+ ', Y: '+ IntToStr(Y)+ ', Row '+ IntToStr(Row)+ ', Col '+ IntToStr(Col));
  end;

procedure TForm1.MouseUp_Click(Sender: TObject);
begin
  tDrawGrid(dbGrid1).OnMouseUp:= on_mouse_up;
end;

procedure TForm1.on_mouse_down(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
  begin
    with tDrawGrid(dbGrid1), Memo1.Lines do
      Add('Down: X '+ IntToStr(X)+ ', Y: '+ IntToStr(Y)+ ', Row '+ IntToStr(Row)+ ', Col '+ IntToStr(Col)
          + ' '+ Sender.ClassName);

    If Sender is tdbGrid
      then
        with Sender As tdbGrid do
          BeginDrag(True)
      else
        if Sender is tInplaceEdit
          then
            With (Sender As tInplaceEdit) do
              Parent.BeginDrag(True);
  end;

  type t_dbgrille= Class(tdbGrid)
                     protected
                       procedure MouseDown(Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer); Override;
                   end;

procedure t_dbgrille.MouseDown(Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
  var l_on_mouse_down: tMouseEvent;
  begin
    Inherited MouseDown(Button, Shift, X, Y);

    l_on_mouse_down:= OnMouseDown;
    If Assigned(l_on_mouse_down)
      then OnMouseDown(Self, Button, Shift, X, Y);
  end;

var g_dbgrille: t_dbgrille;

procedure TForm1.creeClick(Sender: TObject);
var l_caractere: Word;
begin
  dbGrid1.Visible:= False;

  g_dbgrille:= t_dbgrille.Create(Self);

  with g_dbgrille do
  begin
    DataSource:= DataSource1;
    Parent:= Self;

    Left:= 10; Top:= 10; Height:= 80;

    OnMouseUp:= Form1.on_mouse_up;

    SetFocus;
    ShowEditor;
    HideEditor;
    if InplaceEditor= nil
      then Memo1.Lines.Add('NIL')
      else tMaskEdit(InPlaceEditor).OnMouseUp:= Form1.on_mouse_up;

    OnMouseDown:= Form1.on_mouse_down;
    tMaskEdit(InPlaceEditor).OnMouseDown:= Form1.on_mouse_down;
  end;
end;

procedure TForm1.Memo1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept:= True;
end;

procedure TForm1.Memo1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  With Source as t_dbGrille do
    Memo1.Lines.Add(SelectedField.AsString);
end;

(* -- Memo -> Grid *)

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Memo1.BeginDrag(True);
end;

procedure TForm1.DBGrid1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept:= True;
end;

procedure TForm1.DBGrid1DragDrop(Sender, Source: TObject; X, Y: Integer);
var l_numero_ligne: Integer;
    l_texte: String;
    l_colonne, l_ligne: LongInt;
begin
  l_numero_ligne:= (Source as tMemo).Perform(em_LineFromChar, $FFFF, 0);
  l_texte:= (Source as tMemo).Lines[l_numero_ligne];

  tDrawGrid(dbGrid1).MouseToCell(X, Y, l_colonne, l_ligne);

  if not (dsEdit= Table1.State)
    then Table1.Edit;
  dbGrid1.Fields[l_colonne- 1].AsString:= l_texte;
  Table1.Post;
end;

end.


