(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_gr7 *)

unit U_db_gr7;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    TabStops_NOM_T: TButton;
    dbGrid1: TDBGrid;
    ReadOnly_F: TButton;
    dgEditing_T: TButton;
    dgAlwaysShowEditor_F: TButton;
    dgTabs_T: TButton;
    Entree_F: TButton;
    Maj_Entree_F: TButton;
    PRENOM_7: TButton;
    Memo1: TMemo;
    cree: TButton;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1POIDS: TFloatField;
    procedure dbGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure dbGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ReadOnly_FClick(Sender: TObject);
    procedure dgEditing_TClick(Sender: TObject);
    procedure dgAlwaysShowEditor_FClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TabStops_NOM_TClick(Sender: TObject);
    procedure dgTabs_TClick(Sender: TObject);
    procedure Entree_FClick(Sender: TObject);
    procedure Maj_Entree_FClick(Sender: TObject);
    procedure PRENOM_7Click(Sender: TObject);
    procedure creeClick(Sender: TObject);
    procedure dbGrid1ColEnter(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure dbGrid1Enter(Sender: TObject);
  private
    { Dclarations private }
    procedure change_caption;
    procedure on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure on_key_press(Sender: TObject; var Key: Char);
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tForm1.change_caption;
  begin
    dbGrid1.Invalidate;
    dbGrid1.Update;

    If dbGrid1.ReadOnly
      then ReadOnly_F.Caption:= 'ReadOnly_T'
      else ReadOnly_F.Caption:= 'ReadOnly_F';
    if dgEditing in dbGrid1.Options
      then dgEditing_T.Caption:= 'dgEditing_T'
      else dgEditing_T.Caption:= 'dgEditing_F';
    if dgAlwaysShowEditor in dbGrid1.Options
      then dgAlwaysShowEditor_F.Caption:= 'dgAlwaysShowEditor_T'
      else dgAlwaysShowEditor_F.Caption:= 'dgAlwaysShowEditor_F';
    if dgTabs in dbGrid1.Options
      then dgTabs_T.Caption:= 'dgTabs_T'
      else dgTabs_T.Caption:= 'dgTabs_F';
    if tDrawGrid(dbGrid1).TabStops[2]
      then TabStops_NOM_T.Caption:= 'TabStops_NOM_T'
      else TabStops_NOM_T.Caption:= 'TabStops_NOM_F';
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
  change_caption;
end;

procedure TForm1.ReadOnly_FClick(Sender: TObject);
begin
  dbGrid1.ReadOnly:= Not dbGrid1.ReadOnly;
  change_caption;
end;

procedure TForm1.dgEditing_TClick(Sender: TObject);
begin
  if dgEditing in dbGrid1.Options
    then dbGrid1.Options:= dbGrid1.Options- [dgEditing]
    else dbGrid1.Options:= dbGrid1.Options+ [dgEditing];
  change_caption;
end;

procedure TForm1.dgAlwaysShowEditor_FClick(Sender: TObject);
begin
  if dgAlwaysShowEditor in dbGrid1.Options
    then dbGrid1.Options:= dbGrid1.Options- [dgAlwaysShowEditor]
    else dbGrid1.Options:= dbGrid1.Options+ [dgAlwaysShowEditor];
  change_caption;
end;

procedure TForm1.dgTabs_TClick(Sender: TObject);
begin
  if dgTabs in dbGrid1.Options
    then dbGrid1.Options:= dbGrid1.Options- [dgTabs]
    else dbGrid1.Options:= dbGrid1.Options+ [dgTabs];
  change_caption;
end;

procedure TForm1.TabStops_NOM_TClick(Sender: TObject);
begin
  With tDrawGrid(dbGrid1) do
    TabStops[2]:= Not TabStops[2];
  change_caption;
end;

procedure TForm1.Entree_FClick(Sender: TObject);
begin
  If Entree_F.Caption= 'Entree_F'
    then Entree_F.Caption:= 'Entree_T'
    else Entree_F.Caption:= 'Entree_F';
end;

procedure TForm1.dbGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  If Entree_F.Caption= 'Entree_T'
    then
      If Key= Chr(13)
        then begin
            dbGrid1.SelectedIndex:= (dbGrid1.SelectedIndex+ 1) mod dbGrid1.FieldCount;
            Key:= chr(0);
          end;

  If (PRENOM_7.Caption= 'PRENOM_1') and (dbGrid1.SelectedIndex= 2)
      and (Key in [' '..#255])
    then begin
        If Table1.State<> dsEdit
          then Table1.Edit;
        Table1.FieldByName('PRENOM').AsString:= Key;

        Key:= chr(0);
        dbGrid1.SelectedIndex:= (dbGrid1.SelectedIndex+ 1) mod dbGrid1.FieldCount;
      end;
end;

procedure TForm1.Maj_Entree_FClick(Sender: TObject);
begin
  If Maj_Entree_F.Caption= 'Maj_Entree_F'
    then Maj_Entree_F.Caption:= 'Maj_Entree_T'
    else Maj_Entree_F.Caption:= 'Maj_Entree_F';
end;

procedure TForm1.dbGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{
  if Key= vk_Tab
    then begin
        SelectNext(dbGrid1, not (ssShift in Shift), True);
        Key:= 0;
      end;
}
  If Maj_Entree_F.Caption= 'Maj_Entree_T'
    then
      if Key= vk_Return
        then begin
            if ssShift in Shift
              then dbGrid1.SelectedIndex:= (dbGrid1.SelectedIndex+ dbGrid1.FieldCount- 1) mod dbGrid1.FieldCount
              else dbGrid1.SelectedIndex:= (dbGrid1.SelectedIndex+ 1) mod dbGrid1.FieldCount;
            Key:= 0;
          end;
end;

procedure TForm1.dbGrid1ColEnter(Sender: TObject);
begin
  Memo1.Lines.Add('ColEnter: '+ dbGrid1.SelectedField.AsString);
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_champ: tField;
begin
  if ActiveControl= dbGrid1
    then Memo1.Lines.Add('DataChange: '+ dbGrid1.SelectedField.AsString);
end;

procedure TForm1.dbGrid1Enter(Sender: TObject);
begin
  Memo1.Lines.Add('Enter: '+ dbGrid1.SelectedField.AsString);
end;

  type t_dbgrille= Class(tdbGrid)
                     protected
                       procedure MouseDown(Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer); Override;
                       procedure KeyPress(var Key: Char); Override;
                   end;

procedure t_dbgrille.MouseDown(Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
  var l_on_mouse_down: tMouseEvent;
  begin
    Inherited MouseDown(Button, Shift, X, Y);

    l_on_mouse_down:= OnMouseDown;
    If Assigned(l_on_mouse_down)
      then OnMouseDown(Self, Button, Shift, X, Y);

    if EditorMode
      then Form1.Memo1.Lines.Add('focus (via souris)');
  end;

procedure t_dbgrille.KeyPress(var Key: Char);
  begin
    Inherited KeyPress(Key);

    if EditorMode
      then Form1.Memo1.Lines.Add('focus (via clavier)');
  end;

var g_dbgrille: t_dbgrille;

procedure TForm1.on_key_press(Sender: TObject; var Key: Char);
  begin
    with g_dbgrille do
      if EditorMode and (SelectedIndex= 2)
        then begin
            If (InplaceEditor.SelStart= 0) and (Key in ['a'..'z'])
              then Key:= Upcase(Key);
          end;
  end;

procedure TForm1.on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  begin
{
    With Memo1.Lines, tMaskEdit(g_dbgrille.InplaceEditor) do
      Add('SelStart '+ IntToStr(SelStart));
}
  end;

procedure TForm1.creeClick(Sender: TObject);
var l_caractere: Word;
begin
  dbGrid1.Visible:= False;

  g_dbgrille:= t_dbgrille.Create(Self);

  with g_dbgrille do
  begin
    DataSource:= DataSource1;
    Parent:= Self;

    Left:= 10; Top:= 10; Height:= 80;

    SetFocus;
    ShowEditor;
    HideEditor;
  end;

  g_dbgrille.OnKeyPress:= on_key_press;
  g_dbgrille.OnKeyDown:= on_key_down;
end;

procedure TForm1.PRENOM_7Click(Sender: TObject);
begin
  If PRENOM_7.Caption= 'PRENOM_7'
    Then PRENOM_7.Caption:= 'PRENOM_1'
    else PRENOM_7.Caption:= 'PRENOM_7';
end;

end.


