(* 001 u_db_gr9 *)

unit U_db_gr9;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table32: TTable;
    DataSource32: TDataSource;
    DBGrid2: TDBGrid;
    Table1F_NUMERO: TFloatField;
    Table1F_CLIENT: TStringField;
    Table32I_NUM_FACT: TFloatField;
    Table32I_NUMERO: TFloatField;
    Table32I_LIBELLE: TStringField;
    Table32I_CODE: TFloatField;
    Table32I_PRIX: TFloatField;
    Table32I_QUANTITE: TFloatField;
    Memo1: TMemo;
    Table1_DIALOGUE: TStringField;
    DBEdit1: TDBEdit;
    Table22: TTable;
    DataSource2: TDataSource;
    Table22NOM: TStringField;
    Table22PRENOM: TStringField;
    Table1_PRENOM: TStringField;
    Table21: TTable;
    Table1_PRIX1: TFloatField;
    Table1_PRIX2: TFloatField;
    Table31: TTable;
    DBEdit2: TDBEdit;
    DataSource31: TDataSource;
    Table1_PRIX_TOTAL: TFloatField;
    Table31I_NUM_FACT: TFloatField;
    Table31I_NUMERO: TFloatField;
    Table31I_LIBELLE: TStringField;
    Table31I_CODE: TFloatField;
    Table31I_PRIX: TFloatField;
    Table31I_QUANTITE: TFloatField;
    Button1: TButton;
    DBGrid1: TDBGrid;
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid2Exit(Sender: TObject);
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure Table1CalcFields(DataSet: TDataset);
    procedure DBEdit1Exit(Sender: TObject);
    procedure DBEdit2Exit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses u_db_g12;

{$R *.DFM}

function f_etats_db_grille(p_etats: tGridDrawState): String;
  var l_texte: String;
  begin
    if gdSelected in p_etats
      then l_texte:= 'gdSelected '
      else l_texte:= '';

    if gdFocused in p_etats
      then l_texte:= l_texte+ 'gdFocused ';
    if gdFixed in p_etats
      then l_texte:= l_texte+ 'gdFided';

    Result:= l_texte;
  end;

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_grille(p_x, p_y: Integer; p_etat: tGridDrawState);
  begin
    with Form1 do
      affiche('('+ IntToStr(tDrawGrid(dbGrid1).Col)+ ','+ IntToStr(tDrawGrid(dbGrid1).Row)
          + ') ('+ IntToStr(p_x)+ ','+ IntToStr(p_y)+ ') '+ f_etats_db_grille(p_etat));
  end;

function f_code_virtuel(p_code: Word): String;
  begin
    case p_code of
      vk_Right : result:= 'vk_Right';
      vk_Left : result:= 'vk_Left';

      vk_Up : result:= 'vk_Up';
      vk_Down : result:= 'vk_Down';

      vk_Prior : result:= 'vk_Prior';
      vk_Next : result:= 'vk_Next';

      vk_Shift : result:= 'vk_Shift';

      vk_Insert : Result:= 'vk_Insert';

      vk_tab : result:= 'vk_tab';
      vk_Return : result:= 'vk_Return';

      Ord('A')..Ord('Z') : Result:= 'vk_'+ chr(p_code);

      else Result:= 'vk_'+ IntToStr(p_code);
    end;
  end; (* f_code_virtuel *)

function f_caractere(p_caractere: Char): String;
  begin
    case p_caractere of
      #8 : Result:= 'Eff';
      #9 : Result:= 'Tab';
      #13 : Result:= 'Return';
      #27 : Result:= 'Esc';

      #0..#7, #10..#12, #14..#26, #28..#31 : Result:= IntToStr(Ord(p_caractere));
      else Result:= p_caractere;
    end;
  end;

function f_booleen(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen:= 'vrai'
      else f_booleen:= 'faux';
  end;

(* -- stop sur Tab *)

procedure TForm1.Button1Click(Sender: TObject);
var l_indice: Integer;
begin
  affiche(IntToStr(dbGrid2.Font.Size)
    + ' '+ IntToStr(tDrawGrid(dbGrid1).RowHeights[1]) );

  For l_indice:= 0 to dbGrid1.FieldCount- 1 do
    if dbGrid1.Fields[l_indice].Calculated
      then tDrawGrid(dbGrid1).TabStops[l_indice]:= True;
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
var l_total: Double;
begin
  (* -- calcule le PRENOM *)
  Table21.SetKey;
  Table21.FieldByName('NOM').AsString:= Table1F_CLIENT.AsString;
  If Table21.GotoKey
    then Table1_PRENOM.AsString:= Table21.FieldByName('PRENOM').AsString
    else Table1_PRENOM.AsString:= '?';

  (* -- calcule les PRIX *)
  Table31.SetKey;
  Table31.FieldByName('I_NUM_FACT').AsInteger:= Table1F_NUMERO.AsInteger;
  If Table31.GotoKey
    then begin
        Table1_PRIX1.AsString:= Table31.FieldByName('I_PRIX').AsString;
        Table31.Next;
        if not Table31.Eof
          then Table1_PRIX2.AsString:= Table31.FieldByName('I_PRIX').AsString
          else Table1_PRIX2.AsString:= '';
      end
    else begin
        Table1_PRIX1.AsString:= '';
        Table1_PRIX2.AsString:= '';
      end;

  (* -- calcule le PRIX_TOTAL *)
  l_total:= 0;
  Table31.SetRange([Table1F_NUMERO.AsInteger], [Table1F_NUMERO.AsInteger]);
  Table31.First;
  While Not Table31.Eof do
  begin
    l_total:= l_total+ Table31I_QUANTITE.AsFloat* Table31I_PRIX.AsFloat;
    Table31.Next;
  end;

  Table1_PRIX_TOTAL.AsFloat:= l_total;

  (* -- pour pouvoir calculer _PRIX *)
  Table31.CancelRange;
end;

procedure TForm1.DBGrid1KeyPress(Sender: TObject; var Key: Char);
var l_total: String;
    l_position: Integer;
begin
  if Key= Chr(13)
    then begin
        affiche('Ret');

        with dbGrid1.SelectedField do
        begin
          if FieldName= '_PRENOM'
            then begin
                With tDrawGrid(dbGrid1), CellRect(Col, Row) do
                begin
                  affiche('_PRENOM '+ IntToStr(Col)+ ' '+ IntToStr(Left)+ ' '+ IntToStr(Top));
                  dbEdit1.Left:= dbGrid1.Left+ Left+ 1;
                  dbEdit1.Top:= dbGrid1.Top+ Top+ 1;

                  dbEdit1.Visible:= true;
                  dbEdit1.SetFocus;
                end;
              end;

          if FieldName= '_PRIX1'
            then begin
                affiche('_PRIX1 '+ Table1F_NUMERO.AsString);

                With tDrawGrid(dbGrid1), CellRect(Col, Row) do
                begin
                  Table31.SetKey;
                  Table31.FieldByName('I_NUM_FACT').AsInteger:= Table1F_NUMERO.AsInteger;

                  If Table31.GotoKey
                    then begin
                        dbEdit2.DataSource:= DataSource31;
                        dbEdit2.DataField:= 'I_PRIX';
                        dbEdit2.Left:= dbGrid1.Left+ Left+ 1;
                        dbEdit2.Top:= dbGrid1.Top+ Top+ 1;

                        dbEdit2.Visible:= true;
                        dbEdit2.SetFocus;
                      end
                    else affiche('NOK');
                end;
              end;

          if (FieldName= '_PRIX2') and not dbGrid1.SelectedField.IsNull
            then begin
                With tDrawGrid(dbGrid1), CellRect(Col, Row) do
                begin
                  Table31.CancelRange;
                  Table31.SetKey;
                  Table31.FieldByName('I_NUM_FACT').AsInteger:= Table1F_NUMERO.AsInteger;

                  If Table31.GotoKey
                    then begin
                        Table31.Next;

                        dbEdit2.DataSource:= DataSource31;
                        dbEdit2.DataField:= 'I_PRIX';
                        dbEdit2.Left:= dbGrid1.Left+ Left+ 1;
                        dbEdit2.Top:= dbGrid1.Top+ Top+ 1;

                        dbEdit2.Visible:= true;
                        dbEdit2.SetFocus;
                      end;
                end;
              end;

          if FieldName= '_PRIX_TOTAL'
            then begin
                With tDrawGrid(dbGrid1), CellRect(Col, Row) do
                begin
                  (* rcurse
                  dbGrid2.Invalidate; dbGrid2.Update;
                  *)

                  dbGrid2.Options:= dbGrid2.Options- [dgTitles];
                  dbGrid2.Height:= 2* RowHeights[0]+ 1;
                  dbGrid2.Width:= tDrawGrid(dbGrid2).GridWidth+ 20+ 1;
                  dbGrid2.Left:= dbGrid1.Left+ Left+ 3;
                  dbGrid2.Top:= dbGrid1.Top+ Top+ 3;

                  ColWidths[6]:= dbGrid2.Width+ 4;
                  (* -- APRES ColWidths *)
                  RowHeights[Row]:= 3* RowHeights[0]+ 6;

                  dbGrid2.Visible:= True;
                  dbGrid2.SetFocus;
                  (* -- forcer Paint immdiat *)
                  dbGrid1.Invalidate; dbGrid1.Update;

                  l_total:= Table1_PRIX_TOTAL.AsString;
                  l_position:= ColWidths[6]- Canvas.TextWidth(l_total)- 2;
                  With dbGrid1.Canvas Do
                  begin
                    TextOut(Left+ l_position, Top+ 2* (RowHeights[0]+ 1)+ 2+6, Table1_PRIX_TOTAL.AsString);
                  end;

                  affiche('Ret '+ IntToStr(Left)+ ' '+ IntToStr(Top) );
                end;
              end;

          if FieldName= '_DIALOGUE'
            then begin
                Form2.DataSource1.DataSet:= Table22;
                Form2.ShowModal;
              end
        end;
        Key:= chr(0);
      end;
end;

procedure TForm1.DBEdit1Exit(Sender: TObject);
begin
  dbEdit1.Visible:= False;
  dbGrid1.SetFocus;
  SendMessage(dbGrid1.Handle, wm_KeyDown, vk_Right, 0);
end;

procedure TForm1.DBEdit2Exit(Sender: TObject);
begin
  affiche('Exit');
  dbEdit2.Visible:= False;
  dbGrid1.SetFocus;
  SendMessage(dbGrid1.Handle, wm_KeyDown, vk_Right, 0);
end;

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
begin
  if (gdFocused in State) and (Field.FieldName= 'QUANTITE_PRIX')
    then begin
        affiche('OnDraw ');
        dbGrid1.Canvas.FillRect(Rect);

        With dbGrid1.Canvas, Rect Do
        begin

          TextOut(Left+ 2, 2+ Bottom- dbGrid1.Font.Size- 8, Table1_PRIX_TOTAL.AsString);

        end;
     end;

  if not (gdFocused in State) and (Field.FieldName= 'QUANTITE_PRIX')
    then begin
        affiche('OnDraw Not '+ IntToStr(dbGrid2.Font.Size));
        With dbGrid1.Canvas, Rect Do
        begin
{
          TextOut(Left+ 2+ 15, - 8+ 2+ Bottom- dbGrid1.Font.Size, Table1_PRIX_TOTAL.AsString);
}
        end;
      end;
end;

procedure TForm1.DBGrid2Exit(Sender: TObject);
begin
  dbGrid2.Visible:= False;
  dbGrid1.SetFocus;
  dbGrid1.SelectedIndex:= 1;
  With tDrawGrid(dbGrid1) do
    RowHeights[Row]:= RowHeights[0];
end;

end.


