(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_lis *)

unit U_db_lis;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBListBox1: TDBListBox;
    Sorted_: TButton;
    Query1: TQuery;
    Memo1: TMemo;
    cree_index: TButton;
    charge: TButton;
    charge2: TButton;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    charge_Sql: TButton;
    Columns_: TButton;
    OwnerDraw_: TButton;
    Edit1: TEdit;
    Edit2: TEdit;

    procedure Sorted_Click(Sender: TObject);
    procedure DBListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure DBListBox1Click(Sender: TObject);
    procedure DBListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure DBListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cree_indexClick(Sender: TObject);
    procedure chargeClick(Sender: TObject);
    procedure charge2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure charge_SqlClick(Sender: TObject);
    procedure Columns_Click(Sender: TObject);
    procedure OwnerDraw_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure triClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.cree_indexClick(Sender: TObject);
begin
  Table1.Close;
  Table1.AddIndex('IND_PRETRI', 'PRENOM', [ixUnique]);
  Table1.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ChargeClick(nil);
end;

procedure TForm1.chargeClick(Sender: TObject);
begin
  Table1.IndexName:= 'IND_PRETRI';
  Table1.First;
  dbListBox1.Clear;
  While not Table1.Eof do
  begin
    dbListBox1.Items.Add(Table1.FieldByName('PRENOM').AsString);
    Table1.Next;
  end;
  Table1.IndexName:= '';
end;

procedure TForm1.triClick(Sender: TObject);
var l_chaines: tStringList;
begin
  l_chaines:= tStringList.Create;
  l_chaines.Assign(dbListBox1.Items);
  l_chaines.Sorted:= True;
  dbListBox1.Items.Assign(l_chaines);
end;

procedure TForm1.charge2Click(Sender: TObject);
var l_indice: Integer;
begin
  Table1.First;
  dbListBox1.Clear;
  While not Table1.Eof do
  begin
    l_indice:= dbListBox1.Items.IndexOf(Table1.FieldByName('PRENOM').AsString);
    if l_indice= -1
      then dbListBox1.Items.Add(Table1.FieldByName('PRENOM').AsString);
    Table1.Next;
  end;
end;

procedure TForm1.charge_SqlClick(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    Sql.Clear;
    Sql.Add('SELECT DISTINCT PRENOM FROM "CHERCHE.DBF" ');
    Sql.Add('  ORDER BY PRENOM DESC');
    Query1.Open;
  end;

  Query1.First;
  dbListBox1.Clear;
  While not Query1.Eof do
  begin
    dbListBox1.Items.Add(Query1.FieldByName('PRENOM').AsString);
    Query1.Next;
  end;
end;

procedure TForm1.Sorted_Click(Sender: TObject);
begin
  tListBox(dbListBox1).Sorted:= True;
end;

procedure TForm1.Columns_Click(Sender: TObject);
begin
  tListBox(dbListBox1).Columns:= 2;
end;

procedure TForm1.OwnerDraw_Click(Sender: TObject);
begin
  tListBox(dbListBox1).Style:= lbOwnerDrawFixed;
end;

procedure TForm1.DBListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  With Rect do
  begin
    dbListBox1.Canvas.TextOut(20, Top+ 2, dbListBox1.Items[Index]);
{
    if Index= dbListBox1.ItemIndex
}
    if odSelected in State
      then begin
          dbListBox1.Canvas.Brush.Color:= clRed;
          dbListBox1.Canvas.Ellipse(1, Top+ 4, 16, Top+ 14);
          dbListBox1.Canvas.Brush.Color:= clWhite;
        end;
  end;
end;

procedure TForm1.DBListBox1Click(Sender: TObject);
begin
  dbListBox1.Invalidate;
{

  dbListBox1.Color:= clRed;
}
end;

(* -- navigation incrmentale *)

var g_texte: String;

procedure TForm1.dbListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  Memo1.Lines.Add('dbL.KeyP '+ Key);
  case Key Of
    ' '..#255 : begin
                  g_texte:= '';
                  SendMessage(Edit1.Handle, wm_Char, Ord(Key), 0);
                  Key:= chr(0);
                end;
  end;
end;

  procedure cherche;
    var l_indice, l_item, l_item_ok: Integer;
        l_fini: Boolean;
        l_texte, l_partie_item, l_partie_texte: String;
      begin
        With Form1 do
        begin
          Memo1.Lines.Add('cherche '+ g_texte);
          l_texte:= UpperCase(g_texte);

          l_fini:= False;
          l_item:= 0; l_indice:= 1; l_item_ok:= 0;
          While not l_fini and (l_item<= dbListBox1.Items.Count) do
          begin
            Memo1.Lines.Add('>'+ IntToStr(l_item_ok));
            l_partie_item:= UpperCase(Copy(dbListBox1.Items[l_item], 1, l_indice));
            l_partie_texte:= Copy(l_texte, 1, l_indice);

            if l_partie_item< l_partie_texte
              then inc(l_item)
              else
                if l_partie_item> l_partie_texte
                  then l_fini:= True
                  else begin
                      l_item_ok:= l_item;
                      if l_indice= Length(l_texte)
                        then l_fini:= True
                        else inc(l_indice);
                    end;
          end; (* While *)

          Memo1.Lines.Add(IntToStr(l_item_ok));

          if not (Table1.State= dsEdit)
            then Table1.Edit;
          dbListBox1.ItemIndex:= l_item_ok;

          Edit1.Visible:= True;
          Edit1.SetFocus;

          With dbListBox1 do
          begin
            Edit1.Left:= Left+ 2;
            Edit1.Top:= Top+ ItemHeight* (l_item_ok- TopIndex);
          end;

          if l_partie_item<> l_partie_texte
            then g_texte:= Copy(g_texte, 1, l_indice- 1);

          Edit1.Text:= dbListBox1.Items[l_item_ok];
          Edit1.SelStart:= Length(g_texte);
      end;
    end; (* cherche *)

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  Memo1.Lines.Add('dbedit.KeyP '+ Key);
  case Key Of
    ' '..#255 : begin
                  Memo1.Lines.Add(Key);
                  g_texte:= g_texte+ Key;
                  cherche;
                  Key:= chr(0);
                end;
    #8 : begin
           Delete(g_texte, Length(g_texte), 1);
           cherche;
           Key:= chr(0);
         end;
  end;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  Memo1.Lines.Add('dbE.Exit');
  Edit1.Visible:= False;
end;

(* -- ajout de nouvelle valeur *)

procedure TForm1.DBListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var l_texte: String;
    l_indice: Integer;
begin
  Memo1.Lines.Add('dbL.KeyD');
  case Key of
    vk_Up : dbListBox1.ItemIndex:= dbListBox1.ItemIndex- 1;
    vk_Down : dbListBox1.ItemIndex:= dbListBox1.ItemIndex+ 1;

    vk_Return :
      begin
        l_indice:= dbListBox1.ItemIndex;
        (* -- mmorise le texte car Table1.Edit va repositionner *)
        l_texte:= dbListBox1.Items[l_indice];
        Memo1.Lines.Add(dbListBox1.Items[dbListBox1.ItemIndex]);
        Table1.Edit;
        Table1.FieldByName('PRENOM').AsString:= l_texte;
        Table1.Post;

        (* -- replace, car diffusion va chercher le premier *)
        (* -- ayant ce caractre (AAA -> aaa) *)
        dbListBox1.ItemIndex:= l_indice;
        (* -- aussi repostionner le mme TopIndex *)
      end;
    vk_F2 : begin
              Edit2.Visible:= True;
              Edit2.Left:= dbListBox1.Left+ 2;
              Edit2.Top:= dbListBox1.Top+ 2;
              Edit2.Text:= '';
              Edit2.SetFocus;
            end;
  end; (* Case *)
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
  dbListBox1.Items.Add(Edit2.Text);
  If not (Table1.State= dsEdit)
    then Table1.Edit;
  Table1.FieldByName('PRENOM').AsString:= Edit2.Text;
end;

end.


