(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_loc *)

unit U_db_loc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, StdCtrls, Mask, DBCtrls, dblookup, Grids,
  DBGrids, Buttons;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    Table2A_CODE: TFloatField;
    Table2A_DESCRIPT: TStringField;
    Table1I_NUMERO: TFloatField;
    Table1I_LIBELLE: TStringField;
    Table1I_CODE: TFloatField;
    Table2A_POIDS: TFloatField;
    DBLookupCombo1: TDBLookupCombo;
    DropDown_: TButton;
    Table21: TTable;
    DataSource22: TDataSource;
    DBEdit22: TDBEdit;
    Memo1: TMemo;
    DBGrid22: TDBGrid;
    Table21A_CODE: TFloatField;
    Table21A_DESCRIPT: TStringField;
    SpeedButton1: TSpeedButton;
    DBLookupCombo2: TDBLookupCombo;
    Edit1: TEdit;
    Table22: TTable;
    Table23: TTable;
    Table22A_DESCRIPT: TStringField;
    Table22A_CODE: TFloatField;
    procedure DropDown_Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBLookupCombo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBLookupCombo1KeyPress(Sender: TObject; var Key: Char);
    procedure DBLookupCombo1Enter(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Exit(Sender: TObject);
    procedure DBEdit22KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit22KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBEdit22Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBEdit22Enter(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

function f_code_virtuel(p_code: Word): String;
  begin
    case p_code of
      vk_Right : result:= 'vk_Right';
      vk_Left : result:= 'vk_Left';

      vk_Up : result:= 'vk_Up';
      vk_Down : result:= 'vk_Down';

      vk_Prior : result:= 'vk_Prior';
      vk_Next : result:= 'vk_Next';

      vk_Shift : result:= 'vk_Shift';

      vk_Insert : Result:= 'vk_Insert';

      vk_tab : result:= 'vk_tab';
      vk_Return : result:= 'vk_Return';

      Ord('A')..Ord('Z') : Result:= 'vk_'+ chr(p_code);

      else Result:= 'vk_'+ IntToStr(p_code);
    end;
  end; (* f_code_virtuel *)

function f_caractere(p_caractere: Char): String;
  begin
    case p_caractere of
      #8 : Result:= 'Eff';
      #9 : Result:= 'Tab';
      #13 : Result:= 'Return';
      #27 : Result:= 'Esc';

      #0..#7, #10..#12, #14..#26, #28..#31 : Result:= IntToStr(Ord(p_caractere));
      else Result:= p_caractere;
    end;
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SpeedButton1.Glyph.Handle:= LoadBitMap(0, pChar(32738));
end;

procedure TForm1.DropDown_Click(Sender: TObject);
begin
  dbLookupCombo1.SelStart:= 3;
  dbLookupCombo1.DropDown;
  dbLookupCombo2.DropDown;
end;

(* -- positionnement incrmental *)

var g_texte: String;
    g_indice_caret: Integer;

  procedure cherche;
{
    var l_indice, l_item, l_item_ok: Integer;
        l_fini: Boolean;
        l_texte, l_partie_item, l_partie_texte: String;
        l_signet: tBookMark;
}
    var l_indice: Integer;
        l_fini: Boolean;
        l_texte, l_partie_item, l_partie_texte: String;
        l_signet: tBookMark;
    begin
      With Form1 do
      begin
        Memo1.Lines.Add('cherche '+ g_texte);
        l_texte:= g_texte;

        l_signet:= Table22.GetBookMark;

        l_fini:= False; l_indice:= 1;
        While not l_fini and (l_indice<= g_indice_caret ) do
        begin
          Memo1.Lines.Add('>'+ IntToStr(l_indice)+ ' '+ Table22.FieldByName('A_DESCRIPT').AsString);
          l_partie_texte:= Copy(l_texte, 1, l_indice);

          Table22.SetKey;
          Table22.FieldByName('A_DESCRIPT').AsString:= l_partie_texte;
          Table22.GotoNearest;

          l_partie_item:= Copy(Table22.FieldByName('A_DESCRIPT').AsString, 1, l_indice);

          affiche(l_partie_item+ '-'+ l_partie_texte);

          if l_partie_item= l_partie_texte
            then begin
                inc(l_indice);
                Table22.FreeBookMark(l_signet);
                l_signet:= Table22.GetBookMark;
              end
            else l_fini:= True;
        end; (* While *)

        Memo1.Lines.Add('!!'+ IntToStr(l_indice)+ ' '+ Table22.FieldByName('A_DESCRIPT').AsString);
        if l_partie_item= l_partie_texte
          then affiche(' ==')
          else begin
              affiche(' <> ');
              g_indice_caret:= l_indice- 1;
              Table22.GotoBookMark(l_signet);
              Memo1.Lines.Add(' ->'+ IntToStr(l_indice)+ ' '+ Table22.FieldByName('A_DESCRIPT').AsString);
            end;

        Table22.FreeBookMark(l_signet);
        g_texte:= Table22.FieldByName('A_DESCRIPT').AsString;
      end;
    end; (* cherche *)

(* -- sur dbLookupCombo *)

procedure TForm1.DBLookupCombo1Enter(Sender: TObject);
begin
  g_texte:= '';
end;

procedure TForm1.DBLookupCombo1KeyPress(Sender: TObject; var Key: Char);
begin
  Affiche('KeyPress '+ f_caractere(Key));
  dbLookupCombo1.DropDown;

  case Key of
    ' '..#255 : begin
                  g_texte:= g_texte+ Key;
                  g_indice_caret:= Length(g_texte);
                  cherche;
                end;
    #8 : begin
           g_texte:= g_texte;
         end;
  end; (* case *)
  dbLookupCombo1.Text:= g_texte;
{
  case Key Of
    ' '..#255 : begin
                  g_texte:= '';
                  Edit1.Left:= dbLookupCombo1.Left+ 2;
                  Edit1.Top:= dbLookupCombo1.Top+ 2;
                  Edit1.SetFocus;
                  Edit1.Visible:= True;

                  SendMessage(Edit1.Handle, wm_Char, Ord(Key), 0);
                  Key:= chr(0);
                end;
  end;
}
end;

procedure TForm1.DBLookupCombo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Affiche('KeyDown '+ f_code_virtuel(Key));
end;

(* -- avec Edit incrust *)

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  Memo1.Lines.Add('dbedit.KeyP '+ Key);

  case Key Of
    ' '..#255 : begin
                  Memo1.Lines.Add(Key);
                  g_texte:= g_texte+ Key;
                  cherche;
{
                  Key:= chr(0);
}
                end;
    #8 : begin
           Delete(g_texte, Length(g_texte), 1);
           cherche;
{
           Key:= chr(0);
}
         end;
  end;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  Memo1.Lines.Add('dbE.Exit');
  Edit1.Visible:= False;
end;

(* -- LookupCombo  partir de dbGrid *)

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  Table23.SetKey;
  Table23.FieldByName('A_CODE').AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

  if Table23.GotoKey
    then Table22.GotoCurrent(Table23)
    else Memo1.Lines.Add('N OK');
end;

procedure TForm1.DBEdit22Enter(Sender: TObject);
begin
  g_texte:= dbEdit22.Text;
end;

procedure TForm1.dbEdit22KeyPress(Sender: TObject; var Key: Char);
begin
  g_indice_caret:= dbEdit22.SelStart;
  dbGrid22.Visible:= True;
  case Key Of
    ' '..#255 : begin
                  Memo1.Lines.Add('-'+ Key+ IntToStr(g_indice_caret)+ ' '+ g_texte);

                  if g_indice_caret< Length(g_texte)
                    then g_texte[g_indice_caret+ 1]:= Key
                    else g_texte:= g_texte+ Key;

                  inc(g_indice_caret);
                  cherche;

                  dbEdit22.Text:= g_texte;
                  dbEdit22.SelStart:= g_indice_caret;
                  Key:= chr(0);
                end;
    #8 : begin
           Delete(g_texte, Length(g_texte), 1);

           dec(g_indice_caret);
           cherche;

           dbEdit22.Text:= g_texte;
           dbEdit22.SelStart:= g_indice_caret;

           Key:= chr(0);
         end;
  end;
end;

procedure TForm1.dbEdit22KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  dbGrid22.Visible:= True;

  case Key Of
    vk_Down : begin
                Table22.Next;
                dbGrid22.Options:= dbGrid22.Options+ [dgAlwaysShowSelection]
              end;
    vk_Up : begin
                Table22.Prior;
                dbGrid22.Options:= dbGrid22.Options+ [dgAlwaysShowSelection]
              end;
  end;
end;

procedure TForm1.DBEdit22Exit(Sender: TObject);
var l_code: Integer;
begin
  dbGrid22.Visible:= False;

  l_code:= Table22.FieldByName('A_CODE').AsInteger;
{
  affiche(IntToStr(l_code));
}
  If not (Table1.State= dsEdit)
    then Table1.Edit;

  Table1.FieldByName('I_CODE').AsInteger:= l_code;
  Table1.Post;
end;

end.




