(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_nav *)

unit U_db_nav;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls, StdCtrls,
  Buttons;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    types: TButton;
    BtnClick: TButton;
    hints: TButton;
    DBNavigator1: TDBNavigator;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1POIDS: TFloatField;
    Table1NAISSANCE: TDateField;
    procedure typesClick(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure BtnClickClick(Sender: TObject);
    procedure hintsClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

  function f_navigue(p_type: tNavigateBtn): String;
    begin
      case p_type of
        nbFirst : Result:= 'nbFirst';
        nbPrior : Result:= 'nbPrior';
        nbNext : Result:= 'nbNext';
        nbLast : Result:= 'nbLast';

        nbInsert : Result:= 'nbInsert';
        nbDelete : Result:= 'nbDelete';
        nbEdit : Result:= 'nbEdit';
        nbPost : Result:= 'nbPost';
        nbCancel : Result:= 'nbCancel';
        nbRefresh : Result:= 'nbRefresh';
      end;
    end; (* f_type *)

  function f_style(p_style: tNavButtonStyle): String;
    begin
      if nsAllowTimer in p_style
        then Result:= 'nsAllowTimer'
        else Result:= '';
      if nsFocusRect in p_style
        then Result:= Result+ ' nsFocusRect';
    end; (* f_style *)

procedure TForm1.typesClick(Sender: TObject);
var l_indice: Integer;
    l_disponible: String;
begin
  with dbNavigator1 do
  begin
    For l_indice:= 0 to ControlCount- 1 do
      with Controls[l_indice] as tNavButton do
      begin
        if Enabled
          then l_disponible:= ''
          else l_disponible:= ' gris';
{
        if GetFocus= Focused
          then l_focus:= ' focus'
          else l_focus:= '';
}
        affiche(IntToStr(l_indice)+ ' '+ f_navigue(Index)+ ' '+ f_style(NavStyle)
            + l_disponible);
      end; (* for with *)
  end; (* with *)
end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
  affiche('');
  affiche('a cliqu '+ f_navigue(Button));
  if Button= nbNext
    then begin
        Table1.Next;
        if not Table1.Eof
          then Table1.Prior;
      end;
end;

procedure TForm1.BtnClickClick(Sender: TObject);
begin
  dbNavigator1.BtnClick(nbNext);
end;

procedure TForm1.hintsClick(Sender: TObject);
var l_conseils: tStringList;
begin
  l_conseils:= tStringList.Create;
  with l_conseils do
  begin
    Add('un');
    Add('');
    Add('deux');
  end;
  dbNavigator1.Hints:= l_conseils;
  dbNavigator1.ShowHint:= True;
end;

end.
