(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_mes *)

unit U_db_mes;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1POIDS: TFloatField;
    Table1NAISSANCE: TDateField;
    Table1GRAND: TBooleanField;
    Button1: TButton;
    Sauve: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure SauveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations private }
    procedure traite_message(Var pv_Msg: tMsg; Var Handled: Boolean);
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(* -- visu *)

const vi_numero: Integer= -2;
      vi_affiche: Boolean= True;

(* -- composant *)

procedure affiche(p_indente: Integer; p_texte: String);
  begin
    If vi_affiche
      then Form1.Memo1.Lines.Add(Format('%3d %'+ IntToStr(p_indente* 2)+ 's %-10s ',
        [vi_numero, '', p_texte]) );

    inc(vi_numero);
  end;

function f_code_virtuel(p_code: Word): String;
  begin
    case p_code of
      vk_Right : result:= 'vk_Right';
      vk_tab : result:= 'vk_tab';
      vk_Return : result:= 'vk_Return';
      Ord('A')..Ord('Z') : Result:= 'vk_'+ chr(p_code);
      else Result:= 'vk_'+ IntToStr(p_code);
    end;
  end; (* f_code_virtuel *)

function f_caractere(p_caractere: Char): String;
  begin
    case p_caractere of
      #0..#31 : Result:= IntToStr(Ord(p_caractere));
      else Result:= p_caractere;
    end;
  end;

type t_dbedit_mes= class(tdbEdit)
                    private
                      procedure wmGetDlgCode(var pv_message: tMessage); message wm_GetDlgCode;
                      procedure wmKeyDown(var pv_message: tMessage); message wm_KeyDown;
                      procedure wmChar(var pv_message: tMessage); message wm_Char;
                      procedure wmKeyUp(var pv_message: tMessage); message wm_KeyUp;
                    protected
                      procedure WndProc(var pv_message: tMessage); Override;
                      procedure KeyDown(var pv_touche: Word; p_shift: tShiftState); Override;
                      procedure KeyPress(var pv_caractere: Char); Override;
                      procedure KeyUp(var pv_touche: Word; p_shift: tShiftState); Override;
                    public
                      procedure on_key_down(Sender: TObject; var Key: Word;
                          Shift: TShiftState);
                      procedure on_key_press(Sender: TObject; var Key: Char);
                      procedure on_key_up(Sender: TObject; var Key: Word;
                          Shift: TShiftState);
                  end;

procedure t_dbedit_mes.wmGetDlgCode(var pv_message: tMessage);
  begin
    affiche(2, 'dbEdit.wmGetDlgCode();');

    inherited;
    Exit;
    pv_message.Result:= pv_message.Result or dlgc_WantArrows OR dlgc_Wanttab;
  end;

procedure t_dbedit_mes.wmKeyDown(var pv_message: tMessage);
  begin
    affiche(2, 'dbEdit.wmKeyDown(w= '+ f_code_virtuel(pv_message.wParam)+ ')');
    inherited;
  end;

procedure t_dbedit_mes.wmChar(var pv_message: tMessage);
  begin
    affiche(2, 'dbEdit.wmChar(w= '+ f_caractere(chr(pv_message.wParam))+ ')');
    inherited;
  end;

procedure t_dbedit_mes.wmKeyUp(var pv_message: tMessage);
  begin
    affiche(2, 'dbEdit.wmKeyUp(w= '+ f_code_virtuel(pv_message.wParam)+ ')');
    inherited;
  end;

procedure t_dbedit_mes.WndProc(var pv_message: tMessage);
  begin
    case pv_message.Msg Of
      wm_GetDlgcode : affiche(1, 'dbEdit.WndProc(wm_GetDlgCode)');

      wm_KeyDown : affiche(1, 'dbEdit.WndProc(wm_KeyDown)');
      wm_Char : affiche(1, 'dbEdit.WndProc(wm_Char)');
      wm_KeyUp : affiche(1, 'dbEdit.WndProc(wm_KeyUp)');
    end; (* case *)

    Inherited WndProc(pv_message);
  end;

(* -- les rpartiteurs *)

procedure t_dbedit_mes.KeyDown(var pv_touche: Word; p_shift: tShiftState);
  begin
    affiche(4, 'dbEdit.KeyDown('+ f_code_virtuel(pv_touche)+ ')');
    InHerited KeyDown(pv_touche, p_shift);
  end;

procedure t_dbedit_mes.KeyPress(var pv_caractere: Char);
  begin
    affiche(4, 'dbEdit.KeyPress('+ f_caractere(pv_caractere)+ ')');
    InHerited KeyPress(pv_caractere);
  end;

procedure t_dbedit_mes.KeyUp(var pv_touche: Word; p_shift: tShiftState);
  begin
    affiche(4, 'dbEdit.KeyUp('+ f_code_virtuel(pv_touche)+ ')');
    InHerited KeyUp(pv_touche, p_shift);
  end;

procedure t_dbedit_mes.on_key_down(Sender: TObject; var Key: Word;
    Shift: TShiftState);
  begin
    affiche(5, 'dbEdit.on_KeyDown ('+ f_code_virtuel(Key)+ ')');
  end;

procedure t_dbedit_mes.on_key_press(Sender: TObject; var Key: Char);
  begin
    affiche(5, 'dbEdit.on_KeyPress('+ f_caractere(Key)+ ')');
  end;

procedure t_dbedit_mes.on_key_up(Sender: TObject; var Key: Word;
    Shift: TShiftState);
  begin
    affiche(5, 'dbEdit.on_KeyUp('+ f_code_virtuel(Key)+ ')');
  end;

(* -- Forme *)

procedure tForm1.traite_message(Var pv_Msg: tMsg; var Handled: Boolean);
  begin
    With pv_Msg do
    begin
      case Message of
        wm_KeyDown : affiche(0, 'Application.OnMessage(wm_KeyDown, '+ f_code_virtuel(wParam)+ ')' );
        wm_Char : affiche(0, 'Application.OnMessage(wm_Char, '+ f_caractere(Chr(wParam))+ ')' );
        wm_KeyUp : affiche(0, 'Application.OnMessage(wm_KeyUp, '+ f_code_virtuel(wParam)+ ')' );

        wm_GetDlgCode : affiche(0, 'Application.OnMessage(wm_GetDlgCode)' );
      end;
    end;

    Handled:= False;
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnMessage:= traite_message;
end;

var g_dbedit_mes: t_dbedit_mes;

procedure TForm1.Button1Click(Sender: TObject);
begin
  g_dbedit_mes:= t_dbedit_mes.Create(Self);

  with g_dbedit_mes do
  begin
    Parent:= Self;
    Left:= Button1.Left;
    Top:= Button1.Top+ Button1.Height+ 10;
    DataSource:= DataSource1;
    DataField:= 'NOM';

    OnKeyDown:= on_key_down;
    OnKeyPress:= on_key_press;
    OnKeyUp:= on_key_up;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche(3, 'Form.on_KeyDown('+ f_code_virtuel(Key)+ ')');
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  affiche(3, 'Form.on_KeyPress('+ f_caractere(key)+ ')');
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche(3, 'Form.on_KeyUp('+ f_code_virtuel(Key)+ ')');
end;

procedure TForm1.SauveClick(Sender: TObject);
begin
  vi_affiche:= False;                    
  Memo1.Lines.SaveToFile('a:f.Pas');
  sauve.Visible:= False;
end;

end.


