(* 001 i_dbf *)
(* 19 avr 96 *)

(*$r+*)

  const k_taille_descripteur_zone= 32;
        k_descripteur_zone_max= 127;
        k_taille_en_tete_max= 4130;
        k_taille_nom_zone_max= 10;
  type t_en_tete_donnees= record
                            signature: byte;
                            date_derniere_mise_a_jour: array[0..2] of byte;
                            nombre_fiches: longint;
                            taille_en_tete: word;
                            taille_fiche: word;
                            remplissage: array[12..31] of byte;
                          end;
       t_nom_zone= array[0..k_taille_nom_zone_max] of char;
       t_descripteur_de_zone= record
                                nom_zone: t_nom_zone;
                                type_zone: char;
                                adresse_memoire: longint;
                                taille_zone: byte;
                                nombre_decimales: byte;
                                remplissage: array[18..31] of byte;
                              end;


       t_dbf= record
                poignee: Integer;
                pt_fiche: Pointer;
                resu: LongInt;
                taille: Word;

                en_tete: t_en_tete_donnees;
                descripteurs_zone: array[0..k_descripteur_zone_max- 1]
                   of t_descripteur_de_zone;
              end;
       t_pt_dbf= ^t_dbf;

  procedure ouvre_dbf(p_nom: String; var pv_pt_dbf: t_pt_dbf);
    var l_en_tete: t_en_tete_donnees;
        l_poignee: Integer;
        l_position: LongInt;
        l_numero_zone: integer;
        l_taille: Integer;
    begin
      l_poignee:= FileOpen(p_nom, fmOpenReadWrite+ fmShareDenyNone );
      if l_poignee< 0
        then begin
            Form1.Memo1.Lines.Add('pb Open '+ IntToStr(l_poignee));

            l_taille:= 2+ 4+ 4+ 2;
            GetMem(pv_pt_dbf, l_taille);
            FillChar(pv_pt_dbf^, l_taille, 0);
            pv_pt_dbf^.taille:= l_taille;
            pv_pt_dbf^.poignee:= l_poignee;
            pv_pt_dbf^.resu:= l_poignee;
            exit;
          end;
      l_position:= FileRead(l_poignee, l_en_tete, 32);

      l_taille:= 2+ 4+ 4+ 2+ l_en_tete.taille_en_tete;
      GetMem(pv_pt_dbf, l_taille);
      GetMem(pv_pt_dbf^.pt_fiche, l_en_tete.taille_fiche);
      pv_pt_dbf^.taille:= l_taille;

      Move(l_en_tete, pv_pt_dbf^.en_tete, 32);
      pv_pt_dbf^.poignee:= l_poignee;

      l_numero_zone:= 0;
      while l_position+ 1< l_en_tete.taille_en_tete do
      begin
        l_position:= l_position+ FileRead(l_poignee,
            pv_pt_dbf^.descripteurs_zone[l_numero_zone], 32);
        l_numero_zone:= l_numero_zone+ 1;
      end;
    end; (* ouvre_dbf *)

  procedure affiche_en_tete_dbf(p_pt_dbf: t_pt_dbf; p_chaines: tStrings);
    var l_numero_zone: Integer;
    begin
      with p_chaines, p_pt_dbf^, en_tete do
      begin
        Add('nombre de fiches  '+ FloatToStr(nombre_fiches));
        Add('taille en-tete:   '+ IntToStr(taille_en_tete));
        Add('taille fiche:     '+ IntToStr(taille_fiche));
        Add('$1C: MDX:          $'+ IntToHex(remplissage[$1C], 2));

        For l_numero_zone:= 0 to taille_en_tete div 32- 2 do
          with descripteurs_zone[l_numero_zone] do
            p_chaines.Add(Format('%-10s  %1s   %3d    %3d',
              [StrPas(nom_zone), type_zone, taille_zone, nombre_decimales]));
      end;
    end; (* affiche_en_tete_dbf *)

procedure lis_fiche_dbf(p_pt_dbf: t_pt_dbf; p_numero: LongInt);
  var l_resu: LongInt;
  begin
    with p_pt_dbf^, en_tete do
    begin
      l_resu:= FileSeek(poignee, taille_en_tete+ taille_fiche* p_numero, 0);
      if l_resu< 0
        then ShowMessage('pb Seek');
      l_resu:= FileRead(poignee, pt_fiche^, taille_fiche);
      if l_resu< 0
        then ShowMessage('pb Read')
        else
          if l_resu<> taille_fiche
            then ShowMessage('pb nb Read '+ IntToStr(l_resu)+ ' '+ IntToStr(taille_fiche)+ ' '+ IntToStr(poignee))
    end;
  end; (* lis_fiche_dbf *)

procedure ecris_fiche_dbf(p_pt_dbf: t_pt_dbf; p_numero: LongInt);
  var l_resu: Integer;
  begin
    with p_pt_dbf^, en_tete do
    begin
      if FileSeek(poignee, taille_en_tete+ taille_fiche* p_numero, 0)< 0
        then ShowMessage('pb Seek');

      l_resu:= FileWrite(poignee, pt_fiche^, taille_fiche);
      if l_resu= -1
        then ShowMessage('pb Write')
        else
          if l_resu<> taille_fiche
            then ShowMessage('pb Write nombre')
    end;
  end; (* ecris_fiche_dbf *)

function f_pt_champ_dbf(p_pt_dbf: t_pt_dbf; p_numero: LongInt): Pointer;
  type t_octets= array[0..0] of Byte;
       t_pt_octets= ^t_octets;
  var l_zone, l_position: Integer;
  begin
    with p_pt_dbf^ do
    begin
      if p_numero> en_tete.taille_en_tete div 32- 1
        then f_pt_champ_dbf:= nil
        else begin
            l_position:= 1;
            For l_zone:= 0 to p_numero- 1 do
              l_position:= l_position+ descripteurs_zone[l_zone].taille_zone;
            (*$r-*)
            f_pt_champ_dbf:= @t_pt_octets(pt_fiche)^[l_position];
            (*$r+*)
          end;
    end;
  end; (* f_pt_champ_dbf *)

function f_fiche_dbf(p_pt_dbf: t_pt_dbf): String;
  begin
    with p_pt_dbf^, en_tete do
    begin
      if taille_fiche> 255
        then ShowMessage('dpasse 255')
        else begin
            Result[0]:= Chr(taille_fiche);
            Move(pt_fiche^, Result[1], taille_fiche);
          end;
    end;
  end; (* f_fiche_dbf *)

procedure ferme_dbf(var pv_pt_dbf: t_pt_dbf);
  var l_resu: Integer;
  begin
    if pv_pt_dbf^.poignee> 0
      then begin
          l_resu:= _lClose(pv_pt_dbf^.poignee);
          if l_resu< 0
            then ShowMessage('pb close '+ IntToStr(l_resu) );
        end;

    if pv_pt_dbf^.pt_fiche<> nil
     then FreeMem(pv_pt_dbf^.pt_fiche, pv_pt_dbf^.en_tete.taille_fiche);

    FreeMem(pv_pt_dbf, pv_pt_dbf^.taille);
  end; (* ferme_dbf *)

(* -- fin i_dbf *)
