(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_mainte *)

(*$r+*)
unit U_mainte;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    cree_1: TButton;
    cree_2: TButton;
    DBGrid2: TDBGrid;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    aff_dbf_1: TButton;
    Memo1: TMemo;
    Open_1: TButton;
    Close_2: TButton;
    efface_2: TButton;
    Open_2: TButton;
    efface_1: TButton;
    Close_1: TButton;
    remplis_1: TButton;
    remplis_2: TButton;
    Table2: TTable;
    DataSource2: TDataSource;
    champ: TButton;
    refresh_2: TButton;
    enregistrement: TButton;
    aff_dbf_2: TButton;
    dir_2: TButton;
    DbiSaveChanges_2: TButton;
    table: TButton;
    aff_index_2: TButton;
    restaure: TButton;
    restructure: TButton;
    aff_index_1: TButton;
    dir_1: TButton;
    procedure cree_1Click(Sender: TObject);
    procedure cree_2Click(Sender: TObject);
    procedure Open_1Click(Sender: TObject);
    procedure Close_2Click(Sender: TObject);
    procedure efface_2Click(Sender: TObject);
    procedure Open_2Click(Sender: TObject);
    procedure efface_1Click(Sender: TObject);
    procedure Close_1Click(Sender: TObject);
    procedure remplis_1Click(Sender: TObject);
    procedure remplis_2Click(Sender: TObject);
    procedure champClick(Sender: TObject);
    procedure refresh_2Click(Sender: TObject);
    procedure enregistrementClick(Sender: TObject);
    procedure aff_dbf_2Click(Sender: TObject);
    procedure dir_2Click(Sender: TObject);
    procedure DbiSaveChanges_2Click(Sender: TObject);
    procedure tableClick(Sender: TObject);
    procedure aff_index_2Click(Sender: TObject);
    procedure aff_dbf_1Click(Sender: TObject);
    procedure restaureClick(Sender: TObject);
    procedure restructureClick(Sender: TObject);
    procedure aff_index_1Click(Sender: TObject);
    procedure dir_1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

procedure affiche(p_texte: String);

implementation
  uses DbiTypes, DbiProcs, DbiErrs, u__champ, u__enreg, u__table,
    u__restr, u__resta;

(*$i ..\..\u\f_errdbi *)
var l_erreur: String;

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_ligne;
  begin
    Form1.Memo1.Lines.Add('');
  end;

procedure TForm1.cree_1Click(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';

    TableType:= ttdBase;
    TableName:='COPIE_1.DBF';
{
    TableType:= ttParadox;
    TableName:='COPIE_1.DB';
}
    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('POIDS', ftFloat, 0, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, True);
    FieldDefs.Add('GRAND', ftBoolean, 0, True);
{
    dbMemo1.DataSource:= Nil;
}
    FieldDefs.Add('LE_BLOB', ftGraphic, 0, False);
{
    FieldDefs.Add('LE_BLOB', ftMemo, 0, True);
}
    IndexDefs.Clear;

    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;

    AddIndex('IND_NOMNUM', 'NOM + STR(NUMERO)', [ixExpression]);

    Open;
  end;
end;

procedure TForm1.remplis_1Click(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_chaine: String;
begin
  With Table1 do
  begin
    AppendRecord([1, 'MARTIN', 51.300, '1/2/45', True]);
    Edit;
    l_flux_blob:= tBlobStream.Create(FieldByName('LE_BLOB') AS tBlobField, bmWrite);
    l_chaine:= 'Bonjour'+ Chr(13)+ chr(10)
       + chr(130)+ Chr(13)+ chr(10);
    l_flux_blob.Write(l_chaine[1], Length(l_chaine));
    l_flux_blob.Free;
    Post;

    AppendRecord([2, 'DUBOIS', 51.300, '1/2/45', True]);
    First;
  end;
end;

procedure TForm1.Open_1Click(Sender: TObject);
begin
  Try
    Table1.Open;
  except
      on e: eConvertError do
        ShowMessage('OK');
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
  end;
end;

procedure TForm1.Close_1Click(Sender: TObject);
begin
  Table1.Close;
end;

procedure TForm1.efface_1Click(Sender: TObject);
begin
  Table1.DeleteTable;
end;

procedure TForm1.cree_2Click(Sender: TObject);
begin
  With Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('POIDS', ftFloat, 0, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, True);
    FieldDefs.Add('GRAND', ftBoolean, 0, True);
    FieldDefs.Add('LE_BLOB', ftGraphic, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;

    Open;
  end;
end;

procedure TForm1.remplis_2Click(Sender: TObject);
begin
  With Table2 do
  begin
    AppendRecord([1, 'a']);
    AppendRecord([2, 'b']);
    AppendRecord([3, 'c']);
    AppendRecord([4, 'd']);
    AppendRecord([5, 'DUBOIS']);
    First;
  end;
end;

procedure TForm1.Open_2Click(Sender: TObject);
begin
  Try
    Table2.Open;
  Except
      on e: eConvertError do
        ShowMessage('OK');
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
end;

procedure TForm1.Close_2Click(Sender: TObject);
begin
  Table2.Close;
end;

procedure TForm1.efface_2Click(Sender: TObject);
begin
  Table2.DeleteTable;
end;

  function f_options_index(p_option: tIndexOptions): String;
    var l_index: String;
    begin
      l_index:= '';
      if ixPrimary in p_option
        then l_index:= l_index+  'ixPrimary';
      if ixUnique in p_option
        then l_index:= l_index+  'ixUnique';
      if ixDescending in p_option
        then l_index:= l_index+  'ixDescending';
      if ixCaseInsensitive in p_option
        then l_index:= l_index+  'ixCaseInsensitive';
      if ixExpression in p_option
        then l_index:= l_index+  'ixExpression';

      f_options_index:= l_index;
    end; (* f_options_index *)

  procedure affiche_index(p_table: tTable; p_chaines: tStrings);
    var l_indice: Integer;
        l_texte: String;
    begin
      with p_table, p_chaines do
      begin
        Add(p_table.TableName);
        IndexDefs.Update;

        l_texte:= '';
        for l_indice:= 0 to IndexDefs.Count- 1 do
          with IndexDefs[l_indice] do
          begin
            l_texte:= 'Name: '+ Name+ ', Fields: '+ Fields+ ', Options: '+ f_options_index(Options);
            if ixExpression in Options
              then l_texte:= l_texte+ ', Expression: '+ Expression;
            Add(l_texte);
          end; (* with p_ *)
      end;
    end; (* affiche_index *)

procedure TForm1.aff_index_1Click(Sender: TObject);
begin
  affiche_ligne;
  affiche_index(Table1, Memo1.Lines);
end;

procedure TForm1.aff_index_2Click(Sender: TObject);
begin
  affiche_ligne;
  affiche_index(Table2, Memo1.Lines);
end;

procedure TForm1.champClick(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.refresh_2Click(Sender: TObject);
begin
  Table2.Refresh;
end;

procedure TForm1.enregistrementClick(Sender: TObject);
begin
  Form3.Show;
end;

(*$i i_dbf *)

procedure TForm1.aff_dbf_1Click(Sender: TObject);
var l_pt_dbf: t_pt_dbf;
begin
  ouvre_dbf('C:\OSCAR\COPIE_1.DBF', l_pt_dbf);
  lis_fiche_dbf(l_pt_dbf, 1);
  affiche(f_fiche_dbf(l_pt_dbf)+ '<');
  ferme_dbf(l_pt_dbf);
end;

procedure TForm1.aff_dbf_2Click(Sender: TObject);
var l_pt_dbf: t_pt_dbf;
begin
  Try
    ouvre_dbf('C:\OSCAR\COPIE_2.DBF', l_pt_dbf);
    lis_fiche_dbf(l_pt_dbf, 0);
    affiche(f_fiche_dbf(l_pt_dbf)+ '<');
  Finally
    ferme_dbf(l_pt_dbf);
  end;
end;

  procedure affiche_dir(p_table: tTable; p_chaines: tStrings);
   var l_entree: tSearchRec;
       l_nom: String;
   begin
      affiche_ligne;
      l_nom:= 'C:\OSCAR\'+ p_table.TableName;

      affiche('Il est: '+ DateTimeToStr(Now)+ ' '+ l_nom);

      if FindFirst(ChangeFileExt(l_nom, '.DBF'), faAnyFile, l_entree)= 0
        then affiche('DBF: '+ TimeToStr(FileDateToDateTime(l_entree.Time))+ ' '+ IntToStr(l_entree.Size));
      if FindFirst(ChangeFileExt(l_nom, '.MDX'), faAnyFile, l_entree)= 0
        then affiche('MDX: '+ TimeToStr(FileDateToDateTime(l_entree.Time))+ ' '+ IntToStr(l_entree.Size));
      if FindFirst(ChangeFileExt(l_nom, '.DBT'), faAnyFile, l_entree)= 0
        then affiche('DBT: '+ TimeToStr(FileDateToDateTime(l_entree.Time))+ ' '+ IntToStr(l_entree.Size));

      if FindFirst(ChangeFileExt(l_nom, '.TXT'), faAnyFile, l_entree)= 0
        then affiche('TXT: '+ TimeToStr(FileDateToDateTime(l_entree.Time))+ ' '+ IntToStr(l_entree.Size));
      if FindFirst(ChangeFileExt(l_nom, '.SCH'), faAnyFile, l_entree)= 0
        then affiche('SCH: '+ TimeToStr(FileDateToDateTime(l_entree.Time))+ ' '+ IntToStr(l_entree.Size));
    end; (* affiche_dir *)

procedure TForm1.dir_1Click(Sender: TObject);
begin
  affiche_dir(Table1, Memo1.Lines);
end;

procedure TForm1.dir_2Click(Sender: TObject);
begin
  affiche_dir(Table2, Memo1.Lines);
end;

procedure TForm1.DbiSaveChanges_2Click(Sender: TObject);
var l_dbi: Integer;
begin
  l_dbi:= DbiSaveChanges(Table2.Handle);
  if l_dbi<> 0
    then affiche('pb '+ f_erreur_dbi(l_dbi));
end;

procedure TForm1.tableClick(Sender: TObject);
begin
  Form4.Show;
end;

procedure TForm1.restructureClick(Sender: TObject);
begin
  Form5.Show;
end;

procedure TForm1.restaureClick(Sender: TObject);
begin
  Form6.Show;
end;

end.



