(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* -- u__resta *)

unit U__resta;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm6 = class(TForm)
    avec_index: TButton;
    efface_index: TButton;
    AddIndex_: TButton;
    efface_MDX: TButton;
    mets_1C: TButton;
    efface_1C: TButton;
    plombe_dbf: TButton;
    DbiRegenIndex_: TButton;
    en_tete: TButton;
    aff_en_tete: TButton;
    sauve: TButton;
    mets_0: TButton;
    eff_les_index: TButton;
    procedure avec_indexClick(Sender: TObject);
    procedure efface_indexClick(Sender: TObject);
    procedure AddIndex_Click(Sender: TObject);
    procedure efface_MDXClick(Sender: TObject);
    procedure lis_1CClick(Sender: TObject);
    procedure mets_1CClick(Sender: TObject);
    procedure efface_1CClick(Sender: TObject);
    procedure plombe_dbfClick(Sender: TObject);
    procedure DbiRegenIndex_Click(Sender: TObject);
    procedure en_teteClick(Sender: TObject);
    procedure sauveClick(Sender: TObject);
    procedure aff_en_teteClick(Sender: TObject);
    procedure mets_0Click(Sender: TObject);
    procedure eff_les_indexClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form6: TForm6;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, u_mainte;

  (*$i ..\..\u\f_errdbi *)
  var l_erreur: String;

{$R *.DFM}

  procedure copie_par_bloc(Const p_nom_source, p_nom_destination: String);
    Const k_taille_tampon= 512;
    Var l_fichier_source, l_fichier_destination: File;
        l_tampon: array[0..k_taille_tampon- 1] of Byte;
        l_reste, l_quantite: Word;
    begin
      AssignFile(l_fichier_source, p_nom_source);
      AssignFile(l_fichier_destination, p_nom_destination);
      Reset(l_fichier_source, 1);
      Rewrite(l_fichier_destination, 1);

      l_reste:= FileSize(l_fichier_source);

      While l_reste> 0 do
      begin
        l_quantite:= l_reste;
        if l_quantite> k_taille_tampon
          then l_quantite:= k_taille_tampon;

        (*$i-*)
        BlockRead(l_fichier_source, l_tampon, l_quantite);
        (*$i+*)
        if IoResult<> 0
          then Fillchar(l_tampon, k_taille_tampon, ' ');
        BlockWrite(l_fichier_destination, l_tampon, l_quantite);
        Dec(l_reste, l_quantite);
      end; (* while *)

      CloseFile(l_fichier_destination);
      CloseFile(l_fichier_source);
    end; (* copie_par_bloc *)

procedure TForm6.sauveClick(Sender: TObject);
begin
  With Form1 do
    copie_par_bloc('C:\OSCAR\'+ ChangeFileExt(Table1.TableName, '.DBF'),
       'SAUVE.DBF');
end;

(*$i i_dbf *)

procedure TForm6.aff_en_teteClick(Sender: TObject);
var l_pt_dbf: t_pt_dbf;
begin
  Try
    ouvre_dbf('C:\OSCAR\COPIE_1.DBF', l_pt_dbf);
    affiche_en_tete_dbf(l_pt_dbf, Form1.Memo1.Lines);
  Finally
    ferme_dbf(l_pt_dbf);
  end;
end;

procedure TForm6.en_teteClick(Sender: TObject);
var l_pt_dbf_1, l_pt_dbf_2: t_pt_dbf;
    l_taille: LongInt;
begin
  with Form1 do
  begin
    ouvre_dbf('C:\OSCAR\'+ Table1.TableName, l_pt_dbf_1);
    ouvre_dbf('C:\OSCAR\'+ Table2.TableName, l_pt_dbf_2);

    Move(l_pt_dbf_2^.en_tete, l_pt_dbf_1^.en_tete, 32);

    with l_pt_dbf_1^, en_tete do
    begin
      l_taille:= FileSeek(poignee, 0, 2);
      affiche('Taille '+ IntToStr(l_taille));
      nombre_fiches:= (l_taille- taille_en_tete) div taille_fiche;
      affiche('Nombre fiches '+ IntToStr(nombre_fiches));

      FileSeek(poignee, 0, 0);
      FileWrite(poignee, en_tete, taille_en_tete);
    end;

    ferme_dbf(l_pt_dbf_2);
    ferme_dbf(l_pt_dbf_1);
  end;
end;

procedure TForm6.mets_0Click(Sender: TObject);
var l_pt_dbf: t_pt_dbf;
begin
  ouvre_dbf('C:\OSCAR\COPIE_1.DBF', l_pt_dbf);
  lis_fiche_dbf(l_pt_dbf, 1);

  pChar(f_pt_champ_dbf(l_pt_dbf, 0))[0]:= chr(0);
  pChar(f_pt_champ_dbf(l_pt_dbf, 1))[0]:= chr(0);

  ecris_fiche_dbf(l_pt_dbf, 1);
  ferme_dbf(l_pt_dbf);
end;

(* _ index *)

procedure TForm6.avec_indexClick(Sender: TObject);
begin
  if avec_index.Caption= 'avec_index'
    then begin
        avec_index.Caption:= 'sans_index';
        Form1.Table1.IndexName:= 'IND_NOM';
      end
    else begin
        avec_index.Caption:= 'avec_index';
        Form1.Table1.IndexName:= '';
      end;
end;

procedure TForm6.efface_indexClick(Sender: TObject);
begin
  with Form1 do
  begin
{
    (* -- ne peut tre ouvert en mode exclusif *)
    Table1.DeleteIndex('IND_NOM');
}
{
    Table1.Close;
    Table1.Exclusive:= True;
    Table1.Open;
    Table1.DeleteIndex('IND_NOM');
}
    Table1.Close;
    Table1.DeleteIndex('IND_NOM');
    Table1.Open;
  end;
end;

procedure TForm6.eff_les_indexClick(Sender: TObject);
var l_indice: Integer;
    l_liste: tStringList;
begin
  with Form1 do
  begin
    l_liste:= tStringList.Create;
    Table1.GetIndexNames(l_liste);

    Table1.Close;
    for l_indice:= 0 to l_liste.Count- 1 do
      Table1.DeleteIndex(l_liste[l_indice]);

    l_liste.Free;
  end;
end;

procedure TForm6.AddIndex_Click(Sender: TObject);
begin
  with Form1 do
  begin
{
    (* -- ne peut tre ouvert en mode exclusif *)
    Table1.AddIndex('IND_NOM', 'NOM', []);
}
{
    Table1.Close;
    Table1.AddIndex('IND_NOM', 'NOM', []);
}
    Table1.Close;
    Table1.Exclusive:= True;
    Table1.Open;
    Table1.AddIndex('IND_NOM', 'NOM', []);
    Table1.Exclusive:= False;
  end;
end;

procedure TForm6.efface_MDXClick(Sender: TObject);
var l_fichier: File;
begin
  System.Assign(l_fichier, 'C:\OSCAR\'+ 'COPIE_1.MDX');
  Erase(l_fichier);
end;

procedure TForm6.lis_1CClick(Sender: TObject);
var l_poignee: Word;
    l_octet: Byte;
begin
  l_poignee:= FileOpen('C:\OSCAR\'+ Form1.Table1.TableName, fmOpenRead+ fmShareDenyNone );
  if l_poignee< 0
    then affiche('pb');
  FileSeek(l_poignee, $1C, 0);
  FileRead(l_poignee, l_octet, 1);
  affiche('$1C '+ IntToHex(l_octet, 2));
  FileClose(l_poignee);
end;

procedure TForm6.mets_1CClick(Sender: TObject);
var l_poignee: Word;
    l_octet: Byte;
begin
  l_poignee:= FileOpen('C:\OSCAR\'+ Form1.Table1.TableName, fmOpenReadWrite+ fmShareDenyNone );
  if l_poignee< 0
    then affiche('pb');
  FileSeek(l_poignee, $1C, 0);
  FileRead(l_poignee, l_octet, 1);
  l_octet:= l_octet or 1;
  FileSeek(l_poignee, $1C, 0);
  FileWrite(l_poignee, l_octet, 1);
  FileClose(l_poignee);
end;

procedure TForm6.efface_1CClick(Sender: TObject);
var l_poignee: Word;
    l_octet: Byte;
begin
{
  l_poignee:= FileOpen('C:\OSCAR\'+ Form1.Table1.TableName, fmOpenReadWrite+ fmShareDenyNone );
}
  l_poignee:= FileOpen('C:\OSCAR\'+ Form1.Table2.TableName, fmOpenReadWrite+ fmShareDenyNone );
  if l_poignee< 0
    then affiche('pb');
  FileSeek(l_poignee, $1C, 0);
  FileRead(l_poignee, l_octet, 1);
  l_octet:= l_octet and $FE;
  FileSeek(l_poignee, $1C, 0);
  FileWrite(l_poignee, l_octet, 1);
  FileClose(l_poignee);
end;

procedure TForm6.DbiRegenIndex_Click(Sender: TObject);
var l_dbi: Integer;
begin
  With Form1 do
  begin
    Table1.Close;
    Table1.Exclusive:= True;
    Table1.Open;

    l_dbi:= DbiRegenIndexes(Form1.Table1.Handle);

    if l_dbi<> 0
      then affiche('pb '+ f_erreur_dbi(l_dbi));

    Table1.Close;
    Table1.Exclusive:= False;
    Table1.Open;
  end;
end;

procedure TForm6.plombe_dbfClick(Sender: TObject);
var l_pt_dbf: t_pt_dbf;
begin
  ouvre_dbf('C:\OSCAR\COPIE_1.DBF', l_pt_dbf);
  lis_fiche_dbf(l_pt_dbf, 1);
  affiche(f_fiche_dbf(l_pt_dbf));

  pChar(f_pt_champ_dbf(l_pt_dbf, 1))[0]:= 'Z';
  ecris_fiche_dbf(l_pt_dbf, 1);

  ferme_dbf(l_pt_dbf);
end;

end.


