(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u__restr *)

unit U__restr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, db, DBTables;

type
  TForm5 = class(TForm)
    ajoute: TButton;
    ordre: TButton;
    ajoute_SQL: TButton;
    type_: TButton;
    BatchMove1: TBatchMove;
    Query1: TQuery;
    supprime: TButton;
    supprime_SQL: TButton;
    type_manuel: TButton;
    procedure ajouteClick(Sender: TObject);
    procedure ordreClick(Sender: TObject);
    procedure ajoute_SQLClick(Sender: TObject);
    procedure supprimeClick(Sender: TObject);
    procedure supprime_SQLClick(Sender: TObject);
    procedure type_Click(Sender: TObject);
    procedure type_manuelClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form5: TForm5;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, u_mainte;

{$R *.DFM}

(*$i ..\..\u\f_errdbi *)
var l_erreur: String;

procedure TForm5.ordreClick(Sender: TObject);
var l_indice_index: Integer;
begin
  With Form1, Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('POIDS', ftFloat, 0, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, True);
    FieldDefs.Add('GRAND', ftBoolean, 0, True);
    FieldDefs.Add('LE_BLOB', ftGraphic, 0, False);
    FieldDefs.Add('NOM', ftString, 10, True);

    Table1.IndexDefs.Update;
    IndexDefs.Clear;
    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if not (ixExpression in Options)
          then Table2.IndexDefs.Add(Name, Fields, Options);

    TRY
      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END;

    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if ixExpression in Options
          then Table2.AddIndex(Name, Expression, Options);

    with BatchMove1 do
    begin
      Source:= Table1;
      Destination:= Table2;
      Mode:= BatAppend;

      Mappings.Clear;
      Mappings.Add('NUMERO');
      Mappings.Add('POIDS=POIDS');
      Mappings.Add('NAISSANCE=NAISSANCE');
      Mappings.Add('GRAND=GRAND');
      Mappings.Add('LE_BLOB=LE_BLOB');
      Mappings.Add('NOM');
    end;

    Try;
      BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    end; (* except *)
  end; (* with *)
end;

procedure TForm5.ajouteClick(Sender: TObject);
var l_indice_index: Integer;
begin
  With Form1, Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;

    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('PRENOM', ftString, 3, True);
    FieldDefs.Add('POIDS', ftFloat, 0, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, True);
    FieldDefs.Add('GRAND', ftBoolean, 0, True);
    FieldDefs.Add('LE_BLOB', ftGraphic, 0, False);

    Table1.IndexDefs.Update;
    IndexDefs.Clear;
    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if not (ixExpression in Options)
          then Table2.IndexDefs.Add(Name, Fields, Options);

    TRY
      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END;

    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if ixExpression in Options
          then Table2.AddIndex(Name, Expression, Options);

    with BatchMove1 do
    begin
      Source:= Table1;
      Destination:= Table2;
      Mode:= BatAppend;

      Mappings.Clear;
      Mappings.Add('NUMERO');
      Mappings.Add('NOM');
      Mappings.Add('POIDS');
      Mappings.Add('NAISSANCE');
      Mappings.Add('GRAND');
      Mappings.Add('LE_BLOB');
    end;

    Try;
      BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    end; (* except *)
  end; (* with *)
end;

procedure TForm5.ajoute_SQLClick(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    DatabaseName:= 'Flix';

    SQL.Clear;
    SQL.Add('ALTER TABLE "COPIE_2.DBF" ');
    SQL.Add('  ADD VILLE CHAR(10) ');
    Try
    ExecSQL;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
  end;
end;

procedure TForm5.supprimeClick(Sender: TObject);
var l_indice_index: Integer;
begin
  With Form1, Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;

    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, True);
    FieldDefs.Add('GRAND', ftBoolean, 0, True);
    FieldDefs.Add('LE_BLOB', ftGraphic, 0, False);

    Table1.IndexDefs.Update;
    IndexDefs.Clear;
    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if not (ixExpression in Options)
          then Table2.IndexDefs.Add(Name, Fields, Options);

    TRY
      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END;

    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if ixExpression in Options
          then Table2.AddIndex(Name, Expression, Options);

    with BatchMove1 do
    begin
      Source:= Table1;
      Destination:= Table2;
      Mode:= BatAppend;

      Mappings.Clear;
      Mappings.Add('NUMERO');
      Mappings.Add('NOM');
      Mappings.Add('NAISSANCE');
      Mappings.Add('GRAND');
      Mappings.Add('LE_BLOB');
    end;

    Try;
      BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    end; (* except *)
  end; (* with *)
end;

procedure TForm5.supprime_SQLClick(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    DatabaseName:= 'Flix';

    SQL.Clear;
    SQL.Add('ALTER TABLE "COPIE_2.DBF" ');
    SQL.Add('  DROP VILLE ');
    Try
      ExecSQL;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
  end;
end;

procedure TForm5.type_Click(Sender: TObject);
begin
  With Form1, Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;

    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('MONTANT', ftInteger, 0, True);
    FieldDefs.Add('LA_DATE', ftString, 3, True);
    FieldDefs.Add('LA_DATE_2', ftString, 12, True);

    dbMemo2.DataSource:= nil;
    CreateTable;

    with BatchMove1 do
    begin
      Source:= Table1;
      Destination:= Table2;
      Mode:= BatAppend;

      Mappings.Clear;
      Mappings.Add('NUMERO');
      Mappings.Add('MONTANT=NOM');
      Mappings.Add('LA_DATE=NAISSANCE');
      Mappings.Add('LA_DATE_2=NAISSANCE');
    end;

    Try;
      BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    end; (* except *)
    affiche('Moved: '+ IntToStr(BatchMove1.MovedCount));
  end; (* with *)
end;

procedure TForm5.type_manuelClick(Sender: TObject);
var l_nombre, l_entier: Integer;
    l_chaine: String;
begin
  With Form1, Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;

    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('MONTANT', ftInteger, 0, True);
    FieldDefs.Add('LA_DATE', ftString, 3, True);
    FieldDefs.Add('LA_DATE_2', ftString, 12, True);

    dbMemo2.DataSource:= nil;
    CreateTable;

    Open;
    Table1.Open;
    Table1.First;
    l_nombre:= 0;
    While not Table1.Eof do
    begin
      Append;
      FieldByName('NUMERO').AsInteger:= Table1.FieldByName('NUMERO').AsInteger;

      l_entier:= -1;
      Try
        l_entier:= Table1.FieldByName('CHAMP').AsInteger;
      Except
        affiche('pb conversion');
      end;
      FieldByName('MONTANT').AsInteger:= l_entier;

      l_chaine:= Table1.FieldByName('NAISSANCE').AsString;
      FieldByName('LA_DATE').AsString:= l_chaine;
      FieldByName('LA_DATE_2').AsString:= l_chaine;

      Post;
      inc(l_nombre);

      Table1.Next;
    end;
    affiche('Nombre '+ IntToStr(l_nombre));
  end; (* with *)
end;

end.
