(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u__table *)

unit U__table;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, db, DBTables;

type
  TForm4 = class(TForm)
    structure: TButton;
    Bat_Copy: TButton;
    Bat_Append: TButton;
    Bat_Update: TButton;
    Bat_Ap_Up: TButton;
    append_: TButton;
    update_: TButton;
    append_update: TButton;
    BatchMove1: TBatchMove;
    struct_dbf: TButton;
    dbiCopyTable_: TButton;
    flux: TButton;
    lz: TButton;
    file_: TButton;
    rename_: TButton;
    DbiPackTable_: TButton;
    plombe_1: TButton;
    procedure structureClick(Sender: TObject);
    procedure Bat_AppendClick(Sender: TObject);
    procedure Bat_CopyClick(Sender: TObject);
    procedure Bat_UpdateClick(Sender: TObject);
    procedure Bat_Ap_UpClick(Sender: TObject);
    procedure struct_dbfClick(Sender: TObject);
    procedure dbiCopyTable_Click(Sender: TObject);
    procedure fluxClick(Sender: TObject);
    procedure lzClick(Sender: TObject);
    procedure file_Click(Sender: TObject);
    procedure rename_Click(Sender: TObject);
    procedure append_Click(Sender: TObject);
    procedure update_Click(Sender: TObject);
    procedure append_updateClick(Sender: TObject);
    procedure DbiPackTable_Click(Sender: TObject);
    procedure plombe_1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form4: TForm4;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, lzExpand, u_mainte;

(*$i ..\..\u\f_errdbi *)
var l_erreur: String;

{$R *.DFM}

procedure TForm4.structureClick(Sender: TObject);
var l_indice_index: Integer;
begin
  With Form1, Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='COPIE_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;
    FieldDefs.Assign(Table1.FieldDefs);
    Table1.IndexDefs.Update;

    IndexDefs.Clear;
{
    IndexDefs.Add('IND_POIDS', 'POIDS', []);
}
{
    IndexDefs.Assign(Table1.IndexDefs);
}
    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if not (ixExpression in Options)
          then Table2.IndexDefs.Add(Name, Fields, Options);

    TRY
      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END;

    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if ixExpression in Options
          then Table2.AddIndex(Name, Expression, Options);
  end;
end;

(*$i i_dbf *)

procedure TForm4.struct_dbfClick(Sender: TObject);
var l_pt_dbf_1: t_pt_dbf;
    l_fichier: File;
    l_indice: Integer;
begin
  with Form1 do
  begin
    ouvre_dbf('C:\OSCAR\'+ Table1.TableName, l_pt_dbf_1);

    l_pt_dbf_1^.en_tete.remplissage[$1C]:= 0;
    System.Assign(l_fichier, 'C:\OSCAR\'+ Table2.TableName);
    Rewrite(l_fichier, 1);
    BlockWrite(l_fichier, l_pt_dbf_1^.en_tete, l_pt_dbf_1^.en_tete.taille_en_tete);
    System.Close(l_fichier);

    ferme_dbf(l_pt_dbf_1);
  end;
end;

procedure TForm4.plombe_1Click(Sender: TObject);
var l_pt_dbf: t_pt_dbf;
begin
  ouvre_dbf('C:\OSCAR\COPIE_1.DBF', l_pt_dbf);
  lis_fiche_dbf(l_pt_dbf, 1);

{
  pChar(f_pt_champ_dbf(l_pt_dbf, 0))[10]:= 'Z';
  pChar(f_pt_champ_dbf(l_pt_dbf, 3))[0]:= 'Z';
}
  pChar(f_pt_champ_dbf(l_pt_dbf, 1))[0]:= 'Z';

  ecris_fiche_dbf(l_pt_dbf, 1);
  ferme_dbf(l_pt_dbf);
end;

procedure TForm4.Bat_AppendClick(Sender: TObject);
begin
  with BatchMove1 do
  begin
    Source:= Form1.Table1;
    Destination:= Form1.Table2;
    Mode:= BatAppend;
  end;

  Try;
    BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    end;
end;

procedure TForm4.Bat_CopyClick(Sender: TObject);
begin
  with Form1, BatchMove1 do
  begin
    Source:= Form1.Table1;
{
    Table2.TableType:= ttParadox;
    Table2.TableName:= 'COPIE_2.DB';
}
    Table2.TableType:= ttdBase;
    Destination:= Form1.Table2;
    Mode:= BatCopy;

  Try;
    BatchMove1.Execute;

    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    end;
  end;
end;

  procedure ajoute(p_table_1, p_table_2: tTable);
    var l_pointeur_1, l_pointeur_2: Pointer;
    begin
      with Form1, p_table_1 do
      begin
        First;
        While not Eof do
        begin
          l_pointeur_1:= ActiveBuffer;

          p_table_2.Append;
          l_pointeur_2:= p_table_2.ActiveBuffer;
          Move(l_pointeur_1^, l_pointeur_2^, RecordSize);
          p_table_2.Post;

          Next;
        end; (* while *)
      end; (* with *)
    end; (* ajoute *)

procedure TForm4.append_Click(Sender: TObject);
begin
  With Form1 do
    ajoute(Table1, Table2);
end;

procedure TForm4.dbiCopyTable_Click(Sender: TObject);
var l_dbi: Integer;
    l_source, l_type, l_destination: array[0..DbiMaxNameLen] OF Char;
begin
  with Form1 do
  begin
    StrPCopy(l_source, Table1.TableName);
    StrPCopy(l_type, 'dBase');
    StrPCopy(l_destination, Table2.TableName);

    l_dbi:= DbiCopyTable(Table1.DbHandle, True, l_source, l_type, l_destination);
    if l_dbi<> 0
      then affiche('pb '+ f_erreur_dbi(l_dbi));
  end;
end;

  Procedure copie_par_flux( Const p_nom_source, p_nom_destination: String);
    Var l_flux_source, l_flux_destination: TFileStream;
    Begin
      l_flux_source:= tFileStream.Create(p_nom_source, fmOpenRead );
      try
        l_flux_destination:= tFileStream.Create(p_nom_destination,
            fmOpenWrite or fmCreate );
        try
          l_flux_destination.CopyFrom(l_flux_source, l_flux_source.Size ) ;
        finally
          l_flux_destination.Free;
        end;
      finally
        l_flux_source.Free;
      end;
    End;

  Procedure copie_par_lz( Const p_nom_source, p_nom_destination: String);
    Var l_fichier_source, l_fichier_destination: File;
    Begin
      AssignFile(l_fichier_source, p_nom_source);
      AssignFile(l_fichier_destination, p_nom_destination);
      Reset(l_fichier_source);

      try
        Rewrite(l_fichier_destination);
        try
          if lzCopy(tFileRec(l_fichier_source).Handle,
              tFileRec(l_fichier_destination).Handle) < 0
            then raise Exception.Create('pr');
        finally
          CloseFile(l_fichier_destination);
        end;
      finally
        CloseFile(l_fichier_source);
      end;
    end; (* copie_par_lz *)

  procedure copie_par_file(Const p_nom_source, p_nom_destination: String);
    Const k_taille_tampon= 48* 1024;
    Type t_tampon= array[0..k_taille_tampon- 1] of Byte;
    Var l_fichier_source, l_fichier_destination: File;
        l_pt_tampon: ^t_tampon;
        l_taille_lu: Word;
    begin
      AssignFile(l_fichier_source, p_nom_source);
      AssignFile(l_fichier_destination, p_nom_destination);
      Reset(l_fichier_source, 1);
      Rewrite(l_fichier_destination, 1);

      New(l_pt_tampon);

      repeat
        BlockRead(l_fichier_source, l_pt_tampon^, k_taille_tampon, l_taille_lu);
        BlockWrite(l_fichier_destination, l_pt_tampon^, l_taille_lu);
      until l_taille_lu< k_taille_tampon;

      Dispose(l_pt_tampon);
      CloseFile(l_fichier_destination);
      CloseFile(l_fichier_source);
    end;

procedure TForm4.fluxClick(Sender: TObject);
begin
  With Form1 do
    copie_par_flux('C:\OSCAR\'+ Table1.TableName, 'C:\OSCAR\'+ Table2.TableName);
end;

procedure TForm4.lzClick(Sender: TObject);
begin
  With Form1 do
  begin
    copie_par_lz('C:\OSCAR\'+ ChangeFileExt(Table1.TableName, '.MDX'),
       'C:\OSCAR\'+ ChangeFileExt(Table2.TableName, '.MDX') );
  end;
end;

procedure TForm4.file_Click(Sender: TObject);
begin
  With Form1 do
  begin
    copie_par_file('C:\OSCAR\'+ ChangeFileExt(Table1.TableName, '.DBT'),
       'C:\OSCAR\'+ ChangeFileExt(Table2.TableName, '.DBT') );
  end;
end;

procedure TForm4.rename_Click(Sender: TObject);
var l_dbi: Integer;
    l_source, l_type, l_destination: array[0..DbiMaxNameLen] OF Char;
begin
  With Form1 do
  begin
    StrPCopy(l_source, Table2.TableName);
    StrPCopy(l_type, 'dBase');
    StrPCopy(l_destination, 'X');

    Table1.Open;
    l_dbi:= DbiRenameTable(Table1.DbHandle, l_source, l_type, l_destination);
    if l_dbi<> 0
      then affiche('pb '+ f_erreur_dbi(l_dbi));
  end;
end;

procedure TForm4.Bat_UpdateClick(Sender: TObject);
begin
  with BatchMove1 do
  begin
    Source:= Form1.Table1;
    Destination:= Form1.Table2;
    Form1.Table2.IndexName:= 'IND_NOM';
    Mode:= BatUpdate;
  end;

  TRY
    BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
  end;

  U_MAINTE.affiche('ChangedCount '+ IntToStr(BatchMove1.ChangedCount));
end;

  procedure mets_a_jour(p_table_1, p_table_2: tTable; p_nom_index: String);
    var l_pointeur_1, l_pointeur_2: Pointer;
    begin
      with Form1, p_table_1 do
      begin
        p_table_2.IndexName:= 'IND_NOM';

        First;
        While not Eof do
        begin
          p_table_2.SetKey;
          p_table_2.FieldByName('NOM').AsString:= FieldByName('NOM').AsString;
          if p_table_2.GotoKey
            then begin
                affiche(FieldByName('NOM').AsString);
                l_pointeur_1:= ActiveBuffer;

                p_table_2.Edit;
                l_pointeur_2:= p_table_2.ActiveBuffer;
                Move(l_pointeur_1^, l_pointeur_2^, RecordSize);
                p_table_2.Post;
              end;

          Next;
        end; (* while *)
      end; (* with *)
    end; (* mets_a_jour *)

procedure TForm4.update_Click(Sender: TObject);
begin
  With Form1 do
    mets_a_jour(Table1, Table2, 'IND_NOM');
end;

procedure TForm4.Bat_Ap_UpClick(Sender: TObject);
begin
  with BatchMove1 do
  begin
    Source:= Form1.Table1;
    Destination:= Form1.Table2;
    Form1.Table2.IndexName:= 'IND_NOM';
    Mode:= BatAppendUpdate;
  end;

  TRY
    BatchMove1.Execute;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
  end;

  U_MAINTE.affiche('ChangedCount '+ IntToStr(BatchMove1.ChangedCount));
end;

  procedure mets_a_jour_ajoute(p_table_1, p_table_2: tTable; p_nom_index: String);
    var l_pointeur_1, l_pointeur_2: Pointer;
    begin
      with Form1, p_table_1 do
      begin
        IndexName:= 'IND_NOM';
        p_table_2.IndexName:= 'IND_NOM';

        First;
        While not Eof do
        begin
          p_table_2.SetKey;
          p_table_2.FieldByName('NOM').AsString:= FieldByName('NOM').AsString;
          if p_table_2.GotoKey
            then begin
                affiche('fusionne '+ FieldByName('NOM').AsString);
                p_table_2.Edit;
              end
            else begin
                affiche('ajoute '+ FieldByName('NOM').AsString);
                p_table_2.Append;
              end;

          l_pointeur_1:= ActiveBuffer;
          l_pointeur_2:= p_table_2.ActiveBuffer;
          Move(l_pointeur_1^, l_pointeur_2^, RecordSize);
          p_table_2.Post;

          Next;
        end; (* while *)
      end; (* with *)
    end; (* mets_a_jour_ajoute *)

procedure TForm4.append_updateClick(Sender: TObject);
begin
  With Form1 do
    mets_a_jour_ajoute(Table1, Table2, 'IND_NOM');
end;

procedure TForm4.DbiPackTable_Click(Sender: TObject);
var l_dbi: Integer;
begin
  with Form1 do
  begin
    Table2.Close;
    Table2.Exclusive:= True;
    Table2.Open;
    l_dbi:= DbiPackTable(Table2.dbHandle, Table2.Handle, nil, nil, True);
    if l_dbi<> 0
      then affiche('pb pack '+ f_erreur_dbi(l_dbi));
  end;
end;

end.



