(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_net2 *)

unit U_net2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    cree: TButton;
    Open_: TButton;
    Close_: TButton;
    Memo1: TMemo;
    lock_list: TButton;
    is_locked: TButton;
    verrouille_tout: TButton;
    teste_verrous: TButton;
    edite: TButton;
    IsShared_: TButton;
    SaveChanges_: TButton;
    de_verrouille_: TButton;
    de_verrou_tout: TButton;
    Refresh_: TButton;
    remplis_4: TButton;
    dir: TButton;
    remplis_120: TButton;
    efface: TButton;
    ReadLock: TButton;
    WriteLock: TButton;
    verrouille_2: TButton;
    verrouille_cle: TButton;
    Timer1: TTimer;
    re_essaye: TButton;
    Timer2: TTimer;
    LockTable: TButton;
    UnlockTable: TButton;
    exclusive: TButton;
    pas_exclusif: TButton;
    procedure creeClick(Sender: TObject);
    procedure Open_Click(Sender: TObject);
    procedure Close_Click(Sender: TObject);
    procedure lock_listClick(Sender: TObject);
    procedure is_lockedClick(Sender: TObject);
    procedure verrouille_toutClick(Sender: TObject);
    procedure teste_verrousClick(Sender: TObject);
    procedure editeClick(Sender: TObject);
    procedure IsShared_Click(Sender: TObject);
    procedure SaveChanges_Click(Sender: TObject);
    procedure de_verrouille_Click(Sender: TObject);
    procedure de_verrou_toutClick(Sender: TObject);
    procedure Refresh_Click(Sender: TObject);
    procedure remplis_4Click(Sender: TObject);
    procedure dirClick(Sender: TObject);
    procedure effaceClick(Sender: TObject);
    procedure remplis_120Click(Sender: TObject);
    procedure ReadLockClick(Sender: TObject);
    procedure WriteLockClick(Sender: TObject);

    procedure verrouille_2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Table1BeforeEdit(DataSet: TDataset);
    procedure Table1AfterPost(DataSet: TDataset);
    procedure verrouille_cleClick(Sender: TObject);
    procedure re_essayeClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure LockTableClick(Sender: TObject);
    procedure UnlockTableClick(Sender: TObject);
    procedure exclusiveClick(Sender: TObject);
    procedure pas_exclusifClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

  (*$i ..\..\u\f_errdbi *)
  var l_erreur: String;

(* -- affichage *)

const vi_nombre: Integer= 1;

function f_espaces(p_nombre: Integer): String;
  begin
  end; (* f_espaces *)

procedure affiche(p_texte: String);
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_ligne;
 begin
   Form1.Memo1.Lines.Add('');
 end;

procedure affiche_indente(p_indente: Integer; p_texte: String);
  begin
    Form1.Memo1.Lines.Add(Format('%2d %'+ IntToStr(p_indente)+ 's %s ', [vi_nombre, '', p_texte]));
    inc(vi_nombre);
  end;

function f_booleen(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen:= 'vrai'
      else f_booleen:= 'faux';
  end;

(* -- cration *)

procedure TForm1.creeClick(Sender: TObject);
var l_indice: Integer;
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableName:= 'RESEAU.DBF';
    TableType:= ttdBase;

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('MONTANT', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;
  end;
end;

procedure TForm1.remplis_4Click(Sender: TObject);
begin
  With Table1 do
  begin
    Open;

    AppendRecord([1, 'MARTIN']);
    AppendRecord([2, 'DUBOIS']);
    AppendRecord([3, 'MERLIN']);
    AppendRecord([4, 'JEROME']);
  end;
end;

procedure TForm1.remplis_120Click(Sender: TObject);
var l_indice: Integer;
begin
  With Table1 do
  begin
    Open;

    AppendRecord([1, 'MARTIN']);
    AppendRecord([2, 'DUBOIS']);
    AppendRecord([3, 'MERLIN']);
    AppendRecord([4, 'JEROME']);
    for l_indice:= 5 to 105 do
      AppendRecord([l_indice]);
  end;
end;

procedure TForm1.Open_Click(Sender: TObject);
begin
  Table1.Open;
end;

procedure TForm1.Close_Click(Sender: TObject);
begin
  Table1.Close;
end;

procedure TForm1.effaceClick(Sender: TObject);
begin
  Table1.DeleteTable;
end;

procedure TForm1.SaveChanges_Click(Sender: TObject);
begin
  DbiSaveChanges(Table1.Handle);
end;

procedure TForm1.IsShared_Click(Sender: TObject);
var l_dbi: Integer;
    l_partagee: Bool;
begin
  if Table1.Active
    then begin
        l_dbi:= DbiIsTableShared(Table1.Handle, l_partagee);
        affiche('Partagee: '+ f_booleen(l_partagee));
      end;
end;

  procedure affiche_dir(p_table: tTable; p_chaines: tStrings);
    var l_entree: tSearchRec;
        l_nom: String;
    begin
      affiche_ligne;
      l_nom:= 'C:\OSCAR\'+ p_table.TableName;

      affiche('Il est: '+ DateTimeToStr(Now)+ ' '+ l_nom);

      if FindFirst(ChangeFileExt(l_nom, '.DBF'), faAnyFile, l_entree)= 0
        then affiche(p_table.TableName+ ' '+ TimeToStr(FileDateToDateTime(l_entree.Time))+ ' '+ IntToStr(l_entree.Size));
    end; (* affiche_dir *)

procedure TForm1.dirClick(Sender: TObject);
begin
  affiche_dir(Table1, Memo1.Lines);
end;

(* -- rafraichissement *)

procedure TForm1.Refresh_Click(Sender: TObject);
begin
  Table1.Refresh;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
{
  affiche('Refresh');
}
{
  If Table1.Active
    then Table1.Refresh;
}
end;

procedure TForm1.Table1BeforeEdit(DataSet: TDataset);
begin
  Timer1.Enabled:= False;
  Timer2.Enabled:= True;
end;

procedure TForm1.Table1AfterPost(DataSet: TDataset);
begin
  Timer1.Enabled:= True;
  Timer2.Enabled:= False;
end;

(* -- *.NET *)

(* -- verrous *)

procedure TForm1.editeClick(Sender: TObject);
begin
  Try
    Table1.Edit
  except
      on e: eConvertError do
        ShowMessage('OK');
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          affiche(IntToStr(ErrorCount));
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            DbiErr_Locked : l_erreur:= 'aaaaa';
            else l_erreur:= '?? '+ e.Message;
          end;

          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ + '>'+ f_erreur_dbi(ErrorCode)+ '<'+ e.Message
            + IntToStr(NativeError));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
end;

procedure TForm1.WriteLockClick(Sender: TObject);
var l_dbi: Integer;
begin
  With Table1 do
  begin
    UpdateCursorPos;
    l_dbi:= DbiGetRecord(Handle, dbiWriteLock, nil, nil);
    if l_dbi<> 0
      then affiche('WriteLock '+ f_erreur_dbi(l_dbi));
  end;
end;

procedure TForm1.ReadLockClick(Sender: TObject);
var l_dbi: Integer;
begin
  With Table1 do
  begin
    UpdateCursorPos;
    l_dbi:= DbiGetRecord(Handle, dbiReadLock, nil, nil);
    if l_dbi<> 0
      then affiche('ReadLock '+ f_erreur_dbi(l_dbi));
  end;
end;

procedure TForm1.is_lockedClick(Sender: TObject);
var l_dbi: Integer;
    l_verrouille: Bool;
begin
  With Table1 do
    if Active
      then begin
         (* -- ne teste que NOS verrous *)
         UpdateCursorPos;
         l_dbi:= DbiIsRecordLocked(Handle, l_verrouille);
         if l_dbi= 0
           then affiche(FieldByName('NOM').AsString+ ' '+ f_booleen(l_verrouille))
       end
     else affiche('ferme');
end;

procedure TForm1.de_verrouille_Click(Sender: TObject);
var l_dbi: Integer;
begin
  Table1.UpdateCursorPos;
  l_dbi:= DbiRelRecordLock(Table1.Handle, False);
  if l_dbi<> 0
    then affiche('pb '+ Table1.FieldByName('NOM').AsString+ ' '+ f_erreur_dbi(l_dbi) );
end;

(* -- plusieurs verrous *)

procedure TForm1.lock_listClick(Sender: TObject);
const vi_verrou: array[0..9] of String= ('RecLock', 'PxReadRecLock',
    'PxGroupLock', 'PxImageArea',
    'TableReg', 'TableRead', 'TableWrite', 'TableExcl', '?', 'Unknown');
var l_dbi: Integer;
    l_curseur_verrou: hDbiCur;
    l_verrou: LockDesc;
    l_nombre: Integer;
begin
  if Table1.Active
    then begin
{
        if Table1.TableType= ttdBase
          then l_dbi:= DbiOpenLockList(Table1.Handle, False, True, l_curseur_verrou)
          else l_dbi:= DbiOpenLockList(Table1.Handle, True, True, l_curseur_verrou);
}
        l_dbi:= DbiOpenLockList(Table1.Handle, False, False, l_curseur_verrou);

        affiche_ligne;
        if l_dbi= 0
          then begin
              l_nombre:= 0;
              While DbiGetNextRecord(l_curseur_verrou, DbiNoLock, @l_verrou, NIL)= 0 do
              begin
                with l_verrou do
                  affiche(Format('%-10s %-8s NS %1d, S %1d E %2d',
                      [vi_verrou[iType], StrPas(szUserName), iNetSession, iSession, iRecNum]));
                if l_verrou.iType= 0
                  then inc(l_nombre);
              end; (* while *)
              affiche('nombre RecLock: '+ IntToStr(l_nombre));
            end
          else affiche('pas pu ouvrir '+ f_erreur_dbi(l_dbi));
      end
    else affiche('pas ouverte');
end;

procedure TForm1.verrouille_toutClick(Sender: TObject);
var l_dbi: Integer;
    l_nombre_verrouilles, l_nombre_probleme: Integer;
begin
  With Table1 do
  begin
    DisableControls;

    First;
    l_nombre_verrouilles:= 0; l_nombre_probleme:= 0;
    While Not Eof do
    begin
      UpdateCursorPos;
      l_dbi:= DbiGetRecord(Handle, dbiWriteLock, nil, nil);
      if l_dbi= 0
        then inc(l_nombre_verrouilles)
        else begin
            inc(l_nombre_probleme);
            affiche('pb lock '+ f_erreur_dbi(l_dbi));
          end;

      Next;
    end; (* while *)

    EnableControls;
    affiche('verr: '+ IntToStr(l_nombre_verrouilles)+ ', pb: '+IntToStr(l_nombre_probleme));
  end;
end;

procedure TForm1.teste_verrousClick(Sender: TObject);
var l_dbi: Integer;
    l_verrouille: Bool;
    l_nombre_verrouilles, l_nombre_non_verrouilles, l_nombre_probleme: Integer;
begin
  With Table1 do
    if Active
      then begin
          DisableControls;

          First;
          l_nombre_verrouilles:= 0; l_nombre_non_verrouilles:= 0; l_nombre_probleme:= 0;
          While Not Eof do
          begin
            UpdateCursorPos;
            l_dbi:= DbiIsRecordLocked(Handle, l_verrouille);
            if l_dbi= 0
              then begin
                  if l_verrouille
                    then begin
                        inc(l_nombre_verrouilles);
                        affiche(FieldByName('NOM').AsString+ ' '+ f_booleen(l_verrouille));
                      end
                    else inc(l_nombre_non_verrouilles);
                end
              else begin
                  inc(l_nombre_probleme);
                  affiche('pb '+ f_erreur_dbi(l_dbi));
                end;
            Next;
          end; (* while *)

          EnableControls;
          affiche('verr: '+ IntToStr(l_nombre_verrouilles)
              + ', non verr: '+ IntToStr(l_nombre_non_verrouilles)
              + ', pb: '+IntToStr(l_nombre_probleme));
        end
      else affiche('fermee');
end;

procedure TForm1.de_verrou_toutClick(Sender: TObject);
var l_dbi: Integer;
begin
  With Table1 do
  begin
    DisableControls;

    UpdateCursorPos;
    l_dbi:= DbiRelRecordLock(Table1.Handle, True); (* TOUS *)
    if l_dbi<> 0
      then affiche('pb '+ f_erreur_dbi(l_dbi) );

    EnableControls;
  end;
end;

(* -- traitements *)

  procedure verrouille(p_table: tTable);
    var l_dbi: Integer;
    begin
      With p_table do
      begin
        DisableControls;

        UpdateCursorPos;
        l_dbi:= DbiGetRecord(Handle, dbiWriteLock, nil, nil);
        if l_dbi<> 0
          then affiche('pb lock '+ f_erreur_dbi(l_dbi));

        EnableControls;
      end;
    end; (* verrouille *)

  procedure de_verrouille(p_table: tTable);
    var l_dbi: Integer;
    begin
      With p_table do
      begin
        DisableControls;

        UpdateCursorPos;
        l_dbi:= DbiRelRecordLock(Handle, False);
        if l_dbi<> 0
          then affiche('pb Rellock '+ f_erreur_dbi(l_dbi));

        EnableControls;
      end;
    end; (* de_verrouille *)

procedure TForm1.verrouille_2Click(Sender: TObject);
var l_nom: String;
    l_dbi: Integer;
begin
  with Table1 do
  begin
    (* -- pose les verrous sur 1 et 3 *)
    First;
    verrouille(Table1);
    Next;
    Next;
    verrouille(Table1);

    (* -- passe en majuscule *)
    Refresh;
    First;

    UpdateCursorPos;
    affiche(LowerCase(FieldByName('NOM').AsString) );
    l_nom:= LowerCase(FieldByName('NOM').AsString)+ chr(0);
    l_dbi:= DbiPutField(Handle, 2, ActiveBuffer, @l_nom[1]);
    if l_dbi<> 0
      then affiche('pb Put '+ f_erreur_dbi(l_dbi));
    l_dbi:= DbiModifyRecord(Handle, ActiveBuffer, False);
    if l_dbi<> 0
      then affiche('pb Modif '+ f_erreur_dbi(l_dbi));
    affiche_ligne;

    Next;
    Next;

    UpdateCursorPos;
    affiche(LowerCase(FieldByName('NOM').AsString) );
    l_nom:= LowerCase(FieldByName('NOM').AsString)+ chr(0);
    l_dbi:= DbiPutField(Handle, 2, ActiveBuffer, @l_nom[1]);
    if l_dbi<> 0
      then affiche('pb Put '+ f_erreur_dbi(l_dbi));
    l_dbi:= DbiModifyRecord(Handle, ActiveBuffer, False);
    if l_dbi<> 0
      then affiche('pb Modif '+ f_erreur_dbi(l_dbi));
    affiche_ligne;

    (* -- dverrouille *)
    First;
    de_verrouille(Table1);
    Next;
    Next;
    de_verrouille(Table1);
  end; (* with Table1 *)
end;

(* -- avec gestion des erreurs *)

(* Class(Exception) *)

  type t_exception_trouve= Class(Exception);
       t_exception_verrouille= Exception;
       t_exception_GetRecord= Exception;
       t_exception_PutField= Exception;
       t_exception_modifie_cle= Exception;
       t_exception_Modify= Exception;

  function f_verrouille_cle(p_table: tTable; p_cle: String): Boolean;
    var l_dbi: Integer;
    begin
      With p_table do
        try
          Result:= False;
          DisableControls;
          if FindKey([p_cle])
            then begin
                UpdateCursorPos;
                l_dbi:= DbiGetRecord(Handle, dbiWriteLock, nil, nil);
                if l_dbi= 0
                  then result:= True
                  else raise t_exception_verrouille.Create('Verr. Pb verrouille '+ p_cle);
              end
            else raise t_exception_trouve.Create('Verr. Pas trouv '+ p_cle);
        Finally
          EnableControls;
        end;
    end; (* f_verrouille_cle *)

  function f_verrouille_cle_delai(p_table: tTable; p_cle: String; p_delai, p_essai_max: LongInt): Boolean;
    var l_dbi: Integer;
        l_ticks, l_essai: LongInt;
    begin
      With p_table do
        try
          Result:= False;
          DisableControls;

          if FindKey([p_cle])
            then begin
                l_essai:= 0;
                repeat
                  (* -- OBLIGATOIRE ICI *)
                  UpdateCursorPos;
                  l_dbi:= DbiGetRecord(Handle, dbiWriteLock, nil, nil);
                  if l_dbi<> 0
                    then begin
                        affiche('  essaye '+ IntToStr(l_essai)+ ' '+ IntToStr(p_essai_max));
                        l_ticks:= GetTickCount;
                        while GetTickCount- l_ticks< p_delai do
                          Application.ProcessMessages;
                        inc(l_essai);
                      end;

                  affiche(IntToStr(l_dbi)+ ' '+ IntToStr(l_essai)+ ' '+ f_booleen(l_essai> p_essai_max));

                until (l_dbi= 0) or (l_essai> p_essai_max);

                affiche('fin '+ IntToStr(l_essai));

                if l_dbi= 0
                  then result:= True
                  else raise t_exception_verrouille.Create('Verr. Pb verrouille '+ p_cle);
              end
            else raise t_exception_trouve.Create('Verr. Pas trouv '+ p_cle);
        Finally
          EnableControls;
        end;
    end; (* f_verrouille_cle_delai *)

  function f_modifie_cle(p_table: tTable; p_cle: String; CONST p_champs: array of Const): Boolean;
    type t_pt_float= ^Double;
    var l_dbi: Integer;
        l_pt_tampon: Pointer;
        l_indice: Integer;
        l_reel: Double;
        l_chaine: String;
    begin
      With p_table do
        Try
          DisableControls;
          Result:= False;
          GetMem(l_pt_tampon, RecordSize);

          if FindKey([p_cle])
            then begin
                UpdateCursorPos;
                (* -- lis l'enregistrement *)
                l_dbi:= DbiGetRecord(Handle, DbiNoLock, l_pt_tampon, nil);
                if l_dbi<> 0
                  then raise t_exception_getrecord.Create('peut pas lire record');

                For l_indice:= 0 to FieldCount- 1 do
                  with Fields[l_indice], p_champs[l_indice] do
                    if IsIndexField
                      then { raise t_exception_modifie_cle.Create('Verr. Pas trouv '+ p_cle) }
                      else begin
                          case DataType of
                            ftFloat : begin
                                        case vType of
                                          vtInteger : l_reel:= vInteger;
                                          vtExtended : l_reel:= vExtended^;
                                          else affiche('pas bon type ftFloat');
                                        end; (* case *)

                                        affiche(FloatToStr(l_reel));
                                        l_dbi:= DbiPutField(Handle, l_indice+ 1, l_pt_tampon, @l_reel);
                                      end;
                            ftString : begin
                                         case vType of
                                           vtString : l_chaine:= vString^;
                                           else affiche('pas bon type ftString');
                                         end; (* case *)

                                         l_chaine:= l_chaine+ chr(0);
                                         l_dbi:= DbiPutField(Handle, l_indice+ 1, l_pt_tampon, @l_chaine[1]);
                                       end;
                            else affiche('pas implment');
                          end; (* case *)

                          if l_dbi<> 0
                            then raise t_exception_PutField.Create('Modif. Pb PutField '+ p_cle);
                        end; (* For, with Fields *)

                l_dbi:= DbiModifyRecord(Handle, l_pt_tampon, False);
                if l_dbi= 0
                  then Result:= True
                  else raise t_exception_ModiFy.Create('Modif. Pb Modify '+ p_cle);
              end (* a trouv *)
            else raise t_exception_trouve.Create('Modif. Pas trouv '+ p_cle);

      Finally
        FreeMem(l_pt_tampon, RecordSize);
        EnableControls;
        affiche('Modif OK '+ p_cle);
      end;
    end; (* f_modifie_cle *)

  function f_de_verrouille_cle(p_table: tTable; p_cle: String): String;
    var l_dbi: Integer;
    begin
      With p_table do
      begin
        DisableControls;
        Result:= '';

        if FindKey([p_cle])
          then begin
              UpdateCursorPos;
              l_dbi:= DbiRelRecordLock(Handle, False);
              if (l_dbi<> 0) and (l_dbi<> DbiErr_NotLocked)
                then Result:= 'Dever. Pb RelRecLock '+ f_erreur_dbi(l_dbi)+ p_cle;
            end
          else Result:= 'Dver. Pas trouv '+ p_cle;

        EnableControls;
      end;
    end; (* f_deverrouille_cle *)

procedure TForm1.verrouille_cleClick(Sender: TObject);
var l_deverrouille: String;
begin
  with Table1 do
  begin
{
    (* -- pose les verrous sur 1 et 2 *)
    IndexName:= 'IND_NOM';

    if not f_verrouille_cle(Table1, 'DUBOIS')
      then affiche('pb verrouille');
    if not f_verrouille_cle(Table1, 'JEROME')
      then affiche('pb verrouille');

    if FindKey(['DUBOIS'])
      then
        if not f_modifie_cle(Table1, 'DUBOIS', [FieldByName('NUMERO').AsInteger+ 1, FieldByName('NOM').AsString])
          then affiche('pb modifie');

    f_de_verrouille_cle(Table1, 'DUBOIS');
    f_de_verrouille_cle(Table1, 'JEROME');

    IndexName:= '';
}
    (* -- pose les verrous sur DUBOIS et JEROME *)
    IndexName:= 'IND_NOM';

    try
      Try
        f_verrouille_cle(Table1, 'DUBOIS');
        f_verrouille_cle(Table1, 'JEROME');

        if FindKey(['DUBOIS'])
          then f_modifie_cle(Table1, 'DUBOIS', [FieldByName('NUMERO').AsInteger, FieldByName('NOM').AsString,
              FieldByName('MONTANT').AsFloat- 50]);
        if FindKey(['JEROME'])
          then f_modifie_cle(Table1, 'JEROME', [FieldByName('NUMERO').AsInteger, FieldByName('NOM').AsString,
              FieldByName('MONTANT').AsFloat+ 50]);
      except
        on e: t_exception_trouve do affiche(e.Message);
        on e: t_exception_verrouille do affiche(e.Message);
        on e: t_exception_getrecord do affiche(e.Message);
        on e: t_exception_PutField do affiche(e.Message);
        on e: t_exception_modifie_cle do affiche(e.Message);
        on e: t_exception_Modify do affiche(e.Message);
        else affiche('pb inconnu');
      end;
    finally
      l_deverrouille:= f_de_verrouille_cle(Table1, 'DUBOIS')
        + f_de_verrouille_cle(Table1, 'JEROME');
      if l_deverrouille<> ''
        then affiche(l_deverrouille);
    end;

    IndexName:= '';
  end;
end;

procedure TForm1.re_essayeClick(Sender: TObject);
var l_dbi: Integer;
begin
  with Table1 do
  begin
    (* -- pose les verrous sur DUBOIS et JEROME *)
    IndexName:= 'IND_NOM';

    try
      Try
        f_verrouille_cle_delai(Table1, 'DUBOIS', 3000, 5);
        f_verrouille_cle_delai(Table1, 'JEROME', 3000, 5);

        if FindKey(['DUBOIS'])
          then f_modifie_cle(Table1, 'DUBOIS', [FieldByName('NUMERO').AsInteger, FieldByName('NOM').AsString,
              FieldByName('MONTANT').AsFloat- 50]);
        if FindKey(['JEROME'])
          then f_modifie_cle(Table1, 'JEROME', [FieldByName('NUMERO').AsInteger, FieldByName('NOM').AsString,
              FieldByName('MONTANT').AsFloat+ 50]);
      except
        on e: t_exception_trouve do affiche(e.Message);
        on e: t_exception_verrouille do affiche(e.Message);
        on e: t_exception_getrecord do affiche(e.Message);
        on e: t_exception_PutField do affiche(e.Message);
        on e: t_exception_modifie_cle do affiche(e.Message);
        on e: t_exception_Modify do affiche(e.Message);
        else
          affiche('pb inconnu');
      end;
    finally
      l_dbi:= DbiRelRecordLock(Table1.Handle, True); (* TOUS *)
      if l_dbi<> 0
        then affiche('pb '+ f_erreur_dbi(l_dbi) );
    end;

    IndexName:= '';
  end; (* with *)
end;

(* -- Gone To Lunch *)

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  If Table1.State in [dsEdit, dsInsert]
    then begin
        affiche('fusille dsEdit');
        Table1.Cancel;
        Timer2.Enabled:= False;
      end;
end;

procedure TForm1.LockTableClick(Sender: TObject);
begin
  Try
    Table1.LockTable(ltWriteLock);
  except
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
end;

procedure TForm1.UnlockTableClick(Sender: TObject);
begin
  Try
    Table1.UnLockTable(ltWriteLock);
  except
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
end;

procedure TForm1.exclusiveClick(Sender: TObject);
begin
  Try
{
    Table1.Close;
}
    Table1.Exclusive:= True;
  except
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
  affiche('open');
  Try
    Table1.Open;
  except
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
end;

procedure TForm1.pas_exclusifClick(Sender: TObject);
begin
  Table1.Close;
  Table1.Exclusive:= False;
end;

end.


