(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_netlck *)

unit U_netlck;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    lck_net: TButton;
    noms_dir: TButton;
    cree_px: TButton;
    Table1: TTable;
    procedure noms_dirClick(Sender: TObject);
    procedure lck_netClick(Sender: TObject);
    procedure cree_pxClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(* -- affichage *)

const vi_nombre: Integer= 1;

procedure affiche(p_texte: String);
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_ligne;
 begin
   Form1.Memo1.Lines.Add('');
 end; (* affiche_ligne *)

(* -- NetDir PrivateDir *)

procedure TForm1.noms_dirClick(Sender: TObject);
begin
  affiche('NetFileDir: '+ Session.NetFileDir);
  affiche('PrivateDir: '+ Session.PrivateDir);
end;

(* -- dir *)

  function f_erreur_dos(p_code: Integer): String;
    begin
      case p_code of
        0 : f_erreur_dos:= 'sans erreur';
        1 : f_erreur_dos:= 'numro fonctin DOS incorrect';
        2 : f_erreur_dos:= 'pas trouv fichier';
        3 : f_erreur_dos:= 'pas trouv chemin';
        4 : f_erreur_dos:= 'trop de fichiers ouverts';
        5 : f_erreur_dos:= 'poigne fichier incorrecte';
        12 : f_erreur_dos:= 'accs  ce type de fichier incorrect';
        15 : f_erreur_dos:= 'lecteur incorrect';
        16 : f_erreur_dos:= 'peut pas supprimer rpertoire';
        17 : f_erreur_dos:= 'peut pas renommer d''un rpertioire  un autre';
        18 : f_erreur_dos:= 'plus de fichiers';
        else f_erreur_dos:= '?? '+ IntToStr(p_code);
      end; (* case *)
    end; (* f_erreur_dos *)

  procedure affiche_indente_entree(p_indente: Integer; p_entree: tSearchRec);
    begin
      with p_entree do
      begin
        Form1.Memo1.Lines.Add(Format('%'+ IntToStr(2)+ 's %-12s %7d',
            ['', Name, Size]) );
        Form1.Memo1.Lines.Add(Format('%'+ IntToStr(4)+ 's',
            [''])+ DateTimeToStr(FileDateToDateTime(Time)) );
      end;
    end;

  procedure affiche_fichier(p_chemin: String; p_masque: String; p_niveau: Integer);
    var l_entree: tSearchRec;
        l_erreur: Integer;

    procedure affiche_erreur(p_texte: String);
      begin
        if l_erreur<> -18
          then affiche(p_texte+ IntToStr(l_erreur)+ ' '+ f_erreur_dos(-l_erreur));
      end;

    begin
      (* -- affiche les fichiers mais pas les DIR *)
      l_erreur:= findfirst(p_chemin+ p_masque, faArchive { $39 and not faDirectory }, l_entree);
      if l_erreur<> 0
        then affiche_erreur('db ')
        else begin
            while l_erreur= 0 do
            begin
              affiche(p_chemin);
              affiche_indente_entree(p_niveau, l_entree);

             (* -- le fichier suivant de ce sous-rpertoire *)
             l_erreur:= findnext(l_entree);
            end; (* tant qu'il y a des entres dans cette table *)
          end;

      (* -- affiche les fichiers mais pas les DIR *)
      l_erreur:= findfirst(p_chemin+ '*.lck', faArchive { $39 and not faDirectory }, l_entree);
      if l_erreur<> 0
        then affiche_erreur('db ')
        else begin
            while l_erreur= 0 do
            begin
              affiche(p_chemin);
              affiche_indente_entree(p_niveau, l_entree);

             (* -- le fichier suivant de ce sous-rpertoire *)
             l_erreur:= findnext(l_entree);
            end; (* tant qu'il y a des entres dans cette table *)
          end;

      (* -- les sous-rpertoires *)
      l_erreur:= findfirst(p_chemin+ '*.', faDirectory, l_entree);
      if l_erreur<> 0
        then affiche_erreur('db ')
        else begin
            while l_erreur= 0 do
            begin
              if (l_entree.attr and faDirectory<> 0) and (l_entree.Name<> '.') and (l_entree.Name<> '..')
                then affiche_fichier(p_chemin+ l_entree.Name+ '\', p_masque, p_niveau+ 2);

              (* -- le fichier suivant de ce sous-rpertoire *)
              l_erreur:= findnext(l_entree);
            end; (* tant qu'il y a des entres dans cette table *)
          end;
    end; (* affiche_fichier *)


procedure TForm1.lck_netClick(Sender: TObject);
begin
  affiche_fichier('\', '*.net', 0);
  affiche('fin');
end;

procedure TForm1.cree_pxClick(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttParadox;
    TableName:='RESEAU.DB';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);

    CreateTable;

    Open;

    AppendRecord([1]);
  end;
end;

end.


