(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_tradbx *)

unit U_tradbx;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    cree_2: TButton;
    cree: TButton;
    Table3: TTable;
    DataSource3: TDataSource;
    DBGrid3: TDBGrid;
    Memo1: TMemo;
    demarre: TButton;
    recopie: TButton;
    annule: TButton;
    reprise: TButton;
    Table2NUMERO: TFloatField;
    Table2NOM: TStringField;
    Table2MONTANT: TFloatField;
    procedure cree_2Click(Sender: TObject);
    procedure creeClick(Sender: TObject);
    procedure DBGrid2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBGrid2Exit(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure demarreClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DataSource2DataChange(Sender: TObject; Field: TField);
    procedure recopieClick(Sender: TObject);
    procedure repriseClick(Sender: TObject);
    procedure deverrouilleClick(Sender: TObject);
    procedure annuleClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

(* -- cration *)

procedure TForm1.creeClick(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='RESEAU.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('MONTANT', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NUMERO', 'NUMERO', []);
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;
    IndexName:= 'IND_NUMERO';

    Open;

    AppendRecord([1, 'MARTIN', 51.300]);
    AppendRecord([2, 'DUBOIS', 91.300]);
    AppendRecord([3, 'BELIN', 60]);
    AppendRecord([4, 'URSULE', 51.300]);
    AppendRecord([5, 'SCHMITT', 123]);
  end;
end;

procedure TForm1.cree_2Click(Sender: TObject);
var l_indice_index: Integer;
begin
  With Form1, Table2 do
  begin
    Table3.Close;

    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='RES_2.DBF';

    Table1.FieldDefs.Update;
    FieldDefs.Clear;
    FieldDefs.Assign(Table1.FieldDefs);
    Table1.IndexDefs.Update;

    IndexDefs.Clear;
    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if not (ixExpression in Options)
          then Table2.IndexDefs.Add(Name, Fields, Options);

    CreateTable;

    For l_indice_index:= 0 to Table1.IndexDefs.Count- 1 do
      with Table1.IndexDefs[l_indice_index] do
        if ixExpression in Options
          then Table2.AddIndex(Name, Expression, Options);
    IndexName:= 'IND_NUMERO';
    Open;
  end;
end;

procedure TForm1.demarreClick(Sender: TObject);
begin
  affiche(''); affiche('dmarre');
  Table1.Open;
  cree_2Click(nil);
  Table3.Open;
end;

(* -- verrouillage *)

  type t_exception= Class(Exception);

  procedure verrouille_cle(p_table: tTable; p_cle: Integer);
    var l_dbi: Integer;
    begin
      affiche('    verrouille '+ IntToStr(p_cle));
      With p_table do
        try
          DisableControls;
          if FindKey([p_cle])
            then begin
                UpdateCursorPos;
                l_dbi:= DbiGetRecord(Handle, dbiWriteLock, nil, nil);
                if l_dbi<> 0
                  then raise t_exception.Create('    Verr. Pb verrou '+ IntToStr(p_cle));
              end
            else raise t_exception.Create('    Verr. Pas trouv '+ IntToStr(p_cle));
        Finally
          EnableControls;
        end;
    end; (* verrouille_cle *)

(* -- gestion des 2 grilles *)

  procedure positionne;
    begin
      with Form1 do
      begin
        affiche('    positionne');
        (* -- positionne dbgrid2 *)
        dbGrid2.Left:= dbGrid1.Left+ 20;

        with tDrawGrid(dbGrid1) do
          dbGrid2.Top:= Top+ CellRect(Col, Row).Top+ 2;

        dbGrid2.Visible:= True;
        dbGrid2.SetFocus;

        Table2.Fields[0].ReadOnly:= True;
      end;
    end; (* positionne *)

  const vi_trouve: Boolean= False;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if Table2.Active and (Table1.State= dsBrowse)
    then begin
        affiche('  DataChange1 '+ Table1.FieldByName('NUMERO').AsString);
        if Table1.State= dsInsert
          then affiche('   INS');
        if Table1.Eof
          then affiche('    EOF');
        if Table1.Bof
          then affiche('    BOF');
        Table2.Open;

        if not Table1.Eof and (Table2.FindKey([Table1.FieldByName('NUMERO').AsInteger]))
          then begin
              affiche('    ok: '+ Table2.FieldByName('NUMERO').AsString);
              vi_trouve:= True;
              positionne;
            end
          else vi_trouve:= false;
      end;
end;

  procedure ajoute;
    var l_champ: Integer;
    begin
      With Form1, Table1 do
      begin
        affiche('    ajoute '+ Fields[0].AsString);

        Table2.Append;

        For l_champ:= 0 to FieldCount- 1 do
          Table2.Fields[l_champ].Assign(Fields[l_champ]);

        Table2.Post;
      end;
    end; (* ajoute *)

procedure TForm1.DBGrid1KeyPress(Sender: TObject; var Key: Char);
var l_dbi: Integer;
begin
  affiche('  KeyPress');
  Try
    (* -- si Table2 ne contient pas dj une copie *)
    if not vi_trouve
      then begin
          (* -- pose le verrou *)
          verrouille_cle(Table1, Table1.FieldByName('NUMERO').AsInteger);

          (* -- cre enregistrement2, et copie enregistrement1 *)
          ajoute;

          (* -- donne le focus  dbGrid2 *)
          positionne;
        end;
{
    SendMessage(dbGrid2.Handle, wm_Char, Ord(Key), 0);
}
  except
    on e: t_exception do
      begin
        affiche(E.message);
        dbGrid1.Enabled:= False;
        recopie.Enabled:= False;
        reprise.Enabled:= True;
        deverrouilleClick(nil);
      end;
  end; (* try *)

  (* -- annule la suite sur Table1 *)
  SysUtils.Abort;
end;

function f_code_virtuel(p_code: Word): String;
  begin
    case p_code of
      vk_Right : result:= 'vk_Right';
      vk_Left : result:= 'vk_Left';

      vk_Up : result:= 'vk_Up';
      vk_Down : result:= 'vk_Down';

      vk_Prior : result:= 'vk_Prior';
      vk_Next : result:= 'vk_Next';

      vk_Shift : result:= 'vk_Shift';

      vk_Insert : Result:= 'vk_Insert';

      vk_tab : result:= 'vk_tab';
      vk_Return : result:= 'vk_Return';

      Ord('A')..Ord('Z') : Result:= 'vk_'+ chr(p_code);

      else Result:= 'vk_'+ IntToStr(p_code);
    end;
  end; (* f_code_virtuel *)

procedure TForm1.DBGrid2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche('  '+ f_code_virtuel(Key) + ' '+ Table1.Fields[0].AsString+ '<');
  case Key of
    vk_Up : begin
              if not Table1.Bof
                then begin
                    dbGrid1.SetFocus;
                    SendMessage(dbGrid1.Handle, wm_KeyDown, vk_up, 0);
                  end;
              Key:= 0;
            end;
    vk_Down : begin
{
                if not Table1.Eof
                  then
}
                    begin
                      dbGrid1.SetFocus;
                      SendMessage(dbGrid1.Handle, wm_KeyDown, vk_down, 0);
                    end;
                Key:= 0;
              end;
  end;
end;

procedure TForm1.DBGrid2Exit(Sender: TObject);
begin
  dbGrid2.Visible:= False;
  Table2.Fields[0].ReadOnly:= False;
end;

procedure TForm1.DataSource2DataChange(Sender: TObject; Field: TField);
(* -- mise au point *)
begin
  if Table3.Active and (Table2.State= dsBrowse)
    then Table3.GotoCurrent(Table2);
end;

procedure TForm1.recopieClick(Sender: TObject);
var l_pt_1, l_pt_2: Pointer;
    l_dbi: Integer;
begin
  affiche(''); affiche('recopie');
  (* -- replace dans Table1 *)
  with Table2 do
  begin
    First;
    While not Eof do
    begin
      (* -- positionne *)
      if Table1.FindKey([FieldByName('NUMERO').AsInteger])
        then begin
            l_pt_1:= Table1.ActiveBuffer;
            l_pt_2:= Table2.ActiveBuffer;
            Move(l_pt_2^, l_pt_1, Table2.RecordSize);
          end
        else begin
            affiche('BUG pas retrouv la cl');
            exit;
          end;

      Table2.Next;
    end;

    deverrouilleClick(nil);
  end; (* with *)
end;

procedure TForm1.repriseClick(Sender: TObject);
  (* -- repose les verrous *)
var l_cle_1: Integer;
    l_dbi: Integer;
begin
  affiche(''); affiche('reprise');
  Table2.Open;

  (* -- essaye de replacer le mme verrou que celui qui a chou *)
  (* -- si c'tait un nouvel enregistrement pour Table2 *)
  l_cle_1:= Table1.FieldByName('NUMERO').AsInteger;
  if not Table2.FindKey([l_cle_1])
    then
       Try
         verrouille_cle(Table1, l_cle_1);
       except
         on e: t_exception do
           begin
             affiche(E.message);
             Table2.Close;
             exit;
           end;
       end; (* try *)

  (* -- essaye de rcuprer les verrous des enregistremnents de Table2 *)
  with Table2 do
  begin
    First;
    While not Eof do
    begin
      Try
        (* -- pose le verrou *)
        verrouille_cle(Table1, Table2.FieldByName('NUMERO').AsInteger);

        (* -- regarde si a chang: "TransIsolation" *)
        if (Table1.FieldByName('NOM').AsString<> FieldByName('NOM').AsString)
           or
           (Table1.FieldByName('MONTANT').AsString<> FieldByName('MONTANT').AsString)
          then raise t_exception.Create('la valeur a chang');
      except
        on e: t_exception do
          begin
            affiche(E.message);
            deverrouilleClick(nil);
            exit;
          end;
      end; (* try *)

      Table2.Next;
    end; (* while *)

    (* -- a pu tout verrouiller: repositionne sur l'enregistrement *)
    if Table1.FindKey([l_cle_1])
      then begin
          (* -- si l'enregistrement tait nouveau, l'ajouter *)
          if not Table2.FindKey([l_cle_1])
            then begin
                dbGrid2Exit(nil);
                ajoute;
              end;
          positionne;

          dbGrid1.Enabled:= True;
          recopie.Enabled:= True;
          reprise.Enabled:= False;
        end
      else affiche('BUG retrouve pas');
  end; (* with Table2 *)
end;

procedure TForm1.deverrouilleClick(Sender: TObject);
(* -- libre tous les verrous *)
var l_dbi: Integer;
begin
  If Table1.Active
    then begin
        l_dbi:= DbiRelRecordLock(Table1.Handle, True);
        if l_dbi<> 0
          then affiche('pb dverrouillage');
      end;
  Table2.Close;
end;

procedure TForm1.annuleClick(Sender: TObject);
begin
  deverrouilleClick(nil);
  Table3.Close;
  Table2.DeleteTable;
end;

end.
