(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_trainc *)

(*$r+*)
unit U_trainc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table2: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    transactionne: TButton;
    cree_log: TButton;
    Memo1: TMemo;
    Table_log: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Table_logNUMERO_LOG: TFloatField;
    Table_logNUMERO_TRA: TFloatField;
    Table_logTYPE_TRANS: TStringField;
    initialise: TButton;
    Table_logHEURE: TFloatField;
    Table_logDONNEE: TBlobField;
    cree_table: TButton;
    Table2_aux: TTable;
    avec_pannes: TButton;
    restart: TButton;
    immediat: TButton;
    procedure transactionneClick(Sender: TObject);
    procedure Table2BeforePost(DataSet: TDataset);
    procedure cree_logClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure initialiseClick(Sender: TObject);
    procedure cree_tableClick(Sender: TObject);
    procedure avec_pannesClick(Sender: TObject);
    procedure restartClick(Sender: TObject);
    procedure immediatClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  const vi_numero: Integer= 0;

  procedure affiche(p_texte: String);
    begin
      Form1.Memo1.Lines.Add(Format('%3d ', [vi_numero])+ p_texte);
      inc(vi_numero)
    end;

  function f_booleen(p_booleen: Boolean): String;
    begin
      if p_booleen
        then f_booleen:= 'True'
        else f_booleen:= 'False';
    end;

  (* -- transactions *)

  const vi_transaction: Boolean= True;

  var g_numero_log, g_numero_transaction: Integer;

  procedure initialise_numeros;
    begin
      With Form1 do
      begin
        Table_log.Last;
        g_numero_log:= Table_log.FieldByName('NUMERO_LOG').AsInteger;
        g_numero_transaction:= Table_log.FieldByName('NUMERO_TRA').AsInteger;
      end;
    end;

  procedure entre_start_transaction(var pv_transaction: Integer);
    begin
      with Form1 do
      begin
        Memo1.Lines.Add('');
        affiche('Trans '+ IntToStr(g_numero_transaction+ 1)+ ': Start');

        Table_log.Last;
        g_numero_log:= Table_log.FieldByName('NUMERO_LOG').AsInteger;
        g_numero_transaction:= Table_log.FieldByName('NUMERO_TRA').AsInteger;
        inc(g_numero_log); inc(g_numero_transaction);
        pv_transaction:= g_numero_transaction;

        Table_log.AppendRecord([g_numero_log, g_numero_transaction, 'Start']);
        inc(g_numero_log);
      end;
    end; (* entre_start_transaction *)

  procedure entre_write(p_type_transaction: String; p_table: tTable);
    (* -- stocke entre Write *)
    var l_flux: tBlobStream;
        l_pt: Pointer;
    begin
      with Form1, p_table do
      begin
        affiche('Trans '+ IntToStr(Tag)+ ': '+ p_type_transaction
           + ' '+ FieldByName('NOM').AsString
           + ' '+ FieldByName('MONTANT').AsString);

        Table_log.AppendRecord([g_numero_log, Tag, p_type_transaction]);
        inc(g_numero_log);

        Table_log.Edit;
        l_flux:= tBlobStream.Create(Table_logDONNEE, bmWrite);

        l_pt:= ActiveBuffer;
        l_flux.Write(l_pt^, RecordSize);
 
        l_flux.Free;
        Table_log.Post;
      end;
    end; (* entre_write *)

  const vi_redo: Boolean= False;

  procedure recupere_write(p_table: tTable);
    (* -- relis entre Write *)
    var l_flux: tBlobStream;
        l_pt: Pointer;
    begin
      with Form1, p_table do
      begin
        affiche('  recupere_write');
        l_flux:= tBlobStream.Create(Table_logDONNEE, bmRead);

        (* -- chargement temporaire *)
        Append;

        l_pt:= ActiveBuffer;
        l_flux.Read(l_pt^, RecordSize);
        l_flux.Free;

        (* -- recherche si existe dj *)
        Table2_aux.Open;

        If Table2_aux.FindKey([FieldByName('NOM').AsString])
          then begin
              affiche('  remplace');

              Table2_aux.Edit;
              Move(l_pt^, Table2_aux.ActiveBuffer^, RecordSize);
              (* -- sinon fera Append Append *)
              Cancel;

              Table2_aux.Post;
            end
          else begin
              affiche('  ajoute');

              vi_redo:= True;
              Post;
              vi_redo:= False;
            end;
      end; (* with *)
    end; (* recupere_write *)

  procedure efface_write(p_table: tTable);
    var l_flux: tBlobStream;
        l_cle: String;
        l_pt: Pointer;
    begin
      with Form1, p_table do
      begin
        affiche('  efface_write');
        l_flux:= tBlobStream.Create(Table_logDONNEE, bmRead);

        (* -- chargement temporaire *)
        Append;

        l_pt:= ActiveBuffer;
        l_flux.Read(l_pt^, RecordSize);
        l_flux.Free;

        l_cle:= FieldByName('NOM').AsString;
        Cancel;

        if FindKey([l_cle, l_cle])
          then Delete
          else affiche('  pb: retrouve pas '+ l_cle);
      end; (* with *)
    end; (* efface_write *)

  const vi_panne: Boolean= False;

  function f_redo(p_numero_transaction: Integer): Boolean;
    (* -- recommence les critures *)
    var l_numero_log: Integer;
        l_simule_panne: Integer;
    begin
      with Form1, Table_log do
      begin
        Result:= True;
        Memo1.Lines.Add('');

        IndexName:= 'IND_NUMTRA';
        SetRange([p_numero_transaction], [p_numero_transaction]);
        First;

        l_numero_log:= 0;
        l_simule_panne:= Random(g_numero_transaction* 10);

        While not Eof do
        begin
          if vi_panne and (l_simule_panne= l_numero_log)
            then begin
                affiche('Redo: PANNE');
                CancelRange;
                Result:= False; exit;
              end;

          affiche('Redo '+ Table_logNUMERO_TRA.AsString+ ': '+ Table_logTYPE_TRANS.AsString);

          if (Table_logTYPE_TRANS.AsString= 'Write')
            then recupere_write(Table2);

          Next;
          inc(l_numero_log);
        end; (* while not Eof *)

        CancelRange;
        Table2.Refresh;
      end;
    end; (* f_redo *)

  function f_undo(p_numero_transaction: Integer): Boolean;
    var l_numero_log: Integer;
        l_simule_panne: Integer;
    begin
      with Form1, Table_log do
      begin
        Memo1.Lines.Add('');

        Result:= True;
        IndexName:= 'IND_NUMTRA';
        SetRange([p_numero_transaction], [p_numero_transaction]);
        (* -- dfait depuis la fin *)
        Last;

        l_numero_log:= 0;
        l_simule_panne:= Random(g_numero_transaction* 10);

        While not Bof do
        begin
          if vi_panne and (l_simule_panne= l_numero_log)
            then begin
                affiche('Undo: PANNE');
                CancelRange;
                Result:= False; exit;
              end;

          affiche('Undo: '+ Table_logNUMERO_TRA.AsString+ ' '+ Table_logTYPE_TRANS.AsString);

          if Table_logTYPE_TRANS.AsString= 'Pr'
            then recupere_write(Table2)
            else
              if Table_logTYPE_TRANS.AsString= 'Pr Nil'
                then efface_write(Table2);

          Prior;
          inc(l_numero_log);
        end; (* while not Eof *)

        CancelRange;
        Table2.Refresh;
      end;
    end; (* f_undo *)

  procedure entre_commit(p_transaction: Integer);
    begin
      with Form1 do
      begin
        affiche('Trans '+ IntToStr(p_transaction)+ ': Commit');

        Table_log.AppendRecord([g_numero_log, p_transaction, 'Commit']);
        inc(g_numero_log);

        (* -- maintenant que le log est crit, crit les donnes *)
        if immediat.Caption= 'retarde'
          then f_redo(p_transaction);
      end;
    end; (* entre_commit *)

  procedure entre_rollback(p_transaction: Integer);
    begin
      with Form1 do
      begin
        affiche('Trans: '+ IntToStr(p_transaction)+ ' RollBack');

        Table_log.AppendRecord([g_numero_log, p_transaction, 'RollBack']);
        inc(g_numero_log);
      end;
    end; (* entre_rollback *)

  procedure entre_check_point;
    begin
      with Form1 do
      begin
        affiche('Trans: CheckPoint');

        (* -- purge les tampons mmoire du LOG *)
        (* -- purge les tampons mmoire des tables *)

        Table_log.AppendRecord([g_numero_log, -1, 'CheckPoint']);
        inc(g_numero_log);
      end;
    end; (* entre_check_point *)

  function f_verifie_commit(p_transaction: Integer): Boolean;
    (* -- cherche Commit *)
    begin
      with Form1, Table_log do
      begin
        affiche('  Commit '+ IntToStr(p_transaction)+ ' ?');
        IndexName:= 'IND_NUMTRA';
        SetRange([p_transaction], [p_transaction]);
        First;

        While not Eof do
        begin
          if (Table_logTYPE_TRANS.AsString= 'Commit')
            then begin
                Result:= True;
                CancelRange;
                affiche('    oui');
                exit;
              end
            else Next;
        end; (* while *)

        Result:= False;
        affiche('    non');
        CancelRange;
      end; (* with *)
    end; (* f_verifie_commit *)

  procedure purge_log(p_transaction: Integer);
    begin
      with Form1, Table_log do
      begin
        affiche('Purge '+ IntToStr(p_transaction));

        IndexName:= 'IND_NUMTRA';
        SetRange([p_transaction], [p_transaction]);
        First;

        While not Eof do
          delete;

        CancelRange;
      end; (* with *)
    end; (* purge_log *)

  procedure restart_differe;
    var l_numero_transaction: Integer;
    begin
      For l_numero_transaction:= 1 to g_numero_transaction do
        if f_verifie_commit(l_numero_transaction)
          then begin
              if not f_redo(l_numero_transaction)
                then begin
                    affiche('recommencer Restart');
                    Abort;
                  end
            end
          else purge_log(l_numero_transaction)
    end; (* restart_differe *)

  procedure restart_immediat;
    var l_numero_transaction: Integer;
    begin
      For l_numero_transaction:= 1 to g_numero_transaction do
        if f_verifie_commit(l_numero_transaction)
          then begin
              if not f_redo(l_numero_transaction)
                then begin
                    affiche('recommencer Restart');
                    Abort;
                  end;
            end
          else
            if not f_undo(l_numero_transaction)
              then begin
                  affiche('recommencer Restart');
                  Abort;
                end
    end; (* restart_immediat *)

  (* -- lecture et criture dans la Table *)

procedure TForm1.Table2BeforePost(DataSet: TDataset);
var l_cle: String;
begin
  if not vi_transaction
    then exit;

  if not vi_redo
    then begin
        if immediat.Caption= 'retarde'
          then begin
              entre_write('Write', Table2);

              Table2.Cancel;
              Sysutils.Abort;
            end
          else begin
              (* -- la pr-image *)
              if Table2.State= dsInsert
                then begin
                    (* -- nouvel enregistrement: cre une pr-image NIL *)
                    entre_write('Pr Nil', Table2);
                  end
                else begin
                    Table2_aux.Open;
                    l_cle:= Table2.FieldByName('NOM').AsString;
                    if Table2_aux.FindKey([l_cle])
                      then begin
                          Table2_aux.Tag:= Table2.Tag;
                          entre_write('Pr', Table2_aux);
                        end
                      else affiche('pb trouve pas '+ l_cle);
                  end;

              (* -- l'image *)
              entre_write('Write', Table2);
              (* -- et laisse Post crire sur disque *)
            end;
        end;
end; (* TableBeforePost *)

  procedure lis(p_cle: String; var pv_valeur: Double);
    begin
      with Form1 do
        If Table2.FindKey([p_cle])
          then pv_valeur:= Table2.FieldByName('MONTANT').AsFloat
          else ShowMessage('pas cl '+ p_cle);
    end; (* lis *)

  procedure ecris(p_transaction: Integer; p_cle: String; p_valeur: Double);
    begin
      With Form1 do
        If Table2.FindKey([p_cle])
          then begin
              Table2.Edit;
              Table2.FieldByName('MONTANT').AsFloat:= p_valeur;
              Table2.Tag:= p_transaction;

              Try
                Table2.Post;
              except
                on e: eAbort do
              end;
            end
          else ShowMessage('pas cl '+ p_cle);
    end; (* ecris *)

  procedure ajoute(p_transaction: Integer; const pk_valeurs: array of const);
    begin
      Try
        Form1.Table2.AppendRecord(pk_valeurs);
      except
        on e: eAbort do
      end;
    end; (* ajoute *)

(* -- initialisations *)

procedure TForm1.immediatClick(Sender: TObject);
begin
  If immediat.Caption= 'immediat'
    then immediat.Caption:= 'retarde'
    else immediat.Caption:= 'immediat';
end;

procedure TForm1.cree_tableClick(Sender: TObject);
begin
  Table2_aux.Close;

  With Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='RESEAU.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('MONTANT', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;

    Open;

    AppendRecord([1, 'ROY', 1000]);
    AppendRecord([2, 'LUC', 300]);
  end;
end;

procedure TForm1.cree_logClick(Sender: TObject);
begin
  With Table_log do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='LOG.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO_LOG', ftInteger, 0, True);
    FieldDefs.Add('NUMERO_TRA', ftInteger, 0, True);
    FieldDefs.Add('TYPE_TRANS', ftString, 10, True);
    FieldDefs.Add('HEURE', ftInteger, 0, True);
    FieldDefs.Add('DONNEE', ftGraphic, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NUMLOG', 'NUMERO_LOG', []);
    IndexDefs.Add('IND_NUMTRA', 'NUMERO_TRA', []);

    CreateTable;
    Open;
    AppendRecord([0, 0, 'inconnu']);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Try
    Table_log.Open;
  Except
    cree_logClick(nil);
  end;

  Try
    Table2.Open;
  Except
    cree_tableClick(nil);
  end;

  initialise_numeros;
end;

procedure TForm1.initialiseClick(Sender: TObject);
begin
  affiche('rinitialise tout');
  vi_transaction:= False;

  cree_tableClick(nil);

  cree_logClick(nil);
  initialise_numeros;

  vi_transaction:= True;
end;

procedure TForm1.transactionneClick(Sender: TObject);
var l_transaction_1, l_transaction_2: Integer;
  l_valeur_1, l_valeur_2: Double;
  l_valeur_3, l_valeur_4: Double;
begin
  Memo1.Lines.Add('');
  vi_panne:= False;

  TRY
    entre_start_transaction(l_transaction_1);
    lis('LUC', l_valeur_1);
    ecris(l_transaction_1, 'LUC', l_valeur_1- 50);

    lis('ROY', l_valeur_2);
    ecris(l_transaction_1, 'ROY', l_valeur_2+ 50);
    entre_commit(l_transaction_1);
  EXCEPT
    entre_rollback(l_transaction_1);
  END;
{
  entre_start_transaction(l_transaction_2);
  lis('LUC', l_valeur_3);
  ecris(l_transaction_2, 'LUC', l_valeur_3- l_valeur_3* 0.10);

  lis('ROY', l_valeur_4);
  ecris(l_transaction_2, 'ROY', l_valeur_4+ + l_valeur_3* 0.10);
  entre_commit(l_transaction_2);
}
end;

procedure TForm1.avec_pannesClick(Sender: TObject);
var l_transaction_1, l_transaction_2: Integer;
  l_valeur_1, l_valeur_2: Double;
  l_valeur_3, l_valeur_4: Double;
  l_simule_panne, l_compteur: Integer;
begin
  Memo1.Lines.Add('');
  vi_panne:= True;

  TRY
    l_simule_panne:= Random(15); l_compteur:= 0;
    repeat
      if l_compteur= l_simule_panne
        then begin
            affiche('PANNE');
            exit;
          end;
      Case l_compteur of
       0 : entre_start_transaction(l_transaction_1);
       1 : lis('LUC', l_valeur_1);
       2 : ecris(l_transaction_1, 'LUC', l_valeur_1- 50);

       3 : lis('ROY', l_valeur_2);
       4 : ecris(l_transaction_1, 'ROY', l_valeur_2+ 50);
       5 : entre_commit(l_transaction_1);
      end; (* case *)
      inc(l_compteur);
    until l_compteur> 5;
  EXCEPT
    entre_rollback(l_transaction_1);
  END;
end;

procedure TForm1.restartClick(Sender: TObject);
begin
  initialise_numeros;
  affiche(''); affiche('Restart 1..'+ IntToStr(g_numero_transaction));

  if immediat.Caption= 'immediat'
    then restart_immediat
    else restart_differe;

  affiche('Restart OK');
end;

end.

