(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_etavol *)

unit U_etavol;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    PaintBox1: TPaintBox;
    pre_visu: TButton;
    Table1: TTable;
    imprime_: TButton;
    procedure pre_visuClick(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imprime_Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses Printers;

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

  const k_mm_par_inch= 25.4;

  function f_x(p_mm: Double): Integer;
    begin
      Result:= Round(p_mm/ k_mm_par_inch* GetDeviceCaps(Printer.Handle, LogPixelsX));
    end;

  function f_y(p_mm: Double): Integer;
    begin
      Result:= Round(p_mm / k_mm_par_inch* GetDeviceCaps(Printer.Handle, LogPixelsY));
    end;

  procedure calcule_police(p_canvas: tCanvas; p_pixels: Integer);
    var l_indice, l_taille: Integer;
    begin
      l_indice:= p_pixels+ 1;

      repeat
        p_canvas.Font.Height:= -l_indice;
        l_taille:= p_canvas.TextHeight('X');
        if l_taille>= p_pixels
          then dec(l_indice);
      until (l_taille< p_pixels) or (l_indice<= 1);

      p_canvas.Font.Height:= -(l_indice+ 1);
    end; (* calcule_police *)

  procedure imprime(p_x, p_y: Integer; p_chaine: String;
        p_canvas: tCanvas; p_justifie: tAlignment);
    var l_taille: Integer;
    begin
      with p_canvas do
      begin
        case p_justifie of
          taLeftJustify : TextOut(p_x, p_y, p_chaine);
          taRightJustify : begin
                             l_taille:= TextWidth(p_chaine);
                             TextOut(p_x- l_taille, p_y, p_chaine);
                           end;
        end; (* case *)
      end;
    end; (* imprime *)

  procedure pre_imprime(p_x, p_y: Integer; p_chaine: String;
      p_canvas: tCanvas; p_justifie: tAlignment);
    var l_taille: Integer;
        l_ratio: Double;
    begin
      With Form1, p_canvas do
      begin
        l_ratio:= 1.0* PaintBox1.Width / Printer.PageWidth;
        affiche(IntToStr(Round(l_ratio* p_x))+ ' '+ p_chaine);

        case p_justifie of
          taLeftJustify : TextOut(round(l_ratio* p_x), round(l_ratio* p_y), p_chaine);
          taRightJustify : begin
                             l_taille:= TextWidth(p_chaine);
                             TextOut(round(l_ratio* p_x)- l_taille, Round(l_ratio* p_y), p_chaine);
                           end;
        end; (* case *)
      end;
    end; (* pre_imprime *)

  function f_r(p: Double): Integer;
    begin
      With Form1 do
        Result:= f_x(1.0* p* PaintBox1.Width / Printer.PageWidth);
    end;

  function f_p(p: Double): Integer;
    begin
      With Form1 do
        Result:= round(1.0* p* PaintBox1.Width / Printer.PageWidth);
    end;

  function f_1_p(p: Double): Integer;
    begin
      With Form1 do
        Result:= round(1.0* p* Printer.PageWidth / PaintBox1.Width);
    end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var l_mm_large: Integer;
    l_ratio: Double;
begin
  l_mm_large:= GetDeviceCaps(Printer.Handle, HorzSize);
  l_ratio:= 1.0* l_mm_large/ PaintBox1.Width;
  Canvas.Brush.Color:= clWhite;
  Canvas.TextOut(0, 0, 'x= '+ IntToStr(Round(l_ratio* X))
      + ', y= '+ IntToStr(Round(l_ratio* Y) )+ '     ');
end;

  const vi_hauteur_police= 6;
        vi_hauteur_page: Integer= 30;
        vi_marge_x= 10;
        vi_marge_y= 5;
        vi_dilate_x: Double= 1.2;

procedure TForm1.pre_visuClick(Sender: TObject);
var l_champ: Integer;
    l_x, l_y: Integer;
    l_largeurs: array[0..99] of Integer;
begin
  With PaintBox1 do
  begin
    Canvas.Rectangle(0, 0, Width, Height);

    affiche('Ratio '+ IntToStr(Round(1000.0* Width/Printer.PageWidth)));
    affiche('f_r(1) '+ IntToStr(f_r(1)));
    affiche('f_r(10) '+ IntToStr(f_r(10)));

    Canvas.Font.Name:= 'Arial';
    calcule_police(Canvas, f_p(f_x(vi_hauteur_police)));
    affiche(IntToStr(Canvas.Font.Height)+ ' '+ IntToStr(Canvas.TextWidth('X')));

    With Table1 do
    begin
      l_x:= f_x(vi_marge_x);
      For l_champ:= 0 to FieldCount- 1 do
        with Fields[l_champ] do
        begin
          l_largeurs[l_champ]:= l_x;
          l_x:= l_x+  f_1_p(1.0* Canvas.TextWidth('0')* DisplayWidth);
        end;

      First;
      l_y:= f_y(vi_marge_y);

      while not eof do
      begin
        if l_y= f_y(vi_marge_y)
          then begin
              For l_champ:= 0 to FieldCount- 1 do
                with Fields[l_champ] do
                  pre_imprime(l_largeurs[l_champ], l_y, DisplayLabel, Canvas, taLeftJustify);
              inc(l_y, f_1_p(Canvas.TextHeight('0')* 1.1));
            end;

        For l_champ:= 0 to FieldCount- 1 do
          with Fields[l_champ] do
            case DataType of
              ftInteger, ftFloat :
                pre_imprime(l_largeurs[l_champ+ 1]- f_x(2), l_y, AsString, Canvas, taRightJustify);
              else
                pre_imprime(l_largeurs[l_champ], l_y, AsString, Canvas, taLeftJustify);
            end; (* case *)

        inc(l_y, f_1_p(Canvas.TextHeight('0')));

        Next;

        if not Eof and (l_y+ f_1_p(Canvas.TextHeight('0'))> f_y(vi_hauteur_page))
          then begin
              SysUtils.Abort;
              ShowMessage('ejecte');
              Canvas.Rectangle(0, 0, Width, Height);
              l_y:= f_y(vi_marge_y);
            end;
      end; (* while *)

      affiche(IntToStr(Canvas.TextWidth('NUMERO')));
    end; (* with Table1 *)
  end; (* with PaintBox1 *)
end; (* pre_visuClick *)

procedure TForm1.imprime_Click(Sender: TObject);
var l_champ: Integer;
    l_x, l_y: Integer;
    l_largeurs: array[0..99] of Integer;
begin
  With Printer do
  begin
    BeginDoc;

    Canvas.Rectangle(0, 0, PageWidth, PageHeight);

    Canvas.Font.Name:= 'Arial';
    calcule_police(Canvas, f_x(vi_hauteur_police));
    affiche(IntToStr(Canvas.Font.Height)+ ' '+ IntToStr(Canvas.TextWidth('X')));

    With Table1 do
    begin
      l_x:= f_x(vi_marge_x);
      For l_champ:= 0 to FieldCount- 1 do
        with Fields[l_champ] do
        begin
          l_largeurs[l_champ]:= l_x;
          l_x:= l_x+  Round(1.0* Canvas.TextWidth('0')* DisplayWidth* vi_dilate_x);
        end;

      First;
      l_y:= f_y(vi_marge_y);

      while not eof do
      begin
        affiche('y '+ IntToStr(l_y));
        if l_y= f_y(vi_marge_y)
          then begin
              For l_champ:= 0 to FieldCount- 1 do
                with Fields[l_champ] do
                  imprime(l_largeurs[l_champ], l_y, DisplayLabel, Canvas, taLeftJustify);
              inc(l_y, Round(Canvas.TextHeight('0')* 1.1));
            end;

        l_x:= f_x(vi_marge_x);
        For l_champ:= 0 to FieldCount- 1 do
          with Fields[l_champ] do
            case DataType of
              ftInteger, ftFloat :
                imprime(l_largeurs[l_champ+ 1]- f_x(2), l_y, AsString, Canvas, taRightJustify);
              else
                imprime(l_largeurs[l_champ], l_y, AsString, Canvas, taLeftJustify);
            end; (* case *)
        inc(l_y, Canvas.TextHeight('0'));

        Next;

        if not Eof and (l_y+ Canvas.TextHeight('0')> f_y(vi_hauteur_page))
          then begin
              NewPage;
              affiche(IntToStr(f_y(vi_hauteur_page)));
              Canvas.Rectangle(0, 0, PageWidth, PageHeight);
              l_y:= f_y(vi_marge_y);
            end;

      end; (* while *)
    end; (* with Table1 *)

    EndDoc;
  end; (* with Printer *)
end;

end.

