(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_impri *)

unit U_impri;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    imprime_cadre: TButton;
    info_impri: TButton;
    imprime_texte: TButton;
    cerfa: TButton;
    procedure imprime_cadreClick(Sender: TObject);
    procedure info_impriClick(Sender: TObject);
    procedure imprime_texteClick(Sender: TObject);
    procedure cerfaClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses Printers;

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

(* -- paramtres imprimante *)

  const k_inch_par_mm= 1/ 25.4;
        k_mm_par_inch= 25.4;

  type t_parametres_imprimante= record
                                  pixels_x, pixels_y: Integer;
                                  pixel_par_inch_x, pixel_par_inch_y: Integer;
                                  pixels_marge_x, pixels_marge_y: Integer;
                                  mm_x, mm_y, mm_marge_x, mm_marge_y: Double;
                                end;
  var g_parametres_imprimante: t_parametres_imprimante;

  function f_pixel_x_en_mm(p_pixel: Integer): Double;
    begin
      with g_parametres_imprimante do
        Result:= 1.0* p_pixel/ pixel_par_inch_x* k_mm_par_inch;
    end; (* f_pixel_x_en_mm *)

  procedure calcule_parametres_imprimante;
    var l_code_escape: Word;
        l_marges: tPoint;
    begin
      with g_parametres_imprimante do
      begin
        FillChar(g_parametres_imprimante, SizeOf(g_parametres_imprimante), 0);

        pixels_x:= Printer.PageWidth;
        pixels_y:= Printer.PageHeight;

        (* -- exc: l'imprimante n'imprime pas pour l'instant
        affiche( IntToStr(GetDeviceCaps(Printer.CANVAS.Handle, HorzSize)));
        *)
        pixel_par_inch_x:= GetDeviceCaps(Printer.Handle, LogPixelsX);
        pixel_par_inch_y:= GetDeviceCaps(Printer.Handle, LogPixelsY);

        mm_x:= GetDeviceCaps(Printer.Handle, HorzSize);
        mm_y:= GetDeviceCaps(Printer.Handle, VertSize);

        l_code_escape := GETPRINTINGOFFSET;
        If Escape(Printer.Handle, QUERYESCSUPPORT, SizeOf(l_code_escape), @l_code_escape, nil)<> 0
          then begin
              l_code_escape := GETPHYSPAGESIZE;
              If Escape(Printer.Handle, QUERYESCSUPPORT, SizeOf(l_code_escape), @l_code_escape, nil) <> 0
                then begin
                    l_code_escape := GETPRINTINGOFFSET;
                    Escape(Printer.Handle, GETPRINTINGOFFSET, SizeOf(l_code_escape), @l_code_escape, @l_marges);
                    pixels_marge_x:= l_marges.x;
                    mm_marge_x:= pixels_marge_x/ pixel_par_inch_x* k_mm_par_inch;
                    pixels_marge_y:= l_marges.y;
                    mm_marge_y:= pixels_marge_y/ pixel_par_inch_y* k_mm_par_inch;
                  end;
          end;
      end;
    end; (* calcule_parametres_imprimante *)

  procedure affiche_parametres_imprimante;
    begin
      affiche('');
      affiche('Printer.PageWidth:  '+ IntToStr(Printer.PageWidth) );
      affiche('Caps.HorzSize       '+ IntToStr(GetDeviceCaps(Printer.Handle, HorzSize)));
      affiche('Caps.LogPixelsX     '+ IntToStr(GetDeviceCaps(Printer.Handle, LogPixelsX)));
      affiche('');
      affiche('Printer.PageHeight: '+ IntToStr(Printer.PageHeight) );
      affiche('Caps.VertSize       '+ IntToStr(GetDeviceCaps(Printer.Handle, VertSize)));
      affiche('Caps.LogPixelsY     '+ IntToStr(GetDeviceCaps(Printer.Handle, LogPixelsY)));
      with g_parametres_imprimante do
      begin
        affiche('mm_marge_x          '+ IntToStr(Round(mm_marge_x)));
        affiche('mm_marge_y          '+ IntToStr(Round(mm_marge_y)));
      end; (* with *)
    end; (* affiche_parametres_imprimante *)

procedure TForm1.info_impriClick(Sender: TObject);
begin
  Printer.Destroy;
  Printer:= tPrinter.Create;

  calcule_parametres_imprimante;
  affiche_parametres_imprimante;
end;

  function f_x(p_mm: Double): Integer;
    begin
      Result:= Round(p_mm/ k_mm_par_inch* GetDeviceCaps(Printer.Handle, LogPixelsX));
    end;

  function f_y(p_mm: Double): Integer;
    begin
      Result:= Round(p_mm / k_mm_par_inch* GetDeviceCaps(Printer.Handle, LogPixelsY));
    end;

  procedure calcule_police(p_canvas: tCanvas; p_pixels: Integer);
    var l_indice, l_taille: Integer;
    begin
      l_indice:= p_pixels+ 1;

      repeat
        p_canvas.Font.Height:= -l_indice;
        l_taille:= p_canvas.TextHeight('X');

        affiche(IntToStr(l_indice)+ ' '+ IntToStr(l_taille)+ ' '+ IntToStr(p_pixels));

        if l_taille>= p_pixels
          then dec(l_indice);
      until (l_taille< p_pixels) or (l_indice<= 1);

      p_canvas.Font.Height:= -(l_indice+ 1);
    end; (* calcule_police *)

procedure TForm1.imprime_cadreClick(Sender: TObject);
begin
  With Printer do
  begin
    BeginDoc;

    Canvas.Rectangle(0, 0, PageWidth, PageHeight);

    Canvas.Font.Name:= 'Arial';
    calcule_police(Canvas, f_y(10));
    Canvas.textOut(100, 100, 'PageWidth= '+ IntToStr(PageWidth)+ ', PageHeight= '+ IntToStr(PageHeight) );

    EndDoc;
  end;
end;

procedure TForm1.imprime_texteClick(Sender: TObject);
begin
  With Printer do
  begin
    BeginDoc;

    Canvas.Rectangle(0, 0, PageWidth, PageHeight);
    Canvas.textOut(100, 100, 'PageWidth= '+ IntToStr(PageWidth)+ ', PageHeight= '+ IntToStr(PageHeight) );

    Canvas.Font.Name:= 'Arial';
    calcule_police(Canvas, f_y(10));

    (* -- un rectangle *)
    Canvas.Rectangle(f_x(20), f_y(15), f_x(20+ 25), f_y(15+ 10));
    (* -- un texte de 10 mm de haut *)
    Canvas.TextOut(f_x(20), f_y(15), 'L'+ chr($C4)+ '_g');

    (* -- une bordure de 0.5 mm *)
    Canvas.Pen.Width:= f_x(0.5);
    Canvas.Rectangle(f_x(50), f_y(15), f_x(50+ 25), f_y(15+ 10));
    Canvas.TextOut(f_x(50), f_y(15), 'L'+ chr($C4)+ '_g');

    EndDoc;
  end;
end;

  procedure imprime_mm(p_mm_x, p_mm_y: Integer; p_chaine: String;
      p_police: tFont; p_justifie: tAlignment);
    var l_taille: Integer;
    begin
      with Printer.Canvas do
      begin
        Font:= p_police;
        case p_justifie of
          taLeftJustify : TextOut(f_x(p_mm_x), f_y(p_mm_y), p_chaine);
          taRightJustify : begin
                             l_taille:= TextWidth(p_chaine);
                             TextOut(f_x(p_mm_x)- l_taille, f_y(p_mm_y), p_chaine);
                           end;
        end; (* case *)
      end;
    end; (* imprime_mm *)

procedure TForm1.cerfaClick(Sender: TObject);
begin
  With Printer do
  begin
    BeginDoc;

    Canvas.Font.Name:= 'Arial';
    calcule_police(Canvas, f_y(10));

    Canvas.Pen.Width:= f_x(0.5);
    Canvas.Rectangle(f_x(20), f_y(15), f_x(20+ 20), f_y(15+ 10));
    imprime_mm(20, 15, 'Ly', Canvas.Font, taLeftJustify);

    Canvas.Pen.Width:= f_x(0.2);
    Canvas.Rectangle(f_x(50), f_y(15), f_x(50+ 20), f_y(15+ 10));
    imprime_mm(50+ 20, 15, 'Ly', Canvas.Font, taRightJustify);

    EndDoc;
  end;
end;

end.



