(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_police *)

unit U_police;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    metrique: TButton;
    Panel2: TPanel;
    FontDialog1: TFontDialog;
    Label1: TLabel;
    Panel1: TPanel;
    procedure metriqueClick(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

const k_inch_par_mm= 1/ 25.4;
      k_mm_par_inch= 25.4;

  procedure affiche_police(p_canvas: tCanvas);
    var l_metrique: tTextMetric;
    begin
      with p_canvas, Font do
      begin
        affiche('Font.Name '+ Font.Name);
        affiche('-Font.Height '+ IntToStr(-Font.Height));
        GetTextMetrics(p_canvas.Handle, l_metrique);
        with l_metrique do
        begin
          affiche('+InternalLeading '+ IntToStr(tmInternalLeading));
          affiche('=tmHeight '+ IntToStr(tmHeight));
        end;
        affiche('=Canvas.TextHeight '+ IntToStr(TextHeight('W')));
      end;
    end; (* affiche_police *)

procedure TForm1.metriqueClick(Sender: TObject);
var l_canvas: tControlCanvas;
begin
  If FontDialog1.Execute
    then begin
        affiche('');
        l_canvas:= tControlCanvas.Create;
        l_canvas.Control:= Panel1;
        Panel1.Update;

        With l_canvas do
        begin
          Font:= FontDialog1.Font;
{
          Font.Assign(FontDialog1.Font);
}
          Brush.Color:= clRed;
          Font.Color:= clWhite;
          TextOut(15, 0, 'A');
          affiche_police(l_canvas);
        end;

        l_canvas.Font.Color:= clBlack;
        Label1.Font.Assign(l_canvas.Font);
        Label1.Update;

        l_canvas.Free;
        Affiche(Label1.Font.Name);
    end;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Canvas.Textout(Panel1.Left- 30, Panel1.Top, IntToStr(y)+ '   ');
end;

  procedure calcule_police(p_canvas: tCanvas; p_pixels: Integer);
    var l_indice: Integer;
        l_taille, l_taille_precedente: Integer;
        l_erreur, l_erreur_precedente: Integer;
    begin
      affiche('Pixels demands '+ IntToStr(p_pixels));
      (* -- commence par police plus grande *)
      l_indice:= p_pixels;

      repeat
        p_canvas.Font.Height:= -l_indice;
        l_taille:= p_canvas.TextHeight('X');
        l_erreur:= p_pixels- l_taille;

        if l_taille>= p_pixels
          then dec(l_indice);
      until l_taille< p_pixels;

      p_canvas.Font.Height:= -(l_indice+ 1);
    end; (* calcule_police *)

  procedure calcule_police_corps(p_canvas: tCanvas; p_pixels: Integer; var pv_Leading: Integer);
    var l_indice: Integer;
        l_metrique: tTextMetric;
        l_corps: Integer;

    procedure ajuste;
      begin
        p_canvas.Font.Height:= -l_indice;
        GetTextMetrics(p_canvas.Handle, l_metrique);
        l_corps:= l_metrique.tmAscent+ 1- l_metrique.tmInternalLeading;
      end; (* ajuste *)

    begin (* calcule_police_corps *)
      affiche('Pixels demands '+ IntToStr(p_pixels));
      l_indice:= p_pixels;

      ajuste;
      if l_corps> p_pixels
        then begin
            repeat
              dec(l_indice);
              ajuste;
            until l_corps< p_pixels;
            inc(l_indice);
          end
        else begin
            repeat
              inc(l_indice);
              ajuste;
            until l_corps> p_pixels;
            dec(l_indice);
          end;

      ajuste;
      pv_leading:= l_metrique.tmInternalLeading;
      with l_metrique do
      affiche(IntToStr(l_corps)+ ' '+ IntToStr(tmAscent)+ ' '+ IntTOStr(tmDescent)
        + ' '+ IntToStr(tmInternalLeading)+ ' '+ IntToStr(tmHeight));
    end; (* calcule_police_corps *)

  procedure calcule;

    function f_x(p_x: Double): Integer;
      begin
        With Form1 do
          Result:= Round( (Panel1.Width* p_x) / Panel2.Width);
      end;

    function f_y(p_y: Double): Integer;
      begin
        With Form1 do
          Result:= Round( (Panel1.Height* p_y) / Panel2.Height);
      end;

    var l_canvas: tControlCanvas;
        l_leading: Integer;

    begin (* calcule *)
      With Form1 do
      begin
        l_canvas:= tControlCanvas.Create;
        l_canvas.Control:= Panel1;
        (* -- vite Paint en retard *)
        Panel1.Update;

        (* -- le label *)
        With Label1 do
        begin
          l_canvas.Moveto(0, 0);
          l_canvas.Lineto(500, Round(500.0* Panel2.Height /Panel2.Width));

          affiche('');
          l_canvas.Font.Name:= 'Arial';

          calcule_police(l_canvas, f_y(Height) );
          affiche_police(l_canvas);
          l_canvas.TextOut(f_x(Left), f_y(Top), 'Label1');

          l_canvas.Brush.Color:= clBlack;
          l_canvas.FrameRect(Rect(f_x(Left), f_y(Top), f_x(Left+ Width), f_y(Top+ Height)));

          (* -- calcule sans bas et haut *)
          calcule_police_corps(l_canvas, f_y(Height), l_leading);
          l_canvas.Brush.Color:= clWhite;
          l_canvas.TextOut(f_x(Left), Panel1.Height div 3- l_leading, chr($C4)+ 'Label1');

          l_canvas.Brush.Color:= clBlack;
          l_canvas.FrameRect(Rect(f_x(Left), Panel1.Height div 3,
              f_x(Left+ Width), Panel1.Height div 3+ f_y(Height)));

          (* -- rgle de trois sur la largeur *)
          calcule_police(l_canvas, f_x(Height) );
          l_canvas.Brush.Color:= clWhite;
          l_canvas.TextOut(f_x(Left), (2* Panel1.Height) div 3, 'Label1');

          l_canvas.Brush.Color:= clBlack;
          l_canvas.FrameRect(Rect(f_x(Left), (2* Panel1.Height) div 3,
              f_x(Left+ Width), (2* Panel1.Height) div 3+ f_y(Height)));
        end;

        l_canvas.Free;
      end; (* with Form1 *)
    end; (* calcule *)

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Panel1.Width:= X; Panel1.Height:= Y;
  calcule;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Panel1.Width:= X- Panel1.Left;
  Panel1.Height:= y- Panel1.Top;
  calcule;
end;

end.


