(* 001 u_rep *)

unit U_rep;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, DBCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    analyse: TButton;
    Memo1: TMemo;
    ouvre: TButton;
    pre_visu: TButton;
    Table1: TTable;
    imprime: TButton;
    procedure ouvreClick(Sender: TObject);
    procedure analyseClick(Sender: TObject);
    procedure pre_visuClick(Sender: TObject);
    procedure imprimeClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

procedure affiche(p_texte: String);

implementation
  uses Printers, u__rep;

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure TForm1.ouvreClick(Sender: TObject);
begin
  Form2.Show;
end;

type t_etat= record
               titres_colonnes: tPanel;
               ligne: tPanel;
             end;
var g_etat: t_etat;

procedure TForm1.analyseClick(Sender: TObject);
var l_indice: Integer;
    l_controle: tPanel;
begin
  With Form2, g_etat do
    for l_indice:= 0 to ControlCount- 1 do
      if Controls[l_indice] is tPanel
        then begin
            l_controle:= tPanel(Controls[l_indice]);
            affiche('Panel: '+ l_controle.Caption);
            Case l_controle.Tag of
              1 : titres_colonnes:= l_controle;
              2 : ligne:= l_controle;
            end; (* case *)
          end;
end;

  (* -- pr-visu *)

  procedure affiche_titres_colonnes(p_panel: tPanel; var pv_y: Integer);
    var l_indice: Integer;
    begin
      With p_panel, Form2.Image1.Picture.Bitmap.Canvas do
      begin
        affiche(IntToStr(pv_y)+ ' Titres');
        Font.Assign(p_panel.Font);
        For l_indice:= 0 to ControlCount- 1 do
        begin
          if Controls[l_indice] is tLabel
            then
              with tLabel(Controls[l_indice]) do
              begin
                Affiche('  '+ Caption);
                TextOut(Left, Top, Caption);

                Brush.Color:= clBlack;
                FrameRect(Rect(Left, pv_y+ Top, Left+ Width, pv_y+ Top+ Height));
                Brush.Color:= clWhite;
              end;
        end; (* for *)

        pv_y:= pv_y+ Height;
      end; (* with p_panel *)
    end; (* affiche_titres_colonnes *)

  procedure affiche_ligne(p_panel: tPanel; var pv_y: Integer);
    var l_indice: Integer;
        l_texte: String;
    begin
      With p_panel, Form2.Image1.Picture.Bitmap.Canvas do
      begin
        affiche(IntToStr(pv_y)+ ' ligne '+ p_panel.Name);
        Font.Assign(p_panel.Font);
        l_texte:= '';
        For l_indice:= 0 to ControlCount- 1 do
        begin
          if Controls[l_indice] is tdbText
            then
              with tdbText(Controls[l_indice]) do
              begin
                l_texte:= l_texte+ Field.AsString+ ' ';
                TextOut(Left, pv_y+ Top, Field.AsString);
                Brush.Color:= clBlack;
                FrameRect(Rect(Left, pv_y+ Top, Left+ Width, pv_y+ Top+ Height));
                Brush.Color:= clWhite;
              end
            else
              if Controls[l_indice] is tBevel
                then Begin
                    MoveTo(Left, pv_y+ Height);
                    LineTo(Left+ Width, pv_y+ Height );
                  end;
        end; (* for *)

        Affiche('  '+ l_texte);
        pv_y:= pv_y+ Height;
      end; (* with p_panel *)
    end; (* affiche_ligne *)

procedure TForm1.pre_visuClick(Sender: TObject);
const k_hauteur= 200;
var l_y: Integer;
begin
  with g_etat, Form2 do
  begin
    Table1.First;
    l_y:= 0;

    (* -- doit dimensionner avant de crer la bitmap *)
    Image1.Left:= 0; Image1.Top:= 0;
    Image1.Width:= Form2.ClientWidth- 25;
    Image1.Height:= k_hauteur- 25;
    With Image1.Picture do
    begin
      Bitmap:= tBitmap.Create;
      Bitmap.Height:= k_hauteur; Bitmap.Width:= Form2.ClientWidth- 25;
      Bitmap.Canvas.Rectangle(0, 0, Bitmap.Width, Bitmap.Height);
    end;
    ScrollBox1.HorzScrollBar.Range:= Form2.ClientWidth- 25;
    ScrollBox1.VertScrollBar.Range:= k_hauteur- 25;

    While not Table1.Eof Do
    begin
      if l_y= 0
        then affiche_titres_colonnes(titres_colonnes, l_y);

      affiche_ligne(ligne, l_y);

      Table1.Next;
    end; (* while *)
  end; (* with g_etat, Form2 *)
end;

  (* -- imprimante *)

  procedure calcule_police(p_canvas: tCanvas; p_pixels: Integer);
    var l_indice, l_taille: Integer;
    begin
      l_indice:= p_pixels+ 1;

      repeat
        p_canvas.Font.Height:= -l_indice;
        l_taille:= p_canvas.TextHeight('X');

        affiche(IntToStr(l_indice)+ ' '+ IntToStr(l_taille)+ ' '+ IntToStr(p_pixels));

        if l_taille>= p_pixels
          then dec(l_indice);
      until (l_taille< p_pixels) or (l_indice<= 1);

      p_canvas.Font.Height:= -(l_indice+ 1);
    end; (* calcule_police *)

  function f_x(p_ecran: Integer): Integer;
    (* -- pixel cran -> pixel imprimante *)
    begin
      Result:= Round(1.0* p_ecran* Printer.PageWidth / Form2.ClientWidth);
    end; (* f_x *)

  procedure imprime_xy(p_x, p_y, p_largeur, p_hauteur: Integer; p_chaine: String;
      p_justifie: tAlignment);
    const vi_hauteur_precedente: Integer= -1;
    var l_taille: Integer;
    begin
      with Printer, Canvas do
      begin
        if p_hauteur<> vi_hauteur_precedente
          then begin
              Font.Name:= 'Arial';

              calcule_police(Canvas, f_x(p_hauteur));
              vi_hauteur_precedente:= p_hauteur;
            end;

        case p_justifie of
          taLeftJustify : begin
                            { TextOut(f_x(p_x), f_x(p_y), p_chaine); }
                            TextRect(Rect(f_x(p_x), f_x(p_y), f_x(p_x+ p_largeur), f_x(p_y+ p_hauteur)),
                                f_x(p_x), f_x(p_y), p_chaine);
                          end;
          taRightJustify : begin
                             l_taille:= TextWidth(p_chaine);
                             TextOut(f_x(p_x+ p_largeur)- l_taille, f_x(p_y), p_chaine);
                           end;
        end; (* case *)
      end;
    end; (* imprime_mm *)

  procedure imprime_titres_colonnes(p_panel: tPanel; var pv_y: Integer);
    var l_indice: Integer;
    begin
      With p_panel do
      begin
        affiche(IntToStr(pv_y)+ ' Titres');
        For l_indice:= 0 to ControlCount- 1 do
        begin
          if Controls[l_indice] is tLabel
            then
              with tLabel(Controls[l_indice]) do
              begin
                imprime_xy(Left, pv_y+ Top, Width, Height, Caption, taLeftJustify);

                Printer.Canvas.Brush.Color:= clBlack;
                Printer.Canvas.FrameRect(Rect(f_x(Left), f_x(pv_y+ Top), f_x(Left+ Width), f_x(pv_y+ Top+ Height)));
                Printer.Canvas.Brush.Color:= clWhite;
              end;
        end; (* for *)

        pv_y:= pv_y+ Height;
      end; (* with p_panel *)
    end; (* imprime_titres_colonnes *)

  procedure imprime_ligne(p_panel: tPanel; var pv_y: Integer);
    var l_indice: Integer;
    begin
      With p_panel do
      begin
        affiche(IntToStr(pv_y)+ ' ligne '+ p_panel.Name);
        For l_indice:= 0 to ControlCount- 1 do
        begin
          if Controls[l_indice] is tdbText
            then
              with tdbText(Controls[l_indice]) do
              begin
                case Field.DataType of
                  ftInteger, ftFloat:
                    imprime_xy(Left, pv_y+ Top, Width, Height, Field.AsString, taRightJustify);
                  else
                    imprime_xy(Left, pv_y+ Top, Width, Height, Field.AsString, taLeftJustify);
                end;
                Printer.Canvas.Brush.Color:= clBlack;
                Printer.Canvas.FrameRect(Rect(f_x(Left), f_x(pv_y+ Top), f_x(Left+ Width), f_x(pv_y+ Top+ Height)));
                Printer.Canvas.Brush.Color:= clWhite;
              end
            else
              if Controls[l_indice] is tBevel
                then Begin
                    Printer.Canvas.Pen.Width:= 3;
                    Printer.Canvas.MoveTo(f_x(Left), f_x(pv_y+ Height));
                    Printer.Canvas.LineTo(f_x(Left+ Width), f_x(pv_y+ Height) );
                    Printer.Canvas.Pen.Width:= 1;
                  end;
        end; (* for *)

        pv_y:= pv_y+ Height;
      end; (* with p_panel *)
    end; (* imprime_ligne *)

procedure TForm1.imprimeClick(Sender: TObject);
var l_y: Integer;
begin
  with g_etat, Form2 do
  begin
    Printer.BeginDoc;

    Table1.First;
    l_y:= 0;

    While not Table1.Eof Do
    begin
      if l_y= 0
        then imprime_titres_colonnes(titres_colonnes, l_y);
      imprime_ligne(ligne, l_y);

      Table1.Next;
    end; (* while *)

    Printer.EndDoc;
  end; (* with g_etat, Form2 *)
end;

end.
