(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)

unit U_config;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    SysVersion_: TButton;
    SysConfig_: TButton;
    SysInfo_: TButton;
    ListBox1: TListBox;
    procedure SysVersion_Click(Sender: TObject);
    procedure SysConfig_Click(Sender: TObject);
    procedure SysInfo_Click(Sender: TObject);
    procedure FormClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses dbiProcs, DbiTypes, dbiErrs;

{$R *.DFM}

function f_booleen_en_chaine(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen_en_chaine:= 'True'
      else f_booleen_en_chaine:= 'False';
  end; (* f_booleen_en_chaine *)

function f_erreur_Dbi(RetVal: DBIResult): DBIResult;
  (* Description: This is function displays that is a message box about the *)
  (* error that occured. *)
  var l_chaine_erreur_z: array[0..128] of char;
      l_chaine_erreur: String;
      ResStr: array[0..20] of char;
      S: String;
  begin
    if retVal<> DBIERR_NONE
      then begin
          DbiGetErrorString(retVal, l_chaine_erreur_z);
          l_chaine_erreur:= '>'+ { f_chaine_0_en_chaine(l_chaine_erreur_z, 127)+ } '<';
          ShowMessage(l_chaine_erreur);
        end;

    f_erreur_Dbi:= retVal;
  end; (* f_erreur_Dbi *)

procedure TForm1.SysVersion_Click(Sender: TObject);
var l_version: SysVersion;
begin
  ListBox1.Clear;
  ListBox1.Items.Add('DbiGetSysVersion:');

  f_erreur_dbi(DbiGetSysVersion(l_version));
  with l_version, ListBox1.Items do
  begin
    Add('  iVersion   '+ IntToStr(iVersion));
    Add('  iIntfLevel '+ IntToStr(iIntfLevel)+ ' (client itf level)');
    Add('  DateVer    '+ DateToStr(DateVer));
    Add('  TimeVer    '+ TimeToStr(TimeVer));
  end;
end;

procedure TForm1.SysConfig_Click(Sender: TObject);
var l_config: SysConfig;
begin
  ListBox1.Clear;
  ListBox1.Items.Add('DbiGetSysConfig');

  f_erreur_dbi(DbiGetSysConfig(l_config));
  with l_config, ListBox1.Items do
  begin
    Add('    bLocalShare  '+ f_booleen_en_chaine(bLocalShare));
    Add('    iNetProtocol '+ IntToStr(iNetProtocol)+ ' (protocole rseau pilote paradox)');
    Add('    bNetShare    '+ f_booleen_en_chaine(bNetShare)+ ' (True si connect)');
    Add('    szNetType    '+ StrPas(szNetType)+ '<');
    Add('    szUserName   '+ StrPas(szUserName)+ '<');
    Add('    szIniFile    '+ StrPas(szIniFile)+ '<');
    Add('    szLangDriver '+ StrPas(szLangDriver)+ '<');
  end;
end;

procedure TForm1.SysInfo_Click(Sender: TObject);
var l_info: SysInfo;
begin
  ListBox1.Clear;
  ListBox1.Items.Add('DbiGetSysInfo');

  f_erreur_dbi(DbiGetSysInfo(l_info));
  with l_info, ListBox1.Items do
  begin
    Add('    iBufferSpace '+ IntToStr(iBufferSpace)+ ' (K)');
    Add('    iHeapSpace '+ IntToStr(iHeapSpace)+ ' (K)');
    Add('    iDrivers '+ IntToStr(iDrivers)+ ' (pilotes chargs)');
    Add('    iClients '+ IntToStr(iClients)+ ' (clients actifs)');
    Add('    iSessions '+ IntToStr(iSessions)+ ' (pour tous les clients)');
    Add('    iDataBases '+ IntToStr(iDataBases)+ ' (bases ouvertes)');
    Add('    iCursors '+ IntToStr(iCursors)+ ' ');
  end;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  MessageBeep(0);
  ListBox1.Items.SaveToFile('a:resu.pas')
end;

end.



