(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_pilote *)
(* 21 aou 95 *)

unit U_pilote;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    ListBox2: TListBox;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-dclarations }
    dbase_Paradox: Boolean;
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  Uses dbiProcs, dbiTypes;

{$R *.DFM}

function f_verifie_dbi(p_valeur: Integer): Boolean;
  var l_chaine_z: array[0..DbiMaxMsgLen] of char;
      l_chaine: String;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);

          l_chaine:= StrPas(l_chaine_z);
          l_chaine:= IntToStr(p_valeur)+ ' '+ l_chaine;
          ShowMessage('erreur Dbi: '+ l_chaine);
        end;

    f_verifie_dbi:= p_valeur= 0;
  end; (* f_verifie_dbi *)

function f_booleen(p_booleen: boolean): String;
  begin
    if p_booleen
      then f_booleen:= ''
      else f_booleen:= 'PAS ';
  end; (* f_booleen *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  ListBox1.Clear;
  Session.GetDriverNames(ListBox1.Items);
end;

procedure affiche_parametres(p_nom_pilote: String; p_chaines: tStrings);
  const k_categorie: array[drvFile..drvSqlBasedServer] of String
      = ('drvFile', 'drvOtherServer', 'drvSQLBasedServer');
  var l_info_pilote: DrvType;
      l_chaine_z: String;
  begin
    p_nom_pilote:= p_nom_pilote+ chr(0);

    p_chaines.Clear;

    if f_verifie_dbi(DbiGetDriverDesc(@p_nom_pilote[1], l_info_pilote))
      then
        with l_info_pilote, p_chaines do
        begin
          Add('szType:       '+ StrPas(szType)+ ' (nom)');
          Add('szText:       '+ StrPas(szText));
          Add('edrvCat:      '+ k_categorie[edrvCat]);
          Add('bTrueDb:      '+ 'maintient '+ f_booleen(bTrueDb) + 'un dictionnaire');
          Add('szDbType:     '+ StrPas(szDbType)+ ' (type base)');
          Add('bMultiUser:   '+ 'accepte '+ f_booleen(bMultiUser) + 'multiples utilisateurs');
          Add('bReadWrite:   '+ 'supporte '+ f_booleen(bReadWrite) + 'criture');
          Add('bTrans:       '+ 'supporte '+ f_booleen(bTrans) + 'les transactions');
          Add('bPassTruSql:  '+ 'supporte '+ f_booleen(bPassThruSql) + 'Pass Thru SQL');
          Add('bLogIn:       '+ 'supporte '+ f_booleen(bLogIn) + 'log in');
          Add('bCreateDb:    '+ 'peut '+ f_booleen(bCreateDb) + 'crer base');
          Add('bCreateTable: '+ 'peut '+ f_booleen(bCreateTable) + 'crer table');
        end;
  end; (* affiche_parametres *)

procedure TForm1.ListBox1Click(Sender: TObject);
var l_nom: String;
begin
  l_nom:= ListBox1.Items[ListBox1.ItemIndex];
  If l_nom= 'STANDARD'
    then
      if dBase_Paradox
        then l_nom:= 'dBase'
        else l_nom:= 'Paradox';
  ListBox2.Font.Name:= 'FixedSys';


  affiche_parametres(l_nom, ListBox2.Items);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  dBase_Paradox:= Not dBase_Paradox;
end;

procedure TForm1.Button3Click(Sender: TObject);
var l_curseur_Dbi: hDbiCur;
    l_nom_z: Array[0..63] of Char;
begin
  ListBox1.Clear;
  If f_verifie_dbi(DbiOpenDriverList(l_curseur_Dbi))
    then begin
        while DbiGetNextRecord(l_curseur_dbi, dbiNOLOCK, @l_nom_z, nil) = 0 do
          ListBox1.Items.Add(StrPas(l_nom_z));
        DbiCloseCursor(l_curseur_dbi);
      end;
end;

end.


