(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_repef1 *)
(* 12 jul 95 *)

(* -- gestion de rpertoires *)

unit U_repef1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    changer: TButton;
    vider: TButton;
    effacer: TButton;
    met_fichier: TButton;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    vider_tout: TButton;
    Edit2: TEdit;
    GetDir_: TButton;
    SelDir_: TButton;
    procedure creerClick(Sender: TObject);
    procedure testerClick(Sender: TObject);
    procedure changerClick(Sender: TObject);
    procedure effacerClick(Sender: TObject);
    procedure met_fichierClick(Sender: TObject);
    procedure efface_fichiers(Sender: TObject);
    procedure vider_toutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetDir_Click(Sender: TObject);
    procedure SelDir_Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  function f_teste_repertoire(p_nom: String): Integer;
    begin
      (*$i-*)
      ChDir(p_nom);
      (*$i+*)
      f_teste_repertoire:= IoResult;
    end; (* f_teste_repertoire *)

  procedure efface_repertoire(p_chemin: String);
    var l_entree: tSearchRec;
        l_fichier: file;
        l_erreur: Integer;
    begin
      (* -- cherche le premier, et stocke paramtres dans l_entree *)
      findfirst(p_chemin+ '*.*', $3F, l_entree);

      (* -- saute . et .. situes au dbut de chaque rpertoire *)
      if p_chemin<> '\'
        then begin
            l_erreur:= findnext(l_entree);
            l_erreur:= findnext(l_entree);
          end;

      while l_erreur= 0 do
      begin
        if (l_entree.attr and faDirectory)= 0
          then begin
              (* -- efface tous les fichiers *)
              assign(l_fichier, p_chemin+ l_entree.name);
              erase(l_fichier);
            end; (* efface un fichier *)

        (* -- le fichier suivant de ce sous-rpertoire *)
        l_erreur:= findnext(l_entree);
      end; (* tant qu'il y a des entres dans cette table *)

      (* -- supprime le . final *)
      delete(p_chemin, length(p_chemin), 1);
    end; (* efface_repertoire *)

  procedure efface_repertoires(p_chemin: String);
    var l_entree: tSearchRec;
        l_fichier: file;
        l_erreur: Integer;
    begin
      (* -- cherche le premier, et stocke paramtres dans l_entree *)
      findfirst(p_chemin+ '*.*', $3F, l_entree);

      (* -- saute . et .. situes au dbut de chaque rpertoire *)
      if p_chemin<> '\'
        then begin
            l_erreur:= findnext(l_entree);
            l_erreur:= findnext(l_entree);
          end;

      while l_erreur= 0 do
      begin
        if (l_entree.attr and faDirectory)<> 0
          then efface_repertoire(p_chemin+ l_entree.name+ '\')
          else begin
              (* -- efface tous les fichiers *)
              assign(l_fichier, p_chemin+ l_entree.name);
              erase(l_fichier);
            end; (* efface un fichier *)

        (* -- le fichier suivant de ce sous-rpertoire *)
        l_erreur:= findnext(l_entree);
      end; (* tant qu'il y a des entres dans cette table *)

      (* -- supprime le . final *)
      delete(p_chemin, length(p_chemin), 1);
      RmDir(p_chemin);
    end; (* efface_repertoires *)

(* -- affichage du prpertoire courant *)

procedure TForm1.FormCreate(Sender: TObject);
begin
  DirectoryListBox1.Directory:= 'C:\';
  DirectoryListBox1.UpDate;
end;

(* -- crer *)

procedure TForm1.creerClick(Sender: TObject);
begin
  MessageBeep(0);
  Try
    MkDir(Edit1.Text);
    DirectoryListBox1.UpDate;
  except
    On l_exception: eInOutError do
      ShowMessage('erreur MkDir: '+ l_exception.Message
          + l_exception.Message);
  end;
end;

(* -- tester / changer *)

procedure TForm1.testerClick(Sender: TObject);
begin
  if Not DirectoryExists(Edit1.Text)
    then ShowMessage('le rpertoire '+ Edit1.Text+ ' n''existe pas');
end;

procedure TForm1.changerClick(Sender: TObject);
begin
  Try
    ChDir(Edit1.Text);

    DirectoryListBox1.Directory:= Edit1.Text;
    DirectoryListBox1.UpDate;
    Edit2.Text:= Edit1.Text;
  Except
    On e: eInOutError do
      ShowMessage('erreur ChgDir '+ 'existe pas');
  End;
end;

(* -- effacer *)

procedure TForm1.effacerClick(Sender: TObject);
(* -- efface un rpertoire (vide, et pas courant) *)
var l_chemin_courant: String;
begin
  try
    GetDir(0, l_chemin_courant);
    if UpperCase(l_chemin_courant)= UpperCase(Edit1.Text)
      then ShowMessage('peut pas effacer chemin courant')
      else RmDir(Edit1.Text);

    DirectoryListBox1.UpDate;
  Except
    On e: eInOutError do
      ShowMessage('erreur RmDir: '+ Edit1.Text+ ' '+ e.message);
  End;
end;

procedure TForm1.met_fichierClick(Sender: TObject);
(* -- place quelques fichiers pour tests *)
const vi_lettre: Char= 'A';
var l_fichier: File;
begin
  AssignFile(l_fichier, Edit1.Text+ '\bidon'+ vi_lettre+ '.DTA');
  Rewrite(l_fichier);
  System.Close(l_fichier);

  DirectoryListBox1.UpDate;
  FileListBox1.Update;

  vi_lettre:= succ(vi_lettre);
end;

procedure TForm1.efface_fichiers(Sender: TObject);
(* -- efface les fichiers d'un rpertoire *)
begin
  if UpperCase(Edit1.Text)<> 'C:\OSCAR'
    then ShowMessage('ce programme ne permet que l''effacement de C:\OSCAR')
    else begin
         efface_repertoire(Edit1.Text+ '\');
         DirectoryListBox1.UpDate;
         FileListBox1.Update;
       end;
end;

procedure TForm1.vider_toutClick(Sender: TObject);
begin
  if UpperCase(Edit1.Text)<> 'C:\OSCAR'
    then ShowMessage('ce programme ne permet que l''effacement de OSCAR')
    else efface_repertoires(Edit1.Text+ '\');
end;

procedure TForm1.GetDir_Click(Sender: TObject);
var l_chemin: String;
begin
  GetDir(0, l_chemin);
  Edit2.Text:= l_chemin;
end;

procedure TForm1.SelDir_Click(Sender: TObject);
var l_nom: String;
begin
  l_nom:= 'OSCAR';
  If SelectDirectory(l_nom, [sdAllowCreate, sdPrompt], 0)
    THEN ShowMessage('a pu changer');
end;

end.


