(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_affdic *)

unit U_affdic;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Button2: TButton;
    table_bases: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    table_tables: TTable;
    DataSource2: TDataSource;
    table_field_defs: TTable;
    DataSource3: TDataSource;
    DBGrid3: TDBGrid;
    table_index_defs: TTable;
    DataSource4: TDataSource;
    DBGrid4: TDBGrid;
    procedure Button2Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource2DataChange(Sender: TObject; Field: TField);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  (*$i ..\..\u\f_fiedef *)

  procedure affiche_field_defs(p_field_defs: tFieldDefs; p_chaines: tStrings);
    var l_indice: Integer;
        l_texte, l_obligatoire: String;
    begin
      with p_field_defs, p_chaines do
      begin
        Clear;
        For l_indice:= 0 to p_field_defs.Count- 1 do
          with p_field_defs[l_indice] do
          begin
            if required
              then l_obligatoire:= 'obligatoire'
              else l_obligatoire:= 'optionnel';
            l_texte:= Format('  %-2d %-11s %-12s %3d %-10s', [FieldNo, Name, f_field_def(DataType), Size, l_obligatoire]);

            Add(l_texte);
          end; (* For, With *)
      end; (* with *)
    end; (* affiche_field_defs *)

  (*$i ..\..\u\f_op_ind *)

  procedure affiche_index_defs(p_index_defs: tIndexDefs; p_chaines: tStrings);
    var l_indice: Integer;
    begin
      with p_index_defs, p_chaines do
      begin
        Clear;

        For l_indice:= 0 to p_index_defs.Count- 1 do
          with p_index_defs.Items[l_indice] do
            Add( Format('%-10s %-10s %-10s %-15s',
                [Name, Fields, f_options_index(Options), Expression]) );
      end; (* with p_table, p_liste *)
    end;

(* -- interface *)

procedure TForm1.Button2Click(Sender: TObject);
begin
  with table_bases do
  begin
    DatabaseName:= 'Flix';
    TableName:= 'BASES.DBF';
    Open;
  end;

  with table_tables do
  begin
    DatabaseName:= 'Flix';
    TableName:= 'TABLES.DBF';

    IndexName:= 'IND_BASTAB';
    Open;
  end;

  with table_field_defs do
  begin
    DatabaseName:= 'Flix';
    TableName:= 'FIELD_DE.DBF';

    IndexName:= 'IND_BATACH';
    Open;
  end;

  with table_index_defs do
  begin
    DatabaseName:= 'Flix';
    TableName:= 'INDEX_DE.DBF';

    IndexName:= 'IND_BATAIN';
    Open;
  end;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  with table_tables do
  begin
    if Active
      then begin
          SetRangeStart;
          Fields[0]:= table_bases.Fields[0];
          Fields[1].AsString:= '';
          SetRangeEnd;
          Fields[0]:= table_bases.Fields[0];
          Fields[1].AsString:= 'ZZZZZ';
          ApplyRange;
        end;
  end;
end;

procedure TForm1.DataSource2DataChange(Sender: TObject; Field: TField);
begin
  with table_field_defs do
  begin
    if Active
      then begin
{
          Label1.Caption:= table_bases.Fields[0].AsString+ ' '+
            table_tables.Fields[1].AsString+ ' ';
}
          SetRangeStart;
          Fields[0]:= table_bases.Fields[0];
          Fields[1]:= table_tables.Fields[1];
          Fields[2].AsString:= '';
          SetRangeEnd;
          Fields[0]:= table_bases.Fields[0];
          Fields[1]:= table_tables.Fields[1];
          Fields[2].AsString:= 'ZZZZZ';
          ApplyRange;
        end;
  end;

  with table_index_defs do
  begin
    if Active
      then begin
          SetRangeStart;
          Fields[0]:= table_bases.Fields[0];
          Fields[1]:= table_tables.Fields[1];
          Fields[2].AsString:= '';
          SetRangeEnd;
          Fields[0]:= table_bases.Fields[0];
          Fields[1]:= table_tables.Fields[1];
          Fields[2].AsString:= 'ZZZZZ';
          ApplyRange;
        end;
  end;
end;

end.


