(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_credic *)

unit U_credic;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button2: TButton;
    table_bases: TTable;
    table_tables: TTable;
    table_field_defs: TTable;
    table_index_defs: TTable;
    procedure Button2Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  (*$i ..\..\u\f_fiedef *)
  (*$i ..\..\u\f_op_ind *)

  (* -- interface *)

procedure TForm1.Button2Click(Sender: TObject);
var l_liste_noms_bases: tStringList;
    l_indice_base: Integer;
    l_nom_base: String;

  procedure cree_les_tables;
    begin
      WITH table_bases DO
      BEGIN
        DatabaseName:= 'Flix';
        TableName:= 'BASES';
        TableType:= ttdBase;
        FieldDefs.Clear;
        FieldDefs.Add('NOM_BASE', ftString, 20, True);
        CreateTable;
      end;

      With table_tables do
      begin
        DatabaseName:= 'Flix';
        TableName:= 'TABLES';
        TableType:= ttdBase;
        FieldDefs.Clear;
        FieldDefs.Add('NOM_BASE', ftString, 20, True);
        FieldDefs.Add('NOM_TABLE', ftString, 10, True);

        IndexDefs.Clear;
        CreateTable;
        AddIndex('IND_BASTAB', 'NOM_BASE+NOM_TABLE', [ixExpression]);
      end;
      With table_field_defs do
      begin
        DatabaseName:= 'Flix';
        TableName:= 'FIELD_DE';
        TableType:= ttdBase;
        FieldDefs.Clear;
        FieldDefs.Add('NOM_BASE', ftString, 20, True);
        FieldDefs.Add('NOM_TABLE', ftString, 10, True);
        FieldDefs.Add('NOM_CHAMP', ftString, 10, True);
        FieldDefs.Add('TYPE_CHAMP', ftString, 10, True);
        FieldDefs.Add('TAILLE_CHA', ftSmallInt, 0, True);

        IndexDefs.Clear;
        CreateTable;

        AddIndex('IND_BATACH', 'NOM_BASE+NOM_TABLE+NOM_CHAMP', [ixExpression]);
      end;
      With table_index_defs do
      begin
        DatabaseName:= 'Flix';
        TableName:= 'INDEX_DE';
        TableType:= ttdBase;
        FieldDefs.Clear;
        FieldDefs.Add('NOM_BASE', ftString, 20, True);
        FieldDefs.Add('NOM_TABLE', ftString, 10, True);
        FieldDefs.Add('NOM_INDEX', ftString, 10, True);
        FieldDefs.Add('CHAMPS_IND', ftString, 20, True);
        FieldDefs.Add('OPTION_IND', ftString, 20, True);
        FieldDefs.Add('EXPRES_IND', ftString, 20, True);

        IndexDefs.Clear;
        CreateTable;

        AddIndex('IND_BATAIN', 'NOM_BASE+NOM_TABLE+NOM_INDEX', [ixExpression]);
      end;
    end; (* cree_les_tables *)

  procedure cree_table_tables;
    var l_liste_noms_tables: tStringList;
        l_indice_table: Integer;
        l_nom_table: String;

    procedure cree_table_field_defs(p_field_defs: tFieldDefs);
      var l_indice_champ: Integer;
      begin
        With table_field_defs do
        begin
          For l_indice_champ:= 0 to p_field_defs.Count- 1 do
            with p_field_defs[l_indice_champ] do
              AppendRecord([l_nom_base, l_nom_table, Name, f_field_def(DataType), Size]);
        end; (* with table_field_defs *)
      end; (* cree_table_field_defs *)

    procedure cree_table_index_defs(p_index_defs: tIndexDefs);
      var l_indice_index: Integer;
      begin
        With table_index_defs do
        begin
          For l_indice_index:= 0 to p_index_defs.Count- 1 do
            with p_index_defs[l_indice_index] do
              AppendRecord([l_nom_base, l_nom_table, Name, Fields, f_options_index(Options), Expression]);
        end; (* with table_index_defs *)
      end; (* cree_table_index_defs *)

    begin (* cree_table_tables *)
      With table_tables do
      begin
        l_liste_noms_tables:= tStringList.Create;

        Session.GetTableNames(l_nom_base, '*.dbf', True, False, l_liste_noms_tables);
        For l_indice_table:= 0 to l_liste_noms_tables.Count- 1 do
        begin
          l_nom_table:= l_liste_noms_tables[l_indice_table];
          AppendRecord([l_nom_base, l_nom_table]);

          With Table1 DO
          begin
            DatabaseName:= l_nom_base;
            TableName:= l_nom_table;
            TableType:= ttDbase;

            FieldDefs.Update;
            cree_table_field_defs(FieldDefs);
            IndexDefs.Update;
            cree_table_index_defs(IndexDefs);
          end; (* with Table1 *)
        end; (* for l_indice_table *)

        l_liste_noms_tables.Free;
      end; (* with table_tables *)
    end; (* cree_table_tables *)

begin (* Button1Click *)
  cree_les_tables;

  table_bases.Open;
  table_tables.Open;
  table_field_defs.Open;
  table_index_defs.Open;

  WITH table_bases DO
  BEGIN
    l_liste_noms_bases:= tStringList.Create;

    Session.GetDatabaseNames(l_liste_noms_bases);
    For l_indice_base:= 0 to l_liste_noms_bases.Count- 1 do
    begin
      l_nom_base:= l_liste_noms_bases[l_indice_base];
      if l_nom_base<> 'IBLOCAL'
        then begin
            AppendRecord([l_nom_base]);
            cree_table_tables;
          end;
    end; (* for l_indice_base *)

    l_liste_noms_bases.Free;
  END; (* with table_bases do *)
  table_bases.Close;
  table_tables.Close;
  table_field_defs.Close;
  table_index_defs.Close;
end;

end.


