unit U_efface;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Query1: TQuery;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  {$R *.DFM}

(*$i ..\..\u\f_m_e_db *)

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
begin
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'EFF_DEL';
    TableType:= ttdBase;

    TRY
      FieldDefs.Clear;

      FieldDefs.Add('NUMERO', ftSmallInt, 0, True);
      FieldDefs.Add('CLIENT', ftString, 10, True);
      FieldDefs.Add('SOLDE', ftFloat, 0, True);

      IndexDefs.Clear;
      IndexDefs.Add('IND_CLIENT', 'CLIENT', []);
      IndexDefs.Add('IND_NUMERO', 'NUMERO', []);
      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFieldName : l_erreur:= 'nom zone incorrect';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)
  end; (* with *)
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_erreur: String;
begin
  with Table1 do
  begin
    Close;
    DatabaseName := 'Flix';
    TableName := 'EFF_DEL';
    TableType := ttDbase;
{
    DeleteTable;
}

    TRY
      DeleteTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_FileBusy : l_erreur:= 'Table utilise';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)
  end; (* with *)
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  With Query1 DO
  begin
    DatabaseName:= 'Flix';
    Close;
    Sql.Clear;
    Sql.Add('DROP TABLE "EFF_DEL.DBF"');
    ExecSql;
  end; (* with Query1 *)
end;

procedure TForm1.Button4Click(Sender: TObject);
var l_erreur: String;
begin
  with Table1 do
  begin
    Close;
    DatabaseName := 'Flix';
    TableName := 'EFF_DEL';
    TableType := ttDbase;

    TRY
      Exclusive:= True;
      Open;
      DeleteIndex('IND_CLIENT');
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_FileBusy : l_erreur:= 'Table utilise';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)
  end; (* with Table1 *)
end;

procedure TForm1.Button5Click(Sender: TObject);
var l_erreur: String;
begin
  With Query1 DO
  begin
    DatabaseName:= 'Flix';
    Close;
    Sql.Clear;
    Sql.Add('DROP INDEX "EFF_DEL.DBF".IND_CLIENT');
    (* NOK
    Sql.Add('DROP INDEX "EFF_DEL.DBF"');
    *)
    TRY
      ExecSql;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_FileBusy : l_erreur:= 'Table utilise';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)
  end; (* with Query1 *)
end;

procedure TForm1.Button6Click(Sender: TObject);
var l_liste_noms_index: tStringList;
    l_indice: Integer;
begin
  l_liste_noms_index:= tStringList.Create;

  with Table1 do
  begin
    Close;
    DatabaseName := 'Flix';
    TableName := 'EFF_DEL';
    TableType := ttDbase;

    GetIndexNames(l_liste_noms_index);

    Exclusive:= True;
    Open;
    For l_indice:= 0 to l_liste_noms_index.Count- 1 do
      DeleteIndex(l_liste_noms_index[l_indice]);

    Close;
  end; (* with Table1 *)

  l_liste_noms_index.Free;
end;

procedure TForm1.Button7Click(Sender: TObject);
Var l_fichier: File;
    l_octet: Byte;
begin
  System.Assign(l_fichier, 'C:\OSCAR\EFF_DEL.DBF');
  System.Reset(l_fichier, 1);

  Seek(l_fichier, 28);
  l_octet:= 0;
  BlockWrite(l_fichier, l_octet, 1);

  System.Close(l_fichier);
end;

procedure TForm1.Button8Click(Sender: TObject);
var l_erreur: String;
begin
  with Table1 do
  begin
    Close;
    DatabaseName := 'Flix';
    TableName := 'EFF_DEL';
    TableType := ttDbase;
    TRY
      Open;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_FileBusy : l_erreur:= 'Table utilise';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)
  end; (* with *)
end;

end.
