(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_affin3 *)
(* 20 oct 95 *)

unit U_affin3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiErrs, DbiProcs;

{$R *.DFM}

  function f_verifie_dbi(p_valeur: Integer): Boolean;
    var l_chaine_z: array[0..DbiMaxMsgLen] of char;
    begin
      if p_valeur<> 0
        then begin
            DbiGetErrorString(p_valeur, @l_chaine_z);

            ShowMessage('erreur Dbi: '+ IntToStr(p_valeur)+ ' '+ StrPas(l_chaine_z));
          end;

      f_verifie_dbi:= p_valeur= 0;
    end; (* f_verifie_dbi *)

  (*$i ..\..\u\f_op_ind *)

  procedure affiche_noms_index(p_table: tTable; p_chaines: tStrings);
    var l_indice: Integer;
    begin
      with p_table, p_chaines do
      begin
        Clear;

        For l_indice:= 0 to IndexDefs.Count- 1 do
          with IndexDefs.Items[l_indice] do
            Add(Name);
      end; (* with p_table, p_liste *)
    end;

  procedure affiche_un_index_def(p_index_def: tIndexDef; p_chaines: tStrings);
    begin
      with p_index_Def, p_chaines do
      begin
        p_chaines.Clear;

        Add('Fields    : '+ Fields);
        Add('Options   : '+ f_options_index(Options));
        Add('Expression: '+ Expression);
      end; (* with p_ *)
    end;

  procedure affiche_descripteur_index_actif(p_chaines: tStrings);
    const vi_booleen: array[False..True] of String= ('False', 'True');
    var l_descripteur_index: IdxDesc;
        l_texte: String;
        l_indice: Integer;
    begin
      (* -- 0 pour index actif *)
      f_verifie_dbi(DbiGetIndexDesc(Form1.Table1.Handle, 0, l_descripteur_index));

      with l_descripteur_index, p_chaines do
      begin
        Clear;

        Add('iFldsInKey: ' + IntToStr(iFldsInKey));
        Add('bExpIdx: ' + vi_booleen[bExpIdx]);
        if bExpIdx
          then Add('szKeyExp: '+ StrPas(szKeyExp));
        Add('bSubSet: '+ vi_booleen[bSubSet]);
        if bSubSet
          then Add('szKeyCond: '+ StrPas(szKeyCond));

        l_texte:= '';
        For l_indice:= 0 To 5 do
          l_texte:= l_texte+ IntToStr(aiKeyFld[l_indice])+ ', ';
        Add('aiKeyFkd: '+ l_texte);
      end; (* with l_descripteur_index *)
    end;

(* -- interface *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  Session.GetTableNames('C:\OSCAR', '*.db', True, False, ListBox1.Items);
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  Table1.DatabaseName:= 'C:\OSCAR';
  Table1.TableName:= ListBox1.Items[ListBox1.ItemIndex];

  Table1.IndexDefs.Update;
  Table1.GetIndexNames(ListBox2.Items);
end;

procedure TForm1.ListBox2Click(Sender: TObject);
var l_nom_index: String;
    l_indice: Integer;
begin
  l_nom_index:= ListBox2.Items[ListBox2.ItemIndex];

  l_indice:= -1;
  repeat
    inc(l_indice);
  until Table1.IndexDefs[l_indice].Name= l_nom_index;

  ListBox3.Font.Name:= 'FixedSys';
  affiche_un_index_def(Table1.IndexDefs[l_indice], ListBox3.Items);

  (* -- l'index doit tre 'ouvert' ou 'actif' *)
  Table1.IndexName:= l_nom_index;
  (* -- la Table doit tre ouverte pour avoir un Handle correct *)
  Table1.Open;
  ListBox4.Font.Name:= 'FixedSys';
  affiche_descripteur_index_actif(ListBox4.Items);
  Table1.IndexName:= '';
  Table1.Close;
end;

end.


