(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_creiun *)

unit U_creiun;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

(*$i ..\..\u\f_errdbi *)

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
begin
  WITH Table1 DO
  BEGIN
    Close;

    DatabaseName:= 'Flix';

    TableName:= 'CREE_I_D';
    TableType:= ttdBase;

    TRY
      FieldDefs.Clear;

      FieldDefs.Add('NUMERO', ftSmallInt, 0, True);
      FieldDefs.Add('CLIENT', ftString, 10, True);
      FieldDefs.Add('SOLDE', ftFloat, 0, True);

      (* OK *)
{
      IndexDefs.Update;
}
      IndexDefs.Clear;
      IndexDefs.Add('IND_CLIENT', 'CLIENT', []);
{
      (* OK *)
      IndexDefs.Add('IND_CLIENT', 'CLIENT', [ixDescending]);
}
{
      (* NOK *)
      IndexDefs.Add('IND_CLIENT', 'CLIENT', [ixCaseInsensitive]);
}
{
      (* NOK *)
      IndexDefs.Add('IND_CLIENT', 'CLIENT+STR(NUMERO)', [ixExpression]);
}
{
      (* NOK *)
      IndexDefs.Add('IND_CLIENT', 'CLIENT', [ixExpression]);
      (* mm si: *)
      Close;
      Exclusive:= True;
}
      CreateTable;
{
      (* OK *)
      AddIndex('IND_CLIENT', 'CLIENT+STR(NUMERO)', [{ixDescending, ixExpression]);
}
{
      (* NOK *)
      AddIndex('IND_CLIENT', 'CLIENT+STR(NUMERO)', [ixDescending, ixExpression]);
}

    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            DbiErr_InvalidFieldName : l_erreur:= 'nom zone incorrect';
            else l_erreur:= ' Dbi '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ ' = '+ f_erreur_dbi(ErrorCode) );
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* except *)

    Table1.Open;
    AppendRecord([1, 'Joe', 3.14]);
    AppendRecord([2, 'Sam', 3.14]);
    AppendRecord([3, 'Gus', 3.14]);
    AppendRecord([4, 'Joe', 3.14]);
  end; (* with Table1 *)
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  Table1.IndexDefs.Update;
  if Key= chr(13)
    then begin
       Table1.IndexName:= Edit1.Text;
       Key:= chr(0);
       Table1.Open
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var e: Exception;
    l_erreur: String;
begin
{
  Table1.Close;
  Table1.AddIndex('IND_CLINUM', 'CLIENT+STR(NUMERO, 3, 0)', [ixExpression]);
}
{
  try
    Table1.AddIndex('IND_CLINUM', 'CLIENT+STR(NUMERO, 3, 0)', [ixExpression]);
  Except
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_NeedExclAccess : l_erreur:= 'table utilise. Doit tre exclusif';
            else l_erreur:= ' Dbi '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ ' = '+ f_erreur_dbi(ErrorCode) );
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
  end;
}
  try
    Table1.Close;

    Table1.AddIndex('IND_CLINUM', 'CLIENT+STR(NUMERO, 3, 0)', [ixExpression]);
  Except
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
          if ErrorCode= DbiErr_NeedExclAccess
            then ShowMessage('Table utilise. Pour AddIndex faut accs exclusif');
  end;
end;

end.
