(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_affde4 *)
(* 30 aou 95 *)

unit U_affde4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    ListBox5: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiErrs, DbiProcs;

{$R *.DFM}

  function f_type_champ(p_type: tFieldType): String;
    var l_type: String;
    begin
      case p_type of
        ftUnknown : l_type:= 'ftUnKnown';
        ftString : l_type:= 'ftString';
        ftSmallint : l_type:= 'ftSmallInt';
        ftInteger : l_type:= 'ftInteger';
        ftWord : l_type:= 'ftWord';
        ftBoolean : l_type:= 'ftBoolean';
        ftFloat : l_type:= 'ftFloat';
        ftCurrency : l_type:= 'ftCurrency';
        ftBCD : l_type:= 'ftBCD';
        ftDate : l_type:= 'ftDate';
        ftTime : l_type:= 'ftTime';
        ftDateTime : l_type:= 'ftDateTime';
        ftBytes : l_type:= 'ftBytes';
        ftVarBytes : l_type:= 'ftVarBtyes';
        ftBlob : l_type:= 'ftBlob';
        ftMemo : l_type:= 'ftMemo';
        ftGraphic : l_type:= 'ftGraphic';
        else l_type:= '??';
      end; (* case *)

      f_type_champ:= l_type;
    end; (* f_type_champ *)

  procedure affiche_defs(p_table: tTable; p_chaines: tStrings);
    var l_indice: Integer;
        l_texte, l_obligatoire: String;
    begin
      with p_table, p_chaines do
      begin
        Clear;
        For l_indice:= 0 to FieldDefs.Count- 1 do
          with FieldDefs[l_indice] do
          begin
            if required
              then l_obligatoire:= 'obligatoire'
              else l_obligatoire:= 'optionnel';
            l_texte:= Format('  %-2d %-11s %-12s %3d %-10s', [FieldNo, Name, f_type_champ(DataType), Size, l_obligatoire]);

            Add(l_texte);
          end; (* For, With *)
      end; (* with Table1 *)
    end; (* affiche_defs *)

  function f_verifie_dbi(p_valeur: Integer): Boolean;
    var l_chaine_z: array[0..DbiMaxMsgLen] of char;
    begin
      if p_valeur<> 0
        then begin
            DbiGetErrorString(p_valeur, @l_chaine_z);

            ShowMessage('erreur Dbi: '+ IntToStr(p_valeur)+ ' '+ StrPas(l_chaine_z));
          end;

      f_verifie_dbi:= p_valeur= 0;
    end; (* f_verifie_dbi *)

  function f_type_logique_dbi(p_valeur: Word): String;
    begin
      case p_valeur of
        fldZString : Result:= 'FldZString';

        fldUint16 : Result:= 'fldUint16';
        fldInt16 : Result:= 'fldInt16';
        fldUint32 : Result:= 'fldUint32';
        fldFloat : Result:= 'fldFloat';
        fldFloatIeee : Result:= 'fldFloatIeee';

        fldBool : Result:= 'fldBool';

        fldBytes : Result:= 'fldBytes';
        fldVarBytes : Result:= 'fldVarBytes';

        else result:= '??';
      end; (* case *)
    end; (* f_type_logique_dbi *)

  function f_type_physique_dbi(p_valeur: Word): String;
    begin
      case p_valeur of
        fldDBCHAR : Result:= 'FldDbChar';

        fldDBNUM : Result:= 'FldDbNum';
        fldDBFLOAT : Result:= 'FldDbFloat';

        fldDBDATE : Result:= 'FldDbDate';
        fldDBBOOL : Result:= 'FldDbBool';

        fldDBMEMO : Result:= 'FldDbMemo (mmo, blob)';
        fldDBLOCK : Result:= 'FldDbLock';
        fldDBOLEBLOB : Result:= 'FldDbOleBlob (ole blob)';
        fldDBBINARY : Result:= 'FldDbBinary';
        fldDBBYTES : Result:= 'FldDbBytes (tables temp)';
        else result:= '??';
      end; (* case *)
    end; (* f_type_physique_dbi *)

  procedure affiche_desc_logique(p_table: tTable; p_chaines: tStrings);
    type t_descripteurs= array[0..0] of FldDesc;
    var l_pt_descripteurs: ^t_descripteurs;
        l_zone: Integer;
    begin
      with p_table, FieldDefs do
      begin
        p_chaines.Clear;
        GetMem(l_pt_descripteurs, Count* SizeOf(FldDesc));
        f_verifie_dbi(DbiGetFieldDescs(Handle, @l_pt_descripteurs^ ));

        for l_zone:= 0 to Count- 1 do
          with l_pt_descripteurs^[l_zone] do
            p_chaines.Add(Format('%-10s %-15s %3d %3d', [StrPas(@szName), f_type_logique_dbi(iFldType), iUnits1, iUnits2]));

        FreeMem(l_pt_descripteurs, Count* SizeOf(FldDesc));
      end;
    end; (* affiche_desc_logique *)

  procedure affiche_desc_physique(p_table: tTable; p_chaines: tStrings);
    type t_descripteurs= array[0..0] of FldDesc;
    var l_nom: String;
        l_poignee_curseur: hDbiCur;
        l_pt_descripteurs: ^t_descripteurs;
        l_zone, l_nombre_zones: Integer;
    begin
      l_nom:= 'C:\OSCAR\'+ p_table.TableName+ chr(0);

      f_verifie_dbi(DbiOpenTable(p_table.DbHandle,
          @l_nom[1], NIL, NIL, NIL, 0,
          dbiReadOnly, dbiOpenShared,
          xltNone, False, nil,
          l_poignee_curseur) );

      l_nombre_zones:= p_table.FieldDefs.Count;
      p_chaines.Clear;
      GetMem(l_pt_descripteurs, l_nombre_zones* SizeOf(FldDesc));
      f_verifie_dbi(DbiGetFieldDescs(l_poignee_curseur, @l_pt_descripteurs^ ));

      for l_zone:= 0 to l_nombre_zones- 1 do
        with l_pt_descripteurs^[l_zone] do
          p_chaines.Add(Format('%-10s %-15s %3d %3d', [StrPas(@szName), f_type_physique_dbi(iFldType), iUnits1, iUnits2]));

      FreeMem(l_pt_descripteurs, l_nombre_zones* SizeOf(FldDesc));

      f_verifie_dbi(DbiCloseCursor(l_poignee_curseur));
    end; (* affiche_desc_physique *)

  procedure affiche_en_tete_dbf(p_nom: String; p_chaines: tStrings);
    const k_taille_descripteur_zone= 32;
          k_descripteur_zone_max= 127;
          k_taille_en_tete_max= 4130;
          k_taille_nom_zone_max= 10;
    type t_en_tete_donnees= record
                              signature: byte;
                              date_derniere_mise_a_jour: array[0..2] of byte;
                              nombre_fiches: longint;
                              taille_en_tete: word;
                              taille_fiche: word;
                              remplissage: array[12..31] of byte;
                              (*
                              tableau_description_zones: array[0..k_descripteur_zone_max- 1]
                                of t_descripteur_de_zone;
                               *)
                            end;
    var l_donnees: file;
        l_en_tete: t_en_tete_donnees;

    procedure affiche_les_descripteurs_de_zone;
      type t_nom_zone= array[0..k_taille_nom_zone_max] of char;
           t_descripteur_de_zone= record
                                    nom_zone: t_nom_zone;
                                    type_zone: char;
                                    adresse_memoire: longint;
                                    taille_zone: byte;
                                    nombre_decimales: byte;
                                    remplissage: array[18..31] of byte;
                                  end;
      var l_numero_zone: integer;
          l_descripteur: t_descripteur_de_zone;
      begin
        with p_chaines do
        begin
          l_numero_zone:= 0;

          while FilePos(l_donnees)+ 1< l_en_tete.taille_en_tete do
          begin
            BlockRead(l_donnees, l_descripteur, 32);
            with l_descripteur do
              p_chaines.Add(Format('%-10s  %1s   %3d    %3d',
                  [StrPas(nom_zone), type_zone, taille_zone, nombre_decimales]));

            l_numero_zone:= l_numero_zone+ 1;
          end;
        end;
      end; (* affiche_les_descripteurs_de_zone *)

    begin (* affiche_en_tete_dbf *)
      p_chaines.Clear;

      assign(l_donnees, p_nom);
      reset(l_donnees, 1);
      blockread(l_donnees, l_en_tete, 32);

      with l_en_tete, p_chaines do
      begin
        Add('nombre de fiches '+ FloatToStr(nombre_fiches));
        Add('taille en-tete:   '+ IntToStr(taille_en_tete));
        Add('taille fiche:     '+ IntToStr(taille_fiche));
      end;

      affiche_les_descripteurs_de_zone;

      close(l_donnees);
    end; (* remplis_prologue *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  Session.GetTableNames('C:\OSCAR', '*.dbf', True, False, ListBox2.Items);
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
  Table1.Close;
  Table1.DatabaseName:= 'C:\OSCAR';
  Table1.TableName:= ListBox2.Items[ListBox2.ItemIndex];
  Table1.Open;

  ListBox1.Font.Name:= 'FixedSys';
  affiche_defs(Table1, ListBox1.Items);

  ListBox3.Font.Name:= 'FixedSys';
  affiche_desc_logique(Table1, ListBox3.Items);

  ListBox4.Font.Name:= 'FixedSys';
  affiche_desc_physique(Table1, ListBox4.Items);

  (* -- DOIT fermer, sinon erreur SHARE *)
  Table1.Close;
  ListBox5.Font.Name:= 'FixedSys';
  affiche_en_tete_dbf('C:\OSCAR\'+ Table1.TableName, ListBox5.Items);
end;

end.

