(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 i_analys *)
(* 24 nov 95 *)

    type t_type_symbole= (e_symbole_vide,
            e_symbole_champ,
            e_symbole_chaine,
            e_symbole_entier,
            e_symbole_flottant,

            e_symbole_egal,
            e_symbole_plus, e_symbole_moins, e_symbole_fois,
            e_symbole_parenthese_ouvrante, e_symbole_parenthese_fermante,
            e_symbole_AND, e_symbole_OR, e_symbole_NOT);

    var g_symboles_speciaux: array[' '..'~'] of t_type_symbole;

    function f_nombre(p_entier: Integer): String;
      var l_chaine: String;
      begin
        Str(p_entier, l_chaine);
        f_nombre:= l_chaine;
      end;

    function f_nom_symbole(p_symbole: t_type_symbole): string;
      var l_nom: String;
      begin
        case p_symbole of
          e_symbole_vide: l_nom:= 'vide';

          e_symbole_champ: l_nom:= 'CHAMP';
          e_symbole_chaine : l_nom:= 'chaine';
          e_symbole_entier: l_nom:= 'entier';
          e_symbole_flottant: l_nom:= 'flottant';

          e_symbole_egal: l_nom:= '=';

          e_symbole_plus : l_nom:= '+';
          e_symbole_moins : l_nom:= '-';
          e_symbole_fois : l_nom:= '*';
          e_symbole_parenthese_ouvrante : l_nom:= '(';
          e_symbole_parenthese_fermante: l_nom:= ')';

          e_symbole_AND : l_nom:= 'AND';
          e_symbole_OR: l_nom:= 'OR';
          e_symbole_NOT: l_nom:= 'NOT';

          else l_nom:= '??';
        end;

        f_nom_symbole:= l_nom;
      end; (* f_nom_symbole *)

    var l_indice, l_taille_ligne: Integer;
        l_type_symbole: t_type_symbole;
        l_nom_symbole: String;
        l_valeur_entier: LongInt;
        l_valeur_flottant: Double;

    procedure affiche_erreur(p_message: string);
      begin
{
        writeln;
        writeln('': 5, p_expression);
        write('^': 5+ l_indice, ' : ', p_message);
}
        halte('erreur '+ p_message);
      end; (* affiche_erreur *)

    procedure lis_symbole;

      procedure lis_identificateur;
        var l_indice_debut, l_taille: Word;
        begin
          l_indice_debut:= l_indice;
          while p_condition[l_indice] in ['A'..'Z', '_'] do
            inc(l_indice);

          l_taille:= l_indice- l_indice_debut;
          move(p_condition[l_indice_debut], l_nom_symbole[1], l_taille);
          l_nom_symbole[0]:= chr(l_taille);
          if l_nom_symbole= 'AND'
            then l_type_symbole:= e_symbole_AND
            else
              if l_nom_symbole= 'OR'
                then l_type_symbole:= e_symbole_OR
                else
                  if l_nom_symbole= 'NOT'
                    then l_type_symbole:= e_symbole_NOT
                    else
                      l_type_symbole:= e_symbole_champ;
        end; (* lis_identificateur *)

      procedure lis_nombre;
        var l_indice_debut, l_taille, l_indice_erreur: Word;
        begin
          l_indice_debut:= l_indice;
          while p_condition[l_indice] in ['0'..'9', '.', 'e'] do
            inc(l_indice);

          l_taille:= l_indice- l_indice_debut;
          move(p_condition[l_indice_debut], l_nom_symbole[1], l_taille);
          l_nom_symbole[0]:= chr(l_taille);

          val(l_nom_symbole, l_valeur_entier, l_indice_erreur);
          if l_indice_erreur= 0
            then l_type_symbole:= e_symbole_entier
            else begin
               val(l_nom_symbole, l_valeur_flottant, l_indice_erreur);
               if l_indice_erreur= 0
                 then l_type_symbole:= e_symbole_flottant
                 else affiche_erreur('pas un nombre dcimal');
              end;
        end; (* lis_nombre_decimal *)

      procedure lis_chaine;
        var l_indice_debut, l_taille: Word;
        begin
          (* -- saute ' du dbut *)
          inc(l_indice);

          l_indice_debut:= l_indice;
          while p_condition[l_indice]<> '''' do
            inc(l_indice);

          l_taille:= l_indice- l_indice_debut;
          move(p_condition[l_indice_debut], l_nom_symbole[1], l_taille);
          l_nom_symbole[0]:= chr(l_taille);

          (* -- saute ' de la fin *)
          inc(l_indice);

          l_type_symbole:= e_symbole_chaine;
        end; (* lis_chaine *)

      begin (* lis_symbole *)
        (* -- saute les blancs *)
        while p_condition[l_indice]= ' ' do
          inc(l_indice);

        (* -- ligne vide, ou a dpass la fin de la ligne *)
        if l_indice> l_taille_ligne
          then begin
              l_nom_symbole:= '';
              l_type_symbole:= e_symbole_vide;
            end
          else begin
              case p_condition[l_indice] of
                'a'..'z', 'A'..'Z', ''..'':
                    lis_identificateur;

                '0'..'9' : lis_nombre;
                '''': lis_chaine;

                '=', '+', '-', '*', '(', ')' :
                   begin
                     l_type_symbole:= g_symboles_speciaux[p_condition[l_indice]];
                     l_nom_symbole:= p_condition[l_indice];
                     inc(l_indice);
                   end;
                else
                  affiche_erreur('symbole illgal '+ p_condition[l_indice]);
                  inc(l_indice);
              end(* case *)
            end; (* -- pas fin de la ligne *)

{
        writeln('  sy: ', f_nom_symbole(l_type_symbole), ' ');
}
      end; (* lis_symbole *)

(* fin i_analys *)

