(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ufiltre *)

(*$r+*)

unit Ufiltre;

  interface
    uses
      SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
      Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables,
      DbiTypes, DbiProcs, DbiErrs;

    procedure analyse(p_table: tTable; p_condition: String;
        var pv_pt_tampon; var pv_taille: Word);
    procedure ajoute_filtre(p_table: tTable; p_condition: String;
        var pv_poignee_filtre: hDbiFilter);

  implementation

    (* $i fildel *)

    procedure halte(p_message: String);
      begin
  {
        writeln(chr(7), p_message); readln; Halt;
  }
        ShowMessage(p_message);
      end; (* halte *)

    type t_tampon= array[0..0] of Byte;
         t_pt_tampon= ^t_tampon;


    procedure analyse(p_table: tTable; p_condition: String;
        var pv_pt_tampon; var pv_taille: Word);

      (*$i i_analys *)

      type t_pt_chaine= ^String;
      type t_pt_cellule= ^t_cellule;
           t_cellule= record
                        pt_gauche, pt_droite: t_pt_cellule;
                        offset_1, offset_2, taille: Word;
                        type_symbole: t_type_symbole;
                        pt_nom_symbole: t_pt_chaine;
                        pt_noeud: Pointer;
                      end;

      procedure liste(p: t_pt_cellule);
        begin
          exit;

          if p<> nil
            then begin
                liste(p^.pt_gauche);
                with p^ do
                  writeln(pt_nom_symbole^, '': 15- Length(pt_nom_symbole^), offset_1: 4, offset_2: 4);
                liste(p^.pt_droite);
              end;
        end; (* liste *)

      var l_offset_litteraux: Integer;
      var l_pt_cellule_resultat: t_pt_cellule;

      procedure calcule_expression;

        function f_(p_type_symbole: t_type_symbole; p_nom_symbole: String): t_pt_cellule;
          var l_: t_pt_cellule;
          begin
            New(l_);
            FillChar(l_^, SizeOf(l_^), 0);

            with l_^ do
            begin
              pt_gauche:= nil;
              pt_droite:= nil;

              type_symbole:= p_type_symbole;
              GetMem(pt_nom_symbole, 1+ Length(p_nom_symbole));
              pt_nom_symbole^:= p_nom_symbole;
  {
              writeln(' ', p_nom_symbole);
  }
            end;
            f_:= l_;
          end; (* f_ *)

        procedure genere_champ(var pv_pt: t_pt_cellule);
          begin
            pv_pt:= f_(e_symbole_champ, l_nom_symbole);
            with pv_pt^ do
            begin
              taille:= SizeOf(CANField);
              GetMem(pt_noeud, taille);

              with pCANField(pt_noeud)^ do
              begin
                nodeClass:= nodeFIELD;
                canOp:= canFIELD2;
                iFieldNum:= p_table.FieldByName(l_nom_symbole).FieldNo- 1;
                iNameOffset:= l_offset_litteraux;
              end (* with pCAN()^ *)
            end; (* with pv_pt^ *)

            inc(l_offset_litteraux, Length(l_nom_symbole)+ 1);
          end; (* genere_champ *)

        procedure genere_constante(var pv_pt: t_pt_cellule);
          begin
            pv_pt:= f_(l_type_symbole, l_nom_symbole);

            with pv_pt^ do
            begin
              taille:= SizeOf(CANConst);
              GetMem(pt_noeud, taille);

              with pCANConst(pt_noeud)^ do
              begin
                nodeClass:= nodeConst;
                canOp:= canCONST2;
                iOffset:= l_offset_litteraux;

                case l_type_symbole of
                  e_symbole_entier : begin
                                       iType:= fldInt16;
                                       iSize:= 2;
                                     end;
                  e_symbole_flottant : begin
                                         iType:= fldFloat;
                                         iSize:= 8;
                                       end;
                  e_symbole_chaine : begin
                                       iType:= fldZString;
                                       iSize:= Length(l_nom_symbole)+ 1;
                                     end;
                  else halte('pas constante');
                end; (* case *)

                inc(l_offset_litteraux, iSize);
              end (* with pCAN()^ *)
            end; (* with pv_pt^ *)
          end; (* genere_constante *)

        procedure genere_binaire(p_symbole_binaire: t_type_symbole;
            p_pt_cellule_1, p_pt_cellule_2: t_pt_cellule; var pv_pt: t_pt_cellule);
          begin
            pv_pt:= f_(p_symbole_binaire, f_nom_symbole(p_symbole_binaire));
            pv_pt^.pt_gauche:= p_pt_cellule_1; pv_pt^.pt_droite:= p_pt_cellule_2;

            with pv_pt^ do
            begin
              taille:= SizeOf(CANBinary);
              GetMem(pt_noeud, taille);

              with pCANBinary(pt_noeud)^ do
              begin
                nodeClass:= nodeBinary;
                case p_symbole_binaire of
                  e_symbole_OR : canOp:= canOR;
                  e_symbole_AND : canOp:= canAND;

  {
                  e_symbole_fois : begin
                                   end;
  }
                  else halte('pas oprateur binaire');
                end; (* case *)
              end (* with pCAN()^ *)
            end; (* with pv_pt^ *)
          end; (* genere_binaire *)

        procedure genere_unaire(p_symbole_unaire: t_type_symbole; p_pt_cellule: t_pt_cellule;
            var pv_pt: t_pt_cellule);
          begin
            pv_pt:= f_(p_symbole_unaire, f_nom_symbole(p_symbole_unaire));
            pv_pt^.pt_gauche:= p_pt_cellule;

            with pv_pt^ do
            begin
              taille:= SizeOf(CANUnary);
              GetMem(pt_noeud, taille);
              with pCANUnary(pt_noeud)^ do
              begin
                nodeClass:= nodeUnary;
                case p_symbole_unaire of
                  e_symbole_NOT : canOp:= canNOT;
                  else halte('pas oprateur unaire');
                end; (* case *)
              end (* with pCAN()^ *)
            end; (* with pv_pt^ *)
          end; (* genere_unaire *)

        procedure genere_comparaison(p_symbole_comparaison: t_type_symbole;
            p_pt_cellule_1, p_pt_cellule_2: t_pt_cellule; var pv_pt: t_pt_cellule);
          begin
            pv_pt:= f_(p_symbole_comparaison, f_nom_symbole(p_symbole_comparaison));
            pv_pt^.pt_gauche:= p_pt_cellule_1; pv_pt^.pt_droite:= p_pt_cellule_2;

            with pv_pt^ do
            begin
              taille:= SizeOf(CANCompare);
              GetMem(pt_noeud, taille);
              with pCANCompare(pt_noeud)^ do
              begin
                nodeClass:= nodeCompare;
                case p_symbole_comparaison of
                  e_symbole_egal : canOp:= canEQ;
  {
                  e_symbole_superieur : canOp:= canGT;
      canNE          = 4;
      canLT          = 6;
      canGE          = 7;
      canLE          = 8;
  }
                  else halte('pas comparaison');
                end; (* case *)

                bCaseInsensitive:= False;
                iPartialLen:= 0;
              end (* with pCAN()^ *)
            end; (* with pv_pt^ *)
          end; (* genere_comparaison *)

        procedure analyse_expression(var pv_pt_cellule_expression: t_pt_cellule);

          procedure analyse_expression_simple(var pv_pt_cellule_expression_simple: t_pt_cellule);

            procedure compile_terme(var pv_pt_cellule_terme: t_pt_cellule);

              procedure compile_facteur(var pv_pt_cellule_facteur: t_pt_cellule);
                var l_pt_cellule_facteur: t_pt_cellule;
                begin
                  case l_type_symbole of
                    e_symbole_champ : begin
                                        genere_champ(pv_pt_cellule_facteur);
                                        lis_symbole;
                                      end;
                    e_symbole_chaine : begin
                                         genere_constante(pv_pt_cellule_facteur);
                                         lis_symbole;
                                       end;
                    e_symbole_entier : begin
                                         genere_constante(pv_pt_cellule_facteur);
                                         lis_symbole;
                                       end;
                    e_symbole_flottant : begin
                                           genere_constante(pv_pt_cellule_facteur);
                                           lis_symbole;
                                         end;

                    e_symbole_NOT: begin
                                     lis_symbole;
                                     compile_facteur(l_pt_cellule_facteur);

                                     genere_unaire(e_symbole_NOT, l_pt_cellule_facteur, pv_pt_cellule_facteur);
                                   end;
                    e_symbole_parenthese_ouvrante :
                        begin
                          (* -- saute ( *)
                          lis_symbole;

                          analyse_expression(pv_pt_cellule_facteur);
                          if l_type_symbole= e_symbole_parenthese_fermante
                            then lis_symbole
                            else affiche_erreur('attend )');
                        end;
                    else affiche_erreur('facteur inconnu '+ l_nom_symbole);
                  end; (* case *)
                end; (* compile_facteur *)

              var l_pt_cellule_facteur_1, l_pt_cellule_facteur_2: t_pt_cellule;
                  l_symbole_terme: t_type_symbole;

              begin (* compile_terme *)
                compile_facteur(l_pt_cellule_facteur_1);
                pv_pt_cellule_terme:= l_pt_cellule_facteur_1;

                while l_type_symbole in [e_symbole_fois, e_symbole_AND] do
                begin
                  l_symbole_terme:= l_type_symbole;

                  lis_symbole;
                  compile_facteur(l_pt_cellule_facteur_2);

                  genere_binaire(l_symbole_terme, l_pt_cellule_facteur_1, l_pt_cellule_facteur_2,
                    pv_pt_cellule_terme);
                  l_pt_cellule_facteur_1:= pv_pt_cellule_terme;
                end;
              end; (* compile_terme *)

            var l_pt_cellule_terme_1, l_pt_cellule_terme_2: t_pt_cellule;
                l_symbole_expression: t_type_symbole;

            begin (* analyse_expression_simple *)
              (* -- - unaire *)
              if l_type_symbole in [e_symbole_moins]
                then begin
                    lis_symbole;

                    compile_terme(l_pt_cellule_terme_1);

                    genere_unaire(e_symbole_moins, l_pt_cellule_terme_1, pv_pt_cellule_expression_simple);
                    l_pt_cellule_terme_1:= pv_pt_cellule_expression_simple;
                  end
                else begin
                    compile_terme(l_pt_cellule_terme_1);
                    pv_pt_cellule_expression_simple:= l_pt_cellule_terme_1;
                  end;

              while l_type_symbole in [e_symbole_plus, e_symbole_OR] do
              begin
                l_symbole_expression:= l_type_symbole;

                lis_symbole;
                compile_terme(l_pt_cellule_terme_2);

                genere_binaire(l_symbole_expression, l_pt_cellule_terme_1, l_pt_cellule_terme_2,
                    pv_pt_cellule_expression_simple);
                l_pt_cellule_terme_1:= pv_pt_cellule_expression_simple;
              end; (* while *)
            end; (* analyse_expression_simple *)

          var l_pt_cellule_expression_1, l_pt_cellule_expression_2: t_pt_cellule;
              l_symbole_comparaison: t_type_symbole;

          begin (* analyse_expression *)
            analyse_expression_simple(l_pt_cellule_expression_1);
            pv_pt_cellule_expression:= l_pt_cellule_expression_1;

            if l_type_symbole in [e_symbole_egal]
              then begin
                  l_symbole_comparaison:= l_type_symbole;

                  lis_symbole;
                  analyse_expression_simple(l_pt_cellule_expression_2);

                  genere_comparaison(l_symbole_comparaison, l_pt_cellule_expression_1, l_pt_cellule_expression_2,
                      pv_pt_cellule_expression);
                end;
          end; (* analyse_expression *)

        begin (* calcule_expression *)
          Fillchar(g_symboles_speciaux, Sizeof(g_symboles_speciaux), e_symbole_vide);
          g_symboles_speciaux['=']:= e_symbole_egal;
          g_symboles_speciaux['+']:= e_symbole_plus;
          g_symboles_speciaux['-']:= e_symbole_moins;
          g_symboles_speciaux['*']:= e_symbole_fois;
          g_symboles_speciaux['(']:= e_symbole_parenthese_ouvrante;
          g_symboles_speciaux[')']:= e_symbole_parenthese_fermante;
    {
          repeat
            lis_symbole;
            if l_type_symbole<> e_symbole_vide
              then begin
                  writeln(f_nom_symbole(l_type_symbole), ' ', l_nom_symbole);
                end;
          until l_type_symbole= e_symbole_vide;
    }

          l_offset_litteraux:= 0;

          l_indice:= 1; l_taille_ligne:= Length(p_condition);
          lis_symbole;
          analyse_expression(l_pt_cellule_resultat);
  {

          writeln;
          writeln(p_condition);
          liste(l_pt_cellule_resultat);
  }
        end; (* calcule_expression *)

      procedure genere_tampon;
        var l_offset, l_nombre_noeuds: Word;
            l_pt_tampon: t_pt_tampon;

        (*$r-*)

        procedure calcule_offsets(p: t_pt_cellule);
          begin
            if p<> nil
              then
                with p^ do
                begin
  {
                  write(pt_nom_symbole^);
  }
                  l_offset:= l_offset+ taille;
  {
                  write(' ', l_offset, ', ');
  }
                  inc(l_nombre_noeuds);

                  offset_1:= l_offset- SizeOf(CANExpr);
                  calcule_offsets(pt_gauche);
                  offset_2:= l_offset- SizeOf(CANExpr);
                  calcule_offsets(pt_droite);
                end;
          end; (* calcule_offsets *)

        procedure genere_litteral_z(p_nom: String);
          begin
            p_nom:= p_nom+ chr(0);
            Move(p_nom[1], l_pt_tampon^[l_offset_litteraux], Length(p_nom));
            inc(l_offset_litteraux, Length(p_nom))
          end; (* genere_litteral_z *)

        procedure genere_litteral_entier(p_nom: String);
          var l_nombre, l_indice_erreur: Integer;
          begin
            Val(p_nom, l_nombre, l_indice_erreur);
            Move(l_nombre, l_pt_tampon^[l_offset_litteraux], 2);
            inc(l_offset_litteraux, 2);
          end; (* genere_litteral_entier *)

        procedure genere_litteral_flottant(p_nom: String);
          var l_nombre: Double;
              l_indice_erreur: Integer;
          begin
            Val(p_nom, l_nombre, l_indice_erreur);
            Move(l_nombre, l_pt_tampon^[l_offset_litteraux], 8);
            inc(l_offset_litteraux, 8);
          end; (* genere_litteral_flottant *)

        procedure genere_(p: t_pt_cellule);
          begin
            if p<> nil
              then
                with p^ do
                begin
  {
                  writeln(l_offset: 3, ' ', pt_nom_symbole^, '': 15- Length(pt_nom_symbole^), offset_1: 4, offset_2: 4);
  }
                  if pt_noeud= nil
                    then halte('noeud nil');

                  (* -- complte les oprandes et gnre les constantes *)
                  case type_symbole of
                    e_symbole_egal : begin
                                       pCANCompare(pt_noeud)^.iOperand1:= offset_1;
                                       pCANCompare(pt_noeud)^.iOperand2:= offset_2;
                                     end;
                    e_symbole_AND, e_symbole_OR :
                      begin
                        pCANBinary(pt_noeud)^.iOperand1:= offset_1;
                        pCANBinary(pt_noeud)^.iOperand2:= offset_2;
                      end;
                    e_symbole_NOT : pCANBinary(pt_noeud)^.iOperand1:= offset_1;

                    e_symbole_champ : genere_litteral_z(pt_nom_symbole^);
                    e_symbole_chaine : genere_litteral_z(pt_nom_symbole^);
                    e_symbole_entier : genere_litteral_entier(pt_nom_symbole^);
                    e_symbole_flottant : genere_litteral_flottant(pt_nom_symbole^);
                    else halte('pas bon type = AND NOT champ, chaine, N R ');
                  end;

                  (* -- gnre les noeuds *)
                  move(pt_noeud^, l_pt_tampon^[l_offset], taille);
                  l_offset:= l_offset+ taille;

                  genere_(pt_gauche);
                  genere_(pt_droite);
                end;
          end; (* calcule_offsets *)

        begin (* genere_tampon *)
          l_offset:= SizeOf(CANExpr); l_nombre_noeuds:= 0;
          calcule_offsets(l_pt_cellule_resultat);

  {
          writeln(p_condition);
          liste(l_pt_cellule_resultat);
  }

          GetMem(l_pt_tampon, l_offset+ l_offset_litteraux);
          FillChar(l_pt_tampon^, l_offset+ l_offset_litteraux, 0);

          with pCANExpr(@l_pt_tampon^[0])^ do
          begin
            iver:= 1;
            iTotalSize:= l_offset+ l_offset_litteraux;
            inodes:= l_nombre_noeuds;
            (* -- obligatoire !!! *)
            iNodeStart:= SizeOf(CANExpr);
            iLiteralStart:= l_offset;
          end;
          pv_taille:= l_offset+ l_offset_litteraux;

  {
          writeln(p_condition);
  }
          l_offset_litteraux:= l_offset; l_offset:= SizeOf(CANExpr);
          genere_(l_pt_cellule_resultat);
          (*$r+*)

          move(l_pt_tampon, pv_pt_tampon, 4);
        end; (* genere_tampon *)

      procedure libere(p: t_pt_cellule);
        begin
          if p<> nil
            then begin
                libere(p^.pt_gauche);
                libere(p^.pt_droite);

                with p^ do
                begin
                  if pt_nom_symbole<> nil
                    then FreeMem(pt_nom_symbole, 1+ Length(pt_nom_symbole^));
                  if pt_noeud<> nil
                    then FreeMem(pt_noeud, taille);
                end;
                Dispose(p);
              end;
        end; (* libere *)

      begin (* analyse *)
        calcule_expression;
        genere_tampon;
        libere(l_pt_cellule_resultat);
      end; (* analyse *)

    function f_verifie(p_valeur: Integer): Boolean;
      var l_chaine_z: String;
      begin
        if p_valeur<> 0
          then begin
              DbiGetErrorString(p_valeur, @l_chaine_z);
              ShowMessage('Erreur '+ StrPas(@l_chaine_z));
            end;
        f_verifie:= p_valeur= 0;
      end; (* f_verifie *)

    procedure ajoute_filtre(p_table: tTable; p_condition: String;
        var pv_poignee_filtre: hDbiFilter);
      var l_pt_tampon: Pointer;
          l_taille: Word;
      begin
        if Not p_table.Active
          then p_table.Open;
        analyse(p_table, p_condition, l_pt_tampon, l_taille);
        p_table.First;
        f_verifie(DbiAddFilter(p_table.Handle, 0, 1, False, l_pt_tampon, nil, pv_poignee_filtre));
        FreeMem(l_pt_tampon, l_taille);
      end; (* ajoute_filtre *)

end.

