(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajordw *)

unit U_ajordw;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button6: TButton;
    Table_ReadOnly_: TButton;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    Table1PRIX: TFloatField;
    Fields_ReadOnly: TButton;
    DataSource_AutoEdit: TButton;
    DBEdit1: TDBEdit;
    dbEdit_ReadOnly: TButton;
    Table2: TTable;
    Table2_Edit_: TButton;
    Table1CODE: TFloatField;
    procedure Button1Click(Sender: TObject);
    procedure DataSource1StateChange(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Table_ReadOnly_Click(Sender: TObject);
    procedure Fields_ReadOnlyClick(Sender: TObject);
    procedure DataSource_AutoEditClick(Sender: TObject);
    procedure dbEdit_ReadOnlyClick(Sender: TObject);
    procedure Table2_Edit_Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)

  var l_erreur: String;

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
  TRY
    Table1.Edit;
  EXCEPT
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
        if ErrorCode= DbiErr_AlreadyLocked
          then ShowMessage('un autre utilisateur');
  END; (* TRY *)
end;

procedure TForm1.DataSource1StateChange(Sender: TObject);
begin
  if DataSource1.State in [dsEdit, dsInsert]
    then Form1.Color:= clRed
    else Form1.Color:= clWhite;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Table1.Active:= Not Table1.Active;
end;

procedure TForm1.Table_ReadOnly_Click(Sender: TObject);
begin
  TRY
    Table1.ReadOnly:= True;
  EXCEPT
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
end;

procedure TForm1.Fields_ReadOnlyClick(Sender: TObject);
begin
  Table1.Fields[1].ReadOnly:= True;
end;

procedure TForm1.DataSource_AutoEditClick(Sender: TObject);
begin
  DataSource1.AutoEdit:= not DataSource1.AutoEdit;
end;

procedure TForm1.dbEdit_ReadOnlyClick(Sender: TObject);
begin
  dbEdit1.ReadOnly:= Not dbEdit1.ReadOnly; 
end;

procedure TForm1.Table2_Edit_Click(Sender: TObject);
begin
  Table2.Edit;
end;

end.


