(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajoeff *)

unit U_ajoeff;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    Table1PRIX: TFloatField;
    Delete_: TButton;
    DataSource1: TDataSource;
    Table1CODE: TFloatField;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    EmptyTable_: TButton;
    procedure Delete_Click(Sender: TObject);
    procedure Table1BeforeDelete(DataSet: TDataset);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure EmptyTable_Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

  (*$i ..\..\u\f_errdbi *)

  var l_erreur: String;

procedure TForm1.Delete_Click(Sender: TObject);
begin
  TRY
    Table1.Delete;
  EXCEPT
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
end;

procedure TForm1.Table1BeforeDelete(DataSet: TDataset);
begin
  If MessageDlg('Effacer, Abandonner', mtConfirmation,
      [MbYes, mbCancel], 0)<> mrYes
    then SysUtils.Abort;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  If Button2.Caption= 'Affiche'
    then begin
        If DbiSetProp(hDbiObj(Table1.Handle), CurSoftDeleteOn, LongInt(False) )= DbiErr_None
          Then Table1.Refresh
          else ShowMessage('erreur');
        Button2.Caption:= 'Affiche pas';
      end
    else begin
        If DbiSetProp(hDbiObj(Table1.Handle), CurSoftDeleteOn, LongInt(True) )= DbiErr_None
          Then Table1.Refresh
          else ShowMessage('erreur');
        Button2.Caption:= 'Affiche';
      end;
  Table1.Refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
var l_proprietes: RecProps;
begin
  DbiGetRecord(Table1.Handle, DbiNoLock, Nil, @l_proprietes);
  if l_proprietes.bDeleteFlag
    then Button3.Caption:= 'Effac'
    else Button3.Caption:= 'Non effac';
end;

procedure TForm1.Button4Click(Sender: TObject);
var l_resultat: Integer;
begin
  Table1.UpdateCursorPos;
    l_resultat:= DbiUndeleteRecord(Table1.Handle);
    TRY
      if l_resultat=  DbiErr_na
        then ShowMessage('pas effac');
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
      else
        ShowMessage('pb ');
    END; (* TRY *)
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Table1.Close;
  Table1.Exclusive:= True;
  Table1.Open;

  DbiPackTable(Table1.DbHandle, Table1.Handle, 'AJOUTE.DBF', 'dBase', True);
end;

procedure TForm1.EmptyTable_Click(Sender: TObject);
begin
  Table1.Close;
  Table1.Exclusive:= True;
  Table1.Open;

  Table1.EmptyTable;
end;

end.


