(* analyse les ON de Field *)

unit U_eveajo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls,
  DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Open_: TButton;
    Edit_: TButton;
    Fields: TButton;
    Post_: TButton;
    Close_: TButton;
    Table1LIBELLE: TStringField;

    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource1StateChange(Sender: TObject);
    procedure DataSource1UpdateData(Sender: TObject);
    procedure Open_Click(Sender: TObject);
    procedure Table1AfterCancel(DataSet: TDataset);
    procedure Table1AfterClose(DataSet: TDataset);
    procedure Table1AfterDelete(DataSet: TDataset);
    procedure Table1AfterEdit(DataSet: TDataset);
    procedure Table1AfterInsert(DataSet: TDataset);
    procedure Table1AfterOpen(DataSet: TDataset);
    procedure Table1AfterPost(DataSet: TDataset);
    procedure Table1BeforeCancel(DataSet: TDataset);
    procedure Table1BeforeClose(DataSet: TDataset);
    procedure Table1BeforeDelete(DataSet: TDataset);
    procedure Table1BeforeEdit(DataSet: TDataset);
    procedure Table1BeforeInsert(DataSet: TDataset);
    procedure Table1BeforeOpen(DataSet: TDataset);
    procedure Table1BeforePost(DataSet: TDataset);
    procedure Table1CalcFields(DataSet: TDataset);
    procedure Table1NewRecord(DataSet: TDataset);
    procedure Edit_Click(Sender: TObject);
    procedure FieldsClick(Sender: TObject);
    procedure Post_Click(Sender: TObject);
    procedure Close_Click(Sender: TObject);
    procedure Table1LIBELLEChange(Sender: TField);
    procedure Table1LIBELLEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table1LIBELLESetText(Sender: TField; const Text: String);
    procedure Table1LIBELLEValidate(Sender: TField);
  private
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses u_aff_ev;

{$R *.DFM}

(* -- vnements *)

procedure TForm1.Table1BeforeOpen(DataSet: TDataset);
begin
  affiche('Table1.BeforeOpen', '');
end;

procedure TForm1.Table1AfterOpen(DataSet: TDataset);
begin
  affiche('Table1.AfterOpen', '');
end;

procedure TForm1.Table1BeforeInsert(DataSet: TDataset);
begin
  affiche('Table1.BeforeInsert', '');
end;

procedure TForm1.Table1AfterInsert(DataSet: TDataset);
begin
  affiche('Table1.AfterInsert', '');
end;

procedure TForm1.Table1BeforeEdit(DataSet: TDataset);
begin
  affiche('Table1.BeforeEdit', '');
end;

procedure TForm1.Table1AfterEdit(DataSet: TDataset);
begin
  affiche('Table1.AfterEdit', '');
end;

procedure TForm1.Table1BeforeDelete(DataSet: TDataset);
begin
  affiche('Table1.BeforeDelete', '');
end;

procedure TForm1.Table1AfterDelete(DataSet: TDataset);
begin
  affiche('Table1.AfterDelete', '');
end;

procedure TForm1.Table1BeforeCancel(DataSet: TDataset);
begin
  affiche('Table1.BeforeCancel', '');
end;

procedure TForm1.Table1AfterCancel(DataSet: TDataset);
begin
  affiche('Table1.AfterCancel', '');
end;

procedure TForm1.Table1BeforePost(DataSet: TDataset);
begin
  affiche('Table1.BeforePost', '');
end;

procedure TForm1.Table1AfterPost(DataSet: TDataset);
begin
  affiche('Table1.AfterPost', '');
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
  affiche('Table1.CalcFields', '');
end;

procedure TForm1.Table1NewRecord(DataSet: TDataset);
begin
  affiche('Table1.NewRecord', '');
end;

procedure TForm1.Table1BeforeClose(DataSet: TDataset);
begin
  affiche('Table1.BeforeClose', '');
{
  Table1.Cancel;
  SysUtils.Abort;
}
end;

procedure TForm1.Table1AfterClose(DataSet: TDataset);
begin
  affiche('Table1.AfterClose', '');
end;

(* -- Field Persistent: Table1LIBELLE *)

  function f_valeur_champ(p_champ: tField): String;
    begin
      if p_champ= nil
        then Result:= 'nil'
        else Result:= p_champ.AsString;
    end; (* f_LIBELLE *)

procedure TForm1.Table1LIBELLEChange(Sender: TField);
begin
  affiche('Table1Field.Change', f_valeur_champ(Sender));
end;

procedure TForm1.Table1LIBELLEGetText(Sender: TField; var Text: OpenString;
  DisplayText: Boolean);
const vi_booleen: array[False..True] of Char= ('F', 'T');
var l_texte: String;
begin
  l_texte:= Sender.AsString;
  l_texte:= '_'+ l_texte;

  affiche('Table1Field.GetText '+ vi_booleen[Displaytext], l_texte+ ' '+ f_valeur_champ(Sender));
  Text:= l_texte;
end;

procedure TForm1.Table1LIBELLESetText(Sender: TField; const Text: String);
var l_texte: String;
begin
  affiche('Table1Field.SetText', Text+ ' '+ f_valeur_champ(Sender));

  l_texte:= Text;
  Delete(l_texte, 1, 1);
  Sender.AsString:= l_texte;
end;

procedure TForm1.Table1LIBELLEValidate(Sender: TField);
begin
  affiche('Table1Field.Validate', f_valeur_champ(Sender));
end;

(* DataSource *)

  function f_nom_objet(p_objet: tObject): String;
    begin
      if p_objet IS tComponent
        then Result:= tComponent(p_objet).Name
        else Result:= '??';
    end;

procedure TForm1.DataSource1UpdateData(Sender: TObject);
begin
  affiche('DataSource.UpdateData', f_nom_objet(Sender) );
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  affiche('DataSource.DataChange', f_nom_objet(Sender)+ ' '+ f_valeur_champ(Field));
end;

procedure TForm1.DataSource1StateChange(Sender: TObject);
begin
  affiche('DataSource.StateChange', f_nom_objet(Sender) );
end;

(* db_xxx *)

(* -- actions *)

procedure TForm1.Open_Click(Sender: TObject);
begin
  vi_action:= 'Open';
  Table1.Active:= Not Table1.Active;
end;

procedure TForm1.Edit_Click(Sender: TObject);
begin
  vi_action:= 'Edit';
  Table1.Edit;
end;

procedure TForm1.FieldsClick(Sender: TObject);
begin
  vi_action:= 'Fields.As_:=';
  Try
{
    Table1.Fields[1].AsString:= 'abcdefghijklm';
}
    Table1LIBELLE.AsString:= 'Souris';
  except
    showmessage('Fields:= ');
  end;
end;

procedure TForm1.Post_Click(Sender: TObject);
begin
  vi_action:= 'Post';
  Table1.Post;
end;

procedure TForm1.Close_Click(Sender: TObject);
begin
  vi_action:= 'Close';
  Table1.Close;
end;

end.




