(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ajoval *)
(* 21 nov 95 *)

unit U_ajoval;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    MaskEdit1: TMaskEdit;
    DBEdit1: TDBEdit;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    Table1PRIX: TFloatField;
    Table1CODE: TFloatField;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit2: TDBEdit;
    Table2: TTable;
    procedure Table1BeforePost(DataSet: TDataset);
    procedure FormCreate(Sender: TObject);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure Table1PRIXValidate(Sender: TField);
    procedure Table1PRIXSetText(Sender: TField; const Text: String);
    procedure Table1NewRecord(DataSet: TDataset);
    procedure MaskEdit1Exit(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBEdit6KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit6KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Table1QUANTITESetText(Sender: TField; const Text: String);
    procedure DataSource1StateChange(Sender: TObject);
    procedure Table1LIBELLEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table1LIBELLESetText(Sender: TField; const Text: String);
    procedure Table1CODESetText(Sender: TField; const Text: String);
    procedure Table1QUANTITEChange(Sender: TField);
  private
    { Private-dclarations }
    procedure traite_exceptions(Sender: TObject; E: Exception);
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

  type t_exception= Class(Exception);

  procedure TForm1.traite_exceptions(Sender: TObject; E: Exception);
  begin
{
    if E is EDBEngineError then begin
       err := (E as EDBEngineError).errors[(E as
  EDBEngineError).errorcount - 1].errorcode;
       if (err = DBIERR_KEYVIOL) then
          showMessage('A Key violation occurred!')
       else if (err = DBIERR_LOCKED) then
          showmessage('Record locked by another user')
       else if (err = DBIERR_FILELOCKED) then
          showmessage('Table locked by someone else')
       else
          showmessage('Other DB Error')
       end
    else
       showmessage('Whoops!: '+E.Message);
}
    if E is EDBEngineError
      then begin
          showmessage('Exc DBI '+ e.Message)
        end
      else
        if e is EDatabaseError
          then begin
              showmessage('Exc database '+ e.Message)
            end
          else
            if e is t_exception
              then showmessage('mon exc ')
              else showmessage('Exc autre '+ e.Message);
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{
  Application.OnException:= traite_exceptions;
}
end;

(* -- validation caractre  caractre *)

procedure TForm1.DBEdit1KeyPress(Sender: TObject; var Key: Char);
var l_nom: String;
begin
  If Not (Key in ['a'..'Z', 'a'..'z', ' ', chr(8)])
    then begin
        MessageBeep(0);
        ShowMessage('Ps: '+ Key+ ', que lettres, espace ou <- ');
        Key:= chr(0);
      end;
{
  l_nom:= (Sender As tdbEdit).DataField;

  if Not Table1.FieldByName(l_nom).IsValidChar(Key)
    then MessageBeep(0);
}
end;

(* -- MaskEdit *)

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_texte: String;
begin
{
  MaskEdit1.Text:= FloatToStr(Table1PRIX.AsFloat* 100);
}
  (* -- multiplie par 100 pour supprimer la virgule *)
  l_texte:= FormatFloat('000000', Table1PRIX.AsFloat* 100);
{
  Button2.Caption:= '>'+ l_texte+ '<';
  l_texte:= '000123';
}
  MaskEdit1.Text:= l_texte;
end;

procedure TForm1.MaskEdit1Exit(Sender: TObject);
begin
{
  Table1PRIX.AsString:= MaskEdit1.Text;
  MaskEdit1.Visible:= False;
  dbEdit3.Visible:= True;
}
  Table1.Edit;
  Table1PRIX.AsFloat:= StrToFLoat(MaskEdit1.Text) / 100;
end;

(* -- suivi d'un dbEdit *)

procedure TForm1.DBEdit6KeyPress(Sender: TObject; var Key: Char);
var l_texte: String;
    l_indice: Integer;
begin
  with dbEdit6 do
  begin
    case Key of
      '0'..'9' :
         if Text[SelStart+ 1] in ['0'..'9']
           then begin
               l_indice:= SelStart;

               l_texte:= Text;
               l_texte[SelStart+ 1]:= Key;
               (* -- va repositionner SelStart  0 ! *)
               Text:= l_texte;

               if l_texte[l_indice+ 2] in ['.', ',', ' ']
                 then SelStart:= l_indice+ 2
                 else SelStart:= l_indice+ 1;
           end;
      #8 : begin
             if Text[SelStart] in ['.', ',', ' ']
               then SelStart:= SelStart- 2
               else SelStart:= SelStart- 1;
           end;
      else
    end; (* case *)
  end; (* with *)

  (* -- a modifi .Text: pas besoin de laisser passer le caractre *)
  Key:= Chr(0);
end;

procedure TForm1.DBEdit6KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with dbEdit6 do
    case Key of
      vk_Right : if Text[SelStart+ 2] in ['.', ',', ' ']
                   then SelStart:= SelStart+ 1;
      vk_Left : if Text[SelStart] in ['.', ',', ' ']
                  then SelStart:= SelStart- 1;
    end; (* case *)
end;

procedure TForm1.Table1QUANTITESetText(Sender: TField; const Text: String);
var l_texte: String;
    l_indice: Integer;
begin
  (* -- vire les espaces de formatage *)
  l_texte:= '';
  for l_indice:= 1 TO length(Text) do
    if Text[l_indice]<> ' '
      then l_texte:= l_texte+ Text[l_indice];

  (* -- doit forcer Edit, car chr(0) a empch tous les caractres d'arriver *)
  Table1.Edit;
  Table1QUANTITE.AsString:= l_texte;
end;

(* -- formatage spcialis *)

procedure TForm1.Table1LIBELLEGetText(Sender: TField; var Text: OpenString;
  DisplayText: Boolean);
var l_texte: String;
begin
  l_texte:= Sender.AsString;
  If DisplayText
    then Text:= UpperCase(l_texte)
    else Text:= LowerCase(l_texte);
end;

procedure TForm1.Table1LIBELLESetText(Sender: TField; const Text: String);
var l_texte: String;
begin
  l_texte:= LowerCase(Sender.AsString);
  l_texte[1]:= UpCase(l_texte[1]);
  Sender.AsString:= l_texte;
end;

(* -- Validate *)

procedure TForm1.Table1PRIXValidate(Sender: TField);
begin
  if Frac(Sender.AsFloat)<> 0
    Then Abort;
end;

(* -- Min et Max  *)

procedure TForm1.Table1PRIXSetText(Sender: TField; const Text: String);
begin
  if Sender.IsNull
    then ShowMessage('NULL '+ Text);

  IF StrToFloat(Text)> 40
    then begin
        ShowMessage('Trop grand '+ Text);
        Abort;
      end
    else Sender.AsString:= Text;
end;

(* -- unicit *)

procedure TForm1.Table1CODESetText(Sender: TField; const Text: String);
begin
  With Table2 do
  begin
    DatabaseName:= 'Flix';
    TableName:= 'AJOUTE.DBF';
    IndexName:= 'IND_CODE';
    Open;
    IF FindKey([Text])
      then begin
          ShowMessage('Dj '+ Text);
          Abort;
        end
      else Table1CODE.AsString:= Text;
    Close;
  end;
end;

(* -- vrification avant Post *)

procedure TForm1.Table1BeforePost(DataSet: TDataset);
begin
  If MessageDlg('Poster ? ', mtConfirmation, [mbOk, mbNo], 0)<> mrYes
    then begin
        MessageBeep(0);
        Table1.Cancel;
        Raise t_exception.Create('');
{
        Raise t_exception.Create('a avort');
        Abort;
}
      end;
end;

procedure TForm1.Table1NewRecord(DataSet: TDataset);
begin
  Table1QUANTITE.AsInteger:= 1;
{
  Table1PRIX.AsString:= '1,234';
}
end;

procedure TForm1.DataSource1StateChange(Sender: TObject);
begin
  exit;

  if Table1.State  in [dsEdit, dsInsert]
    then Form1.Color:= clRed
    else Form1.Color:= clWhite;
end;

procedure TForm1.Table1QUANTITEChange(Sender: TField);
begin
  If (Table1QUANTITE.AsInteger< 2) AND (Table1PRIX.AsFloat< 20.0)
{
    then Table1PRIX.AsFloat:= Table1PRIX.AsFloat+ 1;
}
    then Table1PRIX.AsFloat:= 20.0;
end;

end.
