  function f_erreur_dbi(p_code: Integer): String;
    var l_texte: String;
    begin
      case p_code of
        $2100 : l_texte:= 'SYSTEM (System related (Fatal Error) ) NONE ()';
        $2101 : l_texte:= 'SYSTEM (System related (Fatal Error) ) SYSFILEOPEN ( Cannot open a system file )';
        $2102 : l_texte:= 'SYSTEM (System related (Fatal Error) ) SYSFILEIO ( I/O error on a system file )';
        $2103 : l_texte:= 'SYSTEM (System related (Fatal Error) ) SYSCORRUPT ( Data structure corruption )';
        $2104 : l_texte:= 'SYSTEM (System related (Fatal Error) ) NOCONFIGFILE ( Cannot find config file )';
        $2105 : l_texte:= 'SYSTEM (System related (Fatal Error) ) CFGCANNOTWRITE ( Cannot write config file (READONLY) )';
        $2106 : l_texte:= 'SYSTEM (System related (Fatal Error) ) CFGMULTIFILE ( Initializing with different ini file )';
        $2107 : l_texte:= 'SYSTEM (System related (Fatal Error) ) REENTERED ( System has been illegally re-entered )';
        $2108 : l_texte:= 'SYSTEM (System related (Fatal Error) ) CANTFINDODAPI ( Cannot locate IDAPIxx.DLL )';
        $2109 : l_texte:= 'SYSTEM (System related (Fatal Error) ) CANTLOADODAPI ( Cannot load IDAPIxx.DLL )';
        $210A : l_texte:= 'SYSTEM (System related (Fatal Error) ) CANTLOADLIBRARY ( Cannot load a service DLL )';
        $2201 : l_texte:= 'NOTFOUND (Object of interest Not Found ) BOF ( Beginning of Virtual table )';
        $2202 : l_texte:= 'NOTFOUND (Object of interest Not Found ) EOF ( End of Virtual table )';
        $2203 : l_texte:= 'NOTFOUND (Object of interest Not Found ) RECMOVED ( Fly-away )';
        $2204 : l_texte:= 'NOTFOUND (Object of interest Not Found ) KEYORRECDELETED ( Record Deleted/Key Modified )';
        $2205 : l_texte:= 'NOTFOUND (Object of interest Not Found ) NOCURRREC ( No current record )';
        $2206 : l_texte:= 'NOTFOUND (Object of interest Not Found ) RECNOTFOUND ( Record was not found )';
        $2207 : l_texte:= 'NOTFOUND (Object of interest Not Found ) ENDOFBLOB ( End of Blob reached )';
        $2208 : l_texte:= 'NOTFOUND (Object of interest Not Found ) OBJNOTFOUND ( Generic Not found )';
        $2209 : l_texte:= 'NOTFOUND (Object of interest Not Found ) FMLMEMBERNOTFOUND ( Family member not found )';
        $220A : l_texte:= 'NOTFOUND (Object of interest Not Found ) BLOBFILEMISSING ( 0x0a Blob file for table is missing )';
        $220B : l_texte:= 'NOTFOUND (Object of interest Not Found ) LDNOTFOUND ( 0x0b Language driver not found )';
        $2301 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) HEADERCORRUPT ( Corrupt Header )';
        $2302 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) FILECORRUPT ( File corrupt - other than header )';
        $2303 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) MEMOCORRUPT ( Memo file corrupted )';
        $2304 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) BMPCORRUPT ( BitMap is corrupt (Internal error) )';
        $2305 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) INDEXCORRUPT ( Index is corrupt )';
        $2306 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) CORRUPTLOCKFILE ( Corrupt lock file )';
        $2307 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) FAMFILEINVALID ( Corrupt family file )';
        $2308 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) VALFILECORRUPT ( Val file is missing or corrupt )';
        $2309 : l_texte:= 'DATACORRUPT (Physical Data Corruption ) FOREIGNINDEX ('
                              + ' Index is in a foreign format - import first )';
        $2401 : l_texte:= 'IO (I/O related error ) READERR ( Read failure (not expected) )';
        $2402 : l_texte:= 'IO (I/O related error ) WRITEERR ( Write failure (not expected) )';
        $2403 : l_texte:= 'IO (I/O related error ) DIRNOACCESS ( No access to dir )';
        $2404 : l_texte:= 'IO (I/O related error ) FILEDELETEFAIL ( File delete failed )';
        $2405 : l_texte:= 'IO (I/O related error ) FILENOACCESS ( No access to file )';
        $2406 : l_texte:= 'IO (I/O related error ) ACCESSDISABLED ( Access to table disabled (previous error) )';
        $2501 : l_texte:= 'LIMIT (Resource or Limit error ) NOMEMORY ( Not enough Memory for this op )';
        $2502 : l_texte:= 'LIMIT (Resource or Limit error ) NOFILEHANDLES ( Not enough File handles )';
        $2503 : l_texte:= 'LIMIT (Resource or Limit error ) NODISKSPACE ( Not enough Disk space )';
        $2504 : l_texte:= 'LIMIT (Resource or Limit error ) NOTEMPTBLSPACE ( Temporary Table resource limit )';
        $2505 : l_texte:= 'LIMIT (Resource or Limit error ) RECTOOBIG ( Too big a record size for table )';
        $2506 : l_texte:= 'LIMIT (Resource or Limit error ) CURSORLIMIT ( Too many open cursors )';
        $2507 : l_texte:= 'LIMIT (Resource or Limit error ) TABLEFULL ( Table is full )';
        $2508 : l_texte:= 'LIMIT (Resource or Limit error ) WSSESLIMIT ( Too many sessions from this WS )';
        $2509 : l_texte:= 'LIMIT (Resource or Limit error ) SERNUMLIMIT ( Serial number limit (paradox) )';
        $250A : l_texte:= 'LIMIT (Resource or Limit error ) INTERNALLIMIT ( 0x0a Some internal limit (see context) )';
        $250B : l_texte:= 'LIMIT (Resource or Limit error ) OPENTBLLIMIT ( 0x0b Too many open tables )';
        $250C : l_texte:= 'LIMIT (Resource or Limit error ) TBLCURSORLIMIT ( 0x0c Too many cursors per table )';
        $250D : l_texte:= 'LIMIT (Resource or Limit error ) RECLOCKLIMIT ( 0x0d Too many record locks on table )';
        $250E : l_texte:= 'LIMIT (Resource or Limit error ) CLIENTSLIMIT ( 0x0e Too many clients )';
        $250F : l_texte:= 'LIMIT (Resource or Limit error ) INDEXLIMIT ( 0x0f Too many indexes (also in Table Create) )';
        $2510 : l_texte:= 'LIMIT (Resource or Limit error ) SESSIONSLIMIT ( 0x10 Too many sessions )';
        $2511 : l_texte:= 'LIMIT (Resource or Limit error ) DBLIMIT ( 0x11 Too many databases )';
        $2512 : l_texte:= 'LIMIT (Resource or Limit error ) PASSWORDLIMIT ( 0x12 Too many passwords )';
        $2513 : l_texte:= 'LIMIT (Resource or Limit error ) DRIVERLIMIT ( 0x13 Too many active drivers )';
        $2514 : l_texte:= 'LIMIT (Resource or Limit error ) FLDLIMIT ( 0x14 Too many Fields in Table Create )';
        $2515 : l_texte:= 'LIMIT (Resource or Limit error ) TBLLOCKLIMIT ( 0x15 Too many table locks )';
        $2516 : l_texte:= 'LIMIT (Resource or Limit error ) OPENBLOBLIMIT ( 0x16 Too many open blobs )';
        $2517 : l_texte:= 'LIMIT (Resource or Limit error ) LOCKFILELIMIT ( 0x17 Lock file has grown too big )';
        $2518 : l_texte:= 'LIMIT (Resource or Limit error ) OPENQRYLIMIT ( 0x18 Too many open queries )';
        $2519 : l_texte:= 'LIMIT (Resource or Limit error ) THREADLIMIT ( 0x19 Too many threads for client )';
        $251A : l_texte:= 'LIMIT (Resource or Limit error ) BLOBLIMIT ( 0x1a Too many blobs )';
        $2601 : l_texte:= 'INTEGRITY (Integrity Violation ) KEYVIOL ( Key violation )';
        $2602 : l_texte:= 'INTEGRITY (Integrity Violation ) MINVALERR ( Min val check failed )';
        $2603 : l_texte:= 'INTEGRITY (Integrity Violation ) MAXVALERR ( Max val check failed )';
        $2604 : l_texte:= 'INTEGRITY (Integrity Violation ) REQDERR ( Field value required )';
        $2605 : l_texte:= 'INTEGRITY (Integrity Violation ) FORIEGNKEYERR ( Master record missing )';
        $2606 : l_texte:= 'INTEGRITY (Integrity Violation ) DETAILRECORDSEXIST ( Cannot MODIFY or DELETE this Master record )';
        $2607 : l_texte:= 'INTEGRITY (Integrity Violation ) MASTERTBLLEVEL ( Master Table Level is incorrect )';
        $2608 : l_texte:= 'INTEGRITY (Integrity Violation ) LOOKUPTABLEERR ( Field value out of lookup tbl range )';
        $2609 : l_texte:= 'INTEGRITY (Integrity Violation ) LOOKUPTBLOPENERR ( Lookup Table Open failed )';
        $260A : l_texte:= 'INTEGRITY (Integrity Violation ) DETAILTBLOPENERR ( 0x0a Detail Table Open failed )';
        $260B : l_texte:= 'INTEGRITY (Integrity Violation ) MASTERTBLOPENERR ( 0x0b Master Table Open failed )';
        $260C : l_texte:= 'INTEGRITY (Integrity Violation ) FIELDISBLANK ( 0x0c Field is blank )';
        $260D : l_texte:= 'INTEGRITY (Integrity Violation ) MASTEREXISTS ( 0x0d Master Table exists )';
        $260E : l_texte:= 'INTEGRITY (Integrity Violation ) MASTERTBLOPEN ( 0x0e Master Table is open )';
        $260F : l_texte:= 'INTEGRITY (Integrity Violation ) DETAILTABLESEXIST ('
                              + ' 0x0f Detail Tables exist ( cannot delete, rename ... ) )';
        $2610 : l_texte:= 'INTEGRITY (Integrity Violation ) DETAILRECEXISTEMPTY ( 0x10 Cannot empty because details exist )';
        $2611 : l_texte:= 'INTEGRITY (Integrity Violation ) MASTERREFERENCEERR ('
                              + ' 0x11 Cannot modify while adding self referencing Referential Integrity )';
        $2612 : l_texte:= 'INTEGRITY (Integrity Violation ) DETAILTBLOPEN ( 0x12 Detail Table is opened )';
        $2613 : l_texte:= 'INTEGRITY (Integrity Violation ) DEPENDENTSMUSTBEEMPTY ('
                              + ' 0x13 Cannot make a master a detail of another table if its details are not empty !)';
        $2614 : l_texte:= 'INTEGRITY (Integrity Violation ) RINTREQINDEX ( 0x14 Ref. integrity fields must be indexed )';
        $2615 : l_texte:= 'INTEGRITY (Integrity Violation ) LINKEDTBLPROTECTED ('
                              + ' 0x15 Master Table is protected ( requires password to open) )';
        $2616 : l_texte:= 'INTEGRITY (Integrity Violation ) FIELDMULTILINKED ( 0x16 Field has more than one master )';
        $2701 : l_texte:= 'INVALIDREQ (Invalid Request ) OUTOFRANGE ( Number out of range (e.g field no) )';
        $2702 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDPARAM ( Generic invalid parameter )';
        $2703 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFILENAME ( Invalid file name )';
        $2704 : l_texte:= 'INVALIDREQ (Invalid Request ) NOSUCHFILE ( No such file )';
        $2705 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDOPTION ( Invalid option for a parameter )';
        $2706 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDHNDL ( Invalid handle to the function )';
        $2707 : l_texte:= 'INVALIDREQ (Invalid Request ) UNKNOWNTBLTYPE ( Table type given not known )';
        $2708 : l_texte:= 'INVALIDREQ (Invalid Request ) UNKNOWNFILE ( Dont know how to open file )';
        $2709 : l_texte:= 'INVALIDREQ (Invalid Request ) PRIMARYKEYREDEFINE ( Cannot redefine primary key )';
        $270A : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDRINTDESCNUM ( 0x0a Cannot change this RINTDesc )';
        $270B : l_texte:= 'INVALIDREQ (Invalid Request ) KEYFLDTYPEMISMATCH ( 0x0b Foreign & Primary Key Mismatch )';
        $270C : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDMODIFYREQUEST ( 0x0c Invalid modify request )';
        $270D : l_texte:= 'INVALIDREQ (Invalid Request ) NOSUCHINDEX ( 0x0d Index does not exist )';
        $270E : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDBLOBOFFSET ( 0x0e Invalid Offset into the Blob )';
        $270F : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDDESCNUM ( 0x0f Invalid descriptor number )';
        $2710 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFLDTYPE ( 0x10 Invalid field type )';
        $2711 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFLDDESC ( 0x11 Invalid field descriptor )';
        $2712 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFLDXFORM ( 0x12 Invalid field transform )';
        $2713 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDRECSTRUCT ( 0x13 Invalid record structure )';
        $2714 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDDESC ( 0x14 Generic: invalid descriptor )';
        $2715 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDINDEXSTRUCT ( 0x15 Invalid array of indexes descriptors )';
        $2716 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDVCHKSTRUCT ( 0x16 Invalid array of  val. check descriptors )';
        $2717 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDRINTSTRUCT ('
                              + ' 0x17 Invalid array of ref. integrity descriptors )';
        $2718 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDRESTRTBLORDER ('
                              + ' 0x18 Invalid ordering of tables during restructure )';
        $2719 : l_texte:= 'INVALIDREQ (Invalid Request ) NAMENOTUNIQUE ( 0x19 Name not unique in this context )';
        $271A : l_texte:= 'INVALIDREQ (Invalid Request ) INDEXNAMEREQUIRED ( 0x1a Index name required )';
        $271B : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDSESHANDLE ( 0x1b Invalid ses handle )';
        $271C : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDRESTROP ( 0x1c Invalid restructure operation )';
        $271D : l_texte:= 'INVALIDREQ (Invalid Request ) UNKNOWNDRIVER ( 0x1d Driver not known to system )';
        $271E : l_texte:= 'INVALIDREQ (Invalid Request ) UNKNOWNDB ( 0x1e Unknown db )';
        $271F : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDPASSWORD ( 0x1f Invalid password given )';
        $2720 : l_texte:= 'INVALIDREQ (Invalid Request ) NOCALLBACK ( 0x20 No callback function )';
        $2721 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDCALLBACKBUFLEN ( 0x21 Invalid callback buffer length )';
        $2722 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDDIR ( 0x22 Invalid directory )';
        $2723 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDXLATION ( 0x23 Translate Error - Translate DID NOT happen )';
        $2724 : l_texte:= 'INVALIDREQ (Invalid Request ) DIFFERENTTABLES ( 0x24 Cannot Set Cursor of one Table to another )';
        $2725 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDBOOKMARK ( 0x25 Bookmarks does not match table, etc. )';
        $2726 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDINDEXNAME ( 0x26 Index/Tag Name is invalid )';
        $2727 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDIDXDESC ( 0x27 Invalid index descriptor )';
        $2728 : l_texte:= 'INVALIDREQ (Invalid Request ) NOSUCHTABLE ( 0x28 No such table )';
        $2729 : l_texte:= 'INVALIDREQ (Invalid Request ) USECOUNT ( 0x29 Table has too many users )';
        $272A : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDKEY ( 0x2a Key does not pass filter condition )';
        $272B : l_texte:= 'INVALIDREQ (Invalid Request ) INDEXEXISTS ( 0x2b Index already exists )';
        $272C : l_texte:= 'INVALIDREQ (Invalid Request ) INDEXOPEN ( 0x2c Index is open )';
        $272D : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDBLOBLEN ( 0x2d Invalid Blob Length )';
        $272E : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDBLOBHANDLE ( 0x2e Invalid Blob handle (in record buffer) )';
        $272F : l_texte:= 'INVALIDREQ (Invalid Request ) TABLEOPEN ( 0x2f Table is open )';
        $2730 : l_texte:= 'INVALIDREQ (Invalid Request ) NEEDRESTRUCTURE ( 0x30 Need to do (hard) restructure )';
        $2731 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDMODE ( 0x31 Invalid mode )';
        $2732 : l_texte:= 'INVALIDREQ (Invalid Request ) CANNOTCLOSE ( 0x32 Cannot close index )';
        $2733 : l_texte:= 'INVALIDREQ (Invalid Request ) ACTIVEINDEX ( 0x33 Index is being used to order tbl )';
        $2734 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDUSRPASS ( 0x34 Bad user name or password )';
        $2735 : l_texte:= 'INVALIDREQ (Invalid Request ) MULTILEVELCASCADE ( 0x35 Multi level Cascade not supported )';
        $2736 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFIELDNAME ( 0x36 Invalid field name )';
        $2737 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDTABLENAME ( 0x37 Invalid table name )';
        $2738 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDLINKEXPR ( 0x38 Invalid linked cursor expression )';
        $2739 : l_texte:= 'INVALIDREQ (Invalid Request ) NAMERESERVED ( 0x39 Name is reserved )';
        $273A : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFILEEXTN ( 0x3a Invalid file extention )';
        $273B : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDLANGDRV ( 0x3b Invalid language driver )';
        $273C : l_texte:= 'INVALIDREQ (Invalid Request ) ALIASNOTOPEN ( 0x3c Requested alias in not open )';
        $273D : l_texte:= 'INVALIDREQ (Invalid Request ) INCOMPATRECSTRUCTS ( 0x3d Incompatible record structures )';
        $273E : l_texte:= 'INVALIDREQ (Invalid Request ) RESERVEDDOSNAME ( 0x3e Reserved dos name )';
        $273F : l_texte:= 'INVALIDREQ (Invalid Request ) DESTMUSTBEINDEXED ( 0x3f Destination must be indexed )';
        $2740 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDINDEXTYPE ( 0x40 Invalid index type )';
        $2741 : l_texte:= 'INVALIDREQ (Invalid Request ) LANGDRVMISMATCH ('
                              + ' 0x41 Language driver of table and index do not match )';
        $2742 : l_texte:= 'INVALIDREQ (Invalid Request ) NOSUCHFILTER ( 0x42 Filter handle is invalid )';
        $2743 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDFILTER ( 0x43 Invalid filter )';
        $2744 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDTABLECREATE ('
                              + ' 0x44 Bad table create request (exact prob unknown) )';
        $2745 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDTABLEDELETE ('
                              + ' 0x45 Bad table delete request (exact prob unknown) )';
        $2746 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDINDEXCREATE ('
                              + ' 0x46 Bad index create request (exact prob unknown) )';
        $2747 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDINDEXDELETE ('
                              + ' 0x47 Bad index delete request (exact prob unknown) )';
        $2748 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDTABLE ( 0x48 Invalid table name specified )';
        $2749 : l_texte:= 'INVALIDREQ (Invalid Request ) MULTIRESULTS ( 0X49 Multi results )';
        $274A : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDTIME ( 0X4A Multi results )';
        $274B : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDDATE ( 0X4B Multi results )';
        $274C : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDTIMESTAMP ( 0X4C Multi results )';
        $274D : l_texte:= 'INVALIDREQ (Invalid Request ) DIFFERENTPATH ( 0X4d Tables in different paths )';
        $274E : l_texte:= 'INVALIDREQ (Invalid Request ) MISMATCHARGS ( 0x4e MisMatch in the # of arguments )';
        $274F : l_texte:= 'INVALIDREQ (Invalid Request ) FUNCTIONNOTFOUND ('
                              + ' 0x4f Loaderlib cant find a func in the DLL (bad version?) )';
        $2750 : l_texte:= 'INVALIDREQ (Invalid Request ) MUSTUSEBASEORDER ( 0x50 Must use baseorder for this operation )';
        $2751 : l_texte:= 'INVALIDREQ (Invalid Request ) INVALIDPROCEDURENAME ( 0x51 Invalid procedure name )';
        $2801 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) LOCKED ()';
        $2802 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) UNLOCKFAILED ()';
        $2803 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) FILEBUSY ()';
        $2804 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) DIRBUSY ()';
        $2805 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) FILELOCKED ()';
        $2806 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) DIRLOCKED ()';
        $2807 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) ALREADYLOCKED ()';
        $2808 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) NOTLOCKED ()';
        $2809 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) LOCKTIMEOUT ()';
        $280A : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) GROUPLOCKED ( 0x0a )';
        $280B : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) LOSTTBLLOCK ( 0x0b )';
        $280C : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) LOSTEXCLACCESS ( 0x0c )';
        $280D : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) NEEDEXCLACCESS ( 0x0d )';
        $280E : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) RECGROUPCONFLICT ( 0x0e )';
        $280F : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) DEADLOCK ()';
        $2810 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) ACTIVETRAN ()';
        $2811 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) NOACTIVETRAN ()';
        $2812 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) RECLOCKFAILED ()';
        $2813 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) OPTRECLOCKFAILED ()';
        $2814 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) OPTRECLOCKRECDEL ()';
        $2815 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) LOCKEDRECS ()';
        $2816 : l_texte:= 'LOCKCONFLICT (Locking/Contention related ) NEEDWRITELOCK ()';
        $2901 : l_texte:= 'SECURITY (Access Violation - Security related ) NOTSUFFFIELDRIGHTS ('
                              + ' Not sufficient field  rights for operation )';
        $2902 : l_texte:= 'SECURITY (Access Violation - Security related ) NOTSUFFTABLERIGHTS ('
                              + ' Not sufficient table  rights for operation )';
        $2903 : l_texte:= 'SECURITY (Access Violation - Security related ) NOTSUFFFAMILYRIGHTS ('
                              + ' Not sufficient family rights for operation )';
        $2904 : l_texte:= 'SECURITY (Access Violation - Security related ) READONLYDIR ( Is a read-only directory )';
        $2905 : l_texte:= 'SECURITY (Access Violation - Security related ) READONLYDB ( Database is read-only )';
        $2906 : l_texte:= 'SECURITY (Access Violation - Security related ) READONLYFLD ( Trying to modify read-only field )';
        $2907 : l_texte:= 'SECURITY (Access Violation - Security related ) TBLENCRYPTED ( Table is encrypted (dBASE only) )';
        $2908 : l_texte:= 'SECURITY (Access Violation - Security related ) NOTSUFFSQLRIGHTS ('
                              + ' Not sufficient sql rights for operation )';
        $2A01 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOTABLOB ( Field is not a blob )';
        $2A02 : l_texte:= 'INVALIDCONTEXT (Invalid context ) BLOBOPENED ( Blob already opened )';
        $2A03 : l_texte:= 'INVALIDCONTEXT (Invalid context ) BLOBNOTOPENED ( Blob not opened )';
        $2A04 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NA ( Operation not applicable )';
        $2A05 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOTINDEXED ( Table is not indexed )';
        $2A06 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOTINITIALIZED ( Engine not initialized )';
        $2A07 : l_texte:= 'INVALIDCONTEXT (Invalid context ) MULTIPLEINIT ( Attempt to re-initialize engine )';
        $2A08 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOTSAMESESSION ( Attempt to mix objs from diff ses )';
        $2A09 : l_texte:= 'INVALIDCONTEXT (Invalid context ) PDXDRIVERNOTACTIVE ( Paradox driver not active )';
        $2A0A : l_texte:= 'INVALIDCONTEXT (Invalid context ) DRIVERNOTLOADED ( 0x0a Driver not loaded )';
        $2A0B : l_texte:= 'INVALIDCONTEXT (Invalid context ) TABLEREADONLY ( 0x0b Table is read only )';
        $2A0C : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOASSOCINDEX ( 0x0c No index associated with the cursor )';
        $2A0D : l_texte:= 'INVALIDCONTEXT (Invalid context ) HASOPENCURSORS ( 0x0d Has open cursors )';
        $2A0E : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOTABLESUPPORT ( 0x0e Op cannot be done on this table )';
        $2A0F : l_texte:= 'INVALIDCONTEXT (Invalid context ) INDEXREADONLY ( 0x0f Index is read only )';
        $2A10 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOUNIQUERECS ( 0x10 Records are not unique )';
        $2A11 : l_texte:= 'INVALIDCONTEXT (Invalid context ) NOTCURSESSION ( 0x11 Not the current/active session )';
        $2A12 : l_texte:= 'INVALIDCONTEXT (Invalid context ) INVALIDKEYWORD ( 0x12 Invalid use of keyword. )';
        $2A13 : l_texte:= 'INVALIDCONTEXT (Invalid context ) CONNECTINUSE ( 0x13 Connection in use )';
        $2A14 : l_texte:= 'INVALIDCONTEXT (Invalid context ) CONNECTNOTSHARED ( 0x14 Passthru SQL connection not share )';
        $2B01 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVFNC ( Invalid function number )';
        $2B02 : l_texte:= 'OS (Os Error not handled by Idapi ) OSENOENT ( No such file or directory )';
        $2B03 : l_texte:= 'OS (Os Error not handled by Idapi ) OSENOPATH ( Path not found )';
        $2B04 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEMFILE ( Too many open files )';
        $2B05 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEACCES ( Permission denied )';
        $2B06 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEBADF ( Bad file number )';
        $2B07 : l_texte:= 'OS (Os Error not handled by Idapi ) OSECONTR ( Memory blocks destroyed )';
        $2B08 : l_texte:= 'OS (Os Error not handled by Idapi ) OSENOMEM ( Not enough core )';
        $2B09 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVMEM ( Invalid memory block address )';
        $2B0A : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVENV ( 0x0a Invalid environment )';
        $2B0B : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVFMT ( 0x0b Invalid format )';
        $2B0C : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVACC ( 0x0c Invalid access code )';
        $2B0D : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVDAT ( 0x0d Invalid data )';
        $2B0F : l_texte:= 'OS (Os Error not handled by Idapi ) OSENODEV ( 0x0f No such device )';
        $2B10 : l_texte:= 'OS (Os Error not handled by Idapi ) OSECURDIR ( 0x10 Attempt to remove curdir )';
        $2B11 : l_texte:= 'OS (Os Error not handled by Idapi ) OSENOTSAM ( 0x11 Not same device )';
        $2B12 : l_texte:= 'OS (Os Error not handled by Idapi ) OSENMFILE ( 0x12 No more files )';
        $2B13 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEINVAL ( 0x13 Invalid argument )';
        $2B14 : l_texte:= 'OS (Os Error not handled by Idapi ) OSE ( 0x14 Arg list too long )';
        $2B15 : l_texte:= 'OS (Os Error not handled by Idapi ) OSENOEXEC ( 0x15 Exec format error )';
        $2B16 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEXDEV ( 0x16 Cross-device link )';
        $2B21 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEDOM ( 0x21 Math argument )';
        $2B22 : l_texte:= 'OS (Os Error not handled by Idapi ) OSERANGE ( 0x22 Result to large )';
        $2B23 : l_texte:= 'OS (Os Error not handled by Idapi ) OSEEXIST ( 0x23 File already exists )';
        $2B27 : l_texte:= 'OS (Os Error not handled by Idapi ) OSUNKNOWN ( 0x27 Unkown | illegal error from rtl )';
        $2B32 : l_texte:= 'OS (Os Error not handled by Idapi ) OSSHAREVIOL ( 0x32 Share viol, ext. err 0x20 )';
        $2B33 : l_texte:= 'OS (Os Error not handled by Idapi ) OSLOCKVIOL ( 0x33 Lock viol, ext. err 0x21 )';
        $2B34 : l_texte:= 'OS (Os Error not handled by Idapi ) OSINT ( 0x34 INT24 called )';
        $2B35 : l_texte:= 'OS (Os Error not handled by Idapi ) OSDRIVENOTREADY ( 0x35 Drive not ready )';
        $2B64 : l_texte:= 'OS (Os Error not handled by Idapi ) NOTEXACT ( 0x64 Not exact read/write )';
        $2B65 : l_texte:= 'OS (Os Error not handled by Idapi ) OSNETERR ( 0x65 Generic network error )';
        $2B66 : l_texte:= 'OS (Os Error not handled by Idapi ) OSUNKNOWNSRVERR ( 0x66 Error from file server )';
        $2B67 : l_texte:= 'OS (Os Error not handled by Idapi ) SERVERNOMEMORY ( 0x67 Server out of memory )';
        $2B68 : l_texte:= 'OS (Os Error not handled by Idapi ) OSALREADYLOCKED ( 0x68 Record already locked (by you) )';
        $2B69 : l_texte:= 'OS (Os Error not handled by Idapi ) OSNOTLOCKED ( 0x69 Record not locked )';
        $2B6A : l_texte:= 'OS (Os Error not handled by Idapi ) NOSERVERSW ('
                              + ' 0x6a Server software not running the workstation/server )';
        $2C01 : l_texte:= 'NETWORK (Network related ) NETINITERR ( Net init failed )';
        $2C02 : l_texte:= 'NETWORK (Network related ) NETUSERLIMIT ( Net user limit exceeded )';
        $2C03 : l_texte:= 'NETWORK (Network related ) NETFILEVERSION ( Wrong net file version )';
        $2C04 : l_texte:= 'NETWORK (Network related ) NETFILELOCKED ( Not able to lock net file )';
        $2C05 : l_texte:= 'NETWORK (Network related ) DIRNOTPRIVATE ()';
        $2C06 : l_texte:= 'NETWORK (Network related ) NETMULTIPLE ( Multiple net files in use )';
        $2C07 : l_texte:= 'NETWORK (Network related ) NETUNKNOWN ( Unknown net error )';
        $2C08 : l_texte:= 'NETWORK (Network related ) SHAREDFILE ( Cannot access a shared file )';
        $2C09 : l_texte:= 'NETWORK (Network related ) SHARENOTLOADED ( Share not loaded )';
        $2C0A : l_texte:= 'NETWORK (Network related ) NOTONANETWORK ( 0x0a Not an Network )';
        $2C0B : l_texte:= 'NETWORK (Network related ) SQLCOMMLOST ( 0x0b Lost Communication with SQL server )';
        $2C0C : l_texte:= 'NETWORK (Network related ) SERVERCOMMLOST ( 0x0c Lost Communication with IDAPI server )';
        $3E01 : l_texte:= 'DRIVER (Driver related ) WRONGDRVNAME ( Wrong driver name )';
        $3E02 : l_texte:= 'DRIVER (Driver related ) WRONGSYSVER ( Wrong system version )';
        $3E03 : l_texte:= 'DRIVER (Driver related ) WRONGDRVVER ( Wrong driver version )';
        $3E04 : l_texte:= 'DRIVER (Driver related ) WRONGDRVTYPE ( Wrong driver type )';
        $3E05 : l_texte:= 'DRIVER (Driver related ) CANNOTLOADDRV ( Can not load driver )';
        $3E06 : l_texte:= 'DRIVER (Driver related ) CANNOTLOADLDDRV ( Can not load language driver )';
        $3E07 : l_texte:= 'DRIVER (Driver related ) VENDINITFAIL ( Vendor init failure )';
        $2E01 : l_texte:= 'QUERY (Query related ) AMBJOASY ( obsolete )';
        $2E02 : l_texte:= 'QUERY (Query related ) AMBJOSYM ( obsolete )';
        $2E03 : l_texte:= 'QUERY (Query related ) AMBOUTEX ()';
        $2E04 : l_texte:= 'QUERY (Query related ) AMBOUTPR ( obsolete )';
        $2E05 : l_texte:= 'QUERY (Query related ) AMBSYMAS ( obsolete )';
        $2E06 : l_texte:= 'QUERY (Query related ) ASETOPER ()';
        $2E07 : l_texte:= 'QUERY (Query related ) AVENUMDA ()';
        $2E08 : l_texte:= 'QUERY (Query related ) BADEXPR ()';
        $2E09 : l_texte:= 'QUERY (Query related ) BADFLDOR ()';
        $2E0A : l_texte:= 'QUERY (Query related ) BADVNAME ( 0x0a )';
        $2E0B : l_texte:= 'QUERY (Query related ) BITMAPER ( 0x0b )';
        $2E0C : l_texte:= 'QUERY (Query related ) CALCBADR ( 0x0c )';
        $2E0D : l_texte:= 'QUERY (Query related ) CALCTYPE ( 0x0d )';
        $2E0E : l_texte:= 'QUERY (Query related ) CHGTO ( 0x0e )';
        $2E0F : l_texte:= 'QUERY (Query related ) CHGTOCHG ( 0x0f )';
        $2E10 : l_texte:= 'QUERY (Query related ) CHGTOEXP ( 0x10 )';
        $2E11 : l_texte:= 'QUERY (Query related ) CHGTOINS ( 0x11 )';
        $2E12 : l_texte:= 'QUERY (Query related ) CHGTONEW ( 0x12 )';
        $2E13 : l_texte:= 'QUERY (Query related ) CHGTOVAL ( 0x13 )';
        $2E14 : l_texte:= 'QUERY (Query related ) CHKMRKFI ( 0x14 )';
        $2E15 : l_texte:= 'QUERY (Query related ) CHNAMBIG ( 0x15 )';
        $2E16 : l_texte:= 'QUERY (Query related ) CHUNKERR ( 0x16 )';
        $2E17 : l_texte:= 'QUERY (Query related ) COLUM ( 0x17 )';
        $2E18 : l_texte:= 'QUERY (Query related ) CONAFTAS ( 0x18 )';
        $2E19 : l_texte:= 'QUERY (Query related ) DEL ( 0x19 )';
        $2E1A : l_texte:= 'QUERY (Query related ) DELAMBIG ( 0x1a )';
        $2E1B : l_texte:= 'QUERY (Query related ) DELFRDEL ( 0x1b )';
        $2E1C : l_texte:= 'QUERY (Query related ) EGFLDTYP ( 0x1c )';
        $2E1D : l_texte:= 'QUERY (Query related ) EXAMINOR ( 0x1d )';
        $2E1E : l_texte:= 'QUERY (Query related ) EXPRTYPS ( 0x1e )';
        $2E1F : l_texte:= 'QUERY (Query related ) EXTRACOM ( 0x1f )';
        $2E20 : l_texte:= 'QUERY (Query related ) EXTRAORO ( 0x20 )';
        $2E21 : l_texte:= 'QUERY (Query related ) EXTRAQRO ( 0x21 )';
        $2E22 : l_texte:= 'QUERY (Query related ) FIND ( 0x22 )';
        $2E23 : l_texte:= 'QUERY (Query related ) FINDANST ( 0x23 )';
        $2E24 : l_texte:= 'QUERY (Query related ) GRPNOSET ( 0x24 )';
        $2E25 : l_texte:= 'QUERY (Query related ) GRPSTROW ( 0x25 )';
        $2E26 : l_texte:= 'QUERY (Query related ) IDFINLCO ( 0x26 )';
        $2E27 : l_texte:= 'QUERY (Query related ) IDFPERLI ( 0x27 )';
        $2E28 : l_texte:= 'QUERY (Query related ) INANEXPR ( 0x28 )';
        $2E29 : l_texte:= 'QUERY (Query related ) INS ( 0x29 )';
        $2E2A : l_texte:= 'QUERY (Query related ) INSAMBIG ( 0x2a )';
        $2E2B : l_texte:= 'QUERY (Query related ) INSDELCH ( 0x2b )';
        $2E2C : l_texte:= 'QUERY (Query related ) INSEXPRR ( 0x2c )';
        $2E2D : l_texte:= 'QUERY (Query related ) INSTOINS ( 0x2d )';
        $2E2E : l_texte:= 'QUERY (Query related ) ISARRAY ( 0x2e )';
        $2E2F : l_texte:= 'QUERY (Query related ) LABELERR ( 0x2f )';
        $2E30 : l_texte:= 'QUERY (Query related ) LINKCALC ( 0x30 )';
        $2E31 : l_texte:= 'QUERY (Query related ) LNGVNAME ( 0x31 )';
        $2E32 : l_texte:= 'QUERY (Query related ) LONGQURY ( 0x32 )';
        $2E33 : l_texte:= 'QUERY (Query related ) MEMVPROC ( 0x33 )';
        $2E34 : l_texte:= 'QUERY (Query related ) MISNGCOM ( 0x34 )';
        $2E35 : l_texte:= 'QUERY (Query related ) MISNGRPA ( 0x35 )';
        $2E36 : l_texte:= 'QUERY (Query related ) MISSRTQU ( 0x36 )';
        $2E37 : l_texte:= 'QUERY (Query related ) NAMTWICE ( 0x37 )';
        $2E38 : l_texte:= 'QUERY (Query related ) NOCHKMAR ( 0x38 )';
        $2E39 : l_texte:= 'QUERY (Query related ) NODEFOCC ( 0x39 )';
        $2E3A : l_texte:= 'QUERY (Query related ) NOGROUPS ( 0x3a )';
        $2E3B : l_texte:= 'QUERY (Query related ) NONSENSE ( 0x3b )';
        $2E3C : l_texte:= 'QUERY (Query related ) NOPATTER ( 0x3c )';
        $2E3D : l_texte:= 'QUERY (Query related ) NOSUCHDA ( 0x3d )';
        $2E3E : l_texte:= 'QUERY (Query related ) NOVALUE ( 0x3e )';
        $2E3F : l_texte:= 'QUERY (Query related ) ONLYCONS ( 0x3f )';
        $2E40 : l_texte:= 'QUERY (Query related ) ONLYSETR ( 0x40 )';
        $2E41 : l_texte:= 'QUERY (Query related ) OUTSENS ( 0x41 )';
        $2E42 : l_texte:= 'QUERY (Query related ) OUTTWIC ( 0x42 )';
        $2E43 : l_texte:= 'QUERY (Query related ) PAROWCNT ( 0x43 )';
        $2E44 : l_texte:= 'QUERY (Query related ) PERSEPAR ( 0x44 )';
        $2E45 : l_texte:= 'QUERY (Query related ) PROCPLSW ( 0x45 )';
        $2E46 : l_texte:= 'QUERY (Query related ) PWINSRTS ( 0x46 )';
        $2E47 : l_texte:= 'QUERY (Query related ) PWMODRTS ( 0x47 )';
        $2E48 : l_texte:= 'QUERY (Query related ) QBEFLDFOUND ( 0x48 )';
        $2E49 : l_texte:= 'QUERY (Query related ) QBENOFENCE ( 0x49 )';
        $2E4A : l_texte:= 'QUERY (Query related ) QBENOFENCET ( 0x4a )';
        $2E4B : l_texte:= 'QUERY (Query related ) QBENOHEADERT ( 0x4b )';
        $2E4C : l_texte:= 'QUERY (Query related ) QBENOTAB ( 0x4c )';
        $2E4D : l_texte:= 'QUERY (Query related ) QBENUMCOLS ( 0x4d )';
        $2E4E : l_texte:= 'QUERY (Query related ) QBEOPENTAB ( 0x4e )';
        $2E4F : l_texte:= 'QUERY (Query related ) QBETWICE ( 0x4f )';
        $2E50 : l_texte:= 'QUERY (Query related ) QRYNOANSWER ( 0x50 )';
        $2E51 : l_texte:= 'QUERY (Query related ) QRYNOTPREP ( 0x51 )';
        $2E52 : l_texte:= 'QUERY (Query related ) QUAINDEL ( 0x52 )';
        $2E53 : l_texte:= 'QUERY (Query related ) QUAININS ( 0x53 )';
        $2E54 : l_texte:= 'QUERY (Query related ) RAGININS ( 0x54 )';
        $2E55 : l_texte:= 'QUERY (Query related ) RAGINSET ( 0x55 )';
        $2E56 : l_texte:= 'QUERY (Query related ) ROWUSERR ( 0x56 )';
        $2E57 : l_texte:= 'QUERY (Query related ) SETEXPEC ( 0x57 )';
        $2E58 : l_texte:= 'QUERY (Query related ) SETVAMB ( 0x58 )';
        $2E59 : l_texte:= 'QUERY (Query related ) SETVBAD ( 0x59 )';
        $2E5A : l_texte:= 'QUERY (Query related ) SETVDEF ( 0x5a )';
        $2E5B : l_texte:= 'QUERY (Query related ) SUMNUMBE ( 0x5b )';
        $2E5C : l_texte:= 'QUERY (Query related ) TBLISWP ( 0x5c )';
        $2E5D : l_texte:= 'QUERY (Query related ) TOKENNOT ( 0x5d )';
        $2E5E : l_texte:= 'QUERY (Query related ) TWOOUTR ( 0x5e )';
        $2E5F : l_texte:= 'QUERY (Query related ) TYPEMISM ( 0x5f )';
        $2E60 : l_texte:= 'QUERY (Query related ) UNRELQ ( 0x60 )';
        $2E61 : l_texte:= 'QUERY (Query related ) UNUSEDST ( 0x61 )';
        $2E62 : l_texte:= 'QUERY (Query related ) USEINSDE ( 0x62 )';
        $2E63 : l_texte:= 'QUERY (Query related ) USEOFCHG ( 0x63 )';
        $2E64 : l_texte:= 'QUERY (Query related ) VARMUSTF ( 0x64 )';
        $2E65 : l_texte:= 'QUERY (Query related ) REGISTER ( 0x65 )';
        $2E66 : l_texte:= 'QUERY (Query related ) LONGEXPR ( 0x66 )';
        $2E67 : l_texte:= 'QUERY (Query related ) REFRESH ( 0x67 )';
        $2E68 : l_texte:= 'QUERY (Query related ) CANCEXCEPT ( 0x68 )';
        $2E69 : l_texte:= 'QUERY (Query related ) DBEXCEPT ( 0x69 )';
        $2E6A : l_texte:= 'QUERY (Query related ) MEMEXCEPT ( 0x6a )';
        $2E6B : l_texte:= 'QUERY (Query related ) FATALEXCEPT ( 0x6b )';
        $2E6C : l_texte:= 'QUERY (Query related ) QRYNIY ( 0x6c )';
        $2E6D : l_texte:= 'QUERY (Query related ) BADFORMAT ( 0x6d )';
        $2E6E : l_texte:= 'QUERY (Query related ) QRYEMPTY ( 0x6e )';
        $2E6F : l_texte:= 'QUERY (Query related ) NOQRYTOPREP ( 0x6f )';
        $2E70 : l_texte:= 'QUERY (Query related ) BUFFTOOSMALL ( 0x70 )';
        $2E71 : l_texte:= 'QUERY (Query related ) QRYNOTPARSE ( 0x71 )';
        $2E72 : l_texte:= 'QUERY (Query related ) NOTHANDLE ( 0x72 )';
        $2E73 : l_texte:= 'QUERY (Query related ) QRYSYNTERR ( 0x73 )';
        $2E74 : l_texte:= 'QUERY (Query related ) QXFLDCOUNT ( 0x74 )';
        $2E75 : l_texte:= 'QUERY (Query related ) QXFLDSYMNOTFOUND ( 0x75 )';
        $2E76 : l_texte:= 'QUERY (Query related ) QXTBLSYMNOTFOUND ( 0x76 )';
        $2E77 : l_texte:= 'QUERY (Query related ) BLOBTERM ( 0x77 )';
        $2E78 : l_texte:= 'QUERY (Query related ) BLOBERR ( 0x78 )';
        $2E79 : l_texte:= 'QUERY (Query related ) RESTARTQRY ( 0x79 )';
        $2E7A : l_texte:= 'QUERY (Query related ) UNKNOWNANSTYPE ( 0x7a )';
        $2E7B : l_texte:= 'QUERY (Query related ) SQLG_MDIST ( 0x7b )';
        $2E7C : l_texte:= 'QUERY (Query related ) SQLG_NOARI ( 0x7c )';
        $2E7D : l_texte:= 'QUERY (Query related ) SQLG_LIKEN ( 0x7d )';
        $2E7E : l_texte:= 'QUERY (Query related ) SQLG_ALPHO ( 0x7e )';
        $2E7F : l_texte:= 'QUERY (Query related ) SQLG_DATEO ( 0x7f )';
        $2E80 : l_texte:= 'QUERY (Query related ) SQLG_RELOP ( 0x80 )';
        $2E81 : l_texte:= 'QUERY (Query related ) SQLG_ONLYC ( 0x81 )';
        $2E82 : l_texte:= 'QUERY (Query related ) SQLG_CNTLN ( 0x82 )';
        $2E83 : l_texte:= 'QUERY (Query related ) SQLG_CHINI ( 0x83 )';
        $2E84 : l_texte:= 'QUERY (Query related ) SQLG_UNION ( 0x84 )';
        $2E85 : l_texte:= 'QUERY (Query related ) SQLG_SLFIN ( 0x85 )';
        $2E86 : l_texte:= 'QUERY (Query related ) SQLG_OTJVR ( 0x86 )';
        $2E87 : l_texte:= 'QUERY (Query related ) SQLG_STROW ( 0x87 )';
        $2E88 : l_texte:= 'QUERY (Query related ) SQLG_QUANT ( 0x88 )';
        $2E89 : l_texte:= 'QUERY (Query related ) SQLG_REGSO ( 0x89 )';
        $2E8A : l_texte:= 'QUERY (Query related ) SQLG_COUNT ( 0x8a )';
        $2E8B : l_texte:= 'QUERY (Query related ) SQLG_AVERA ( 0x8b )';
        $2E8C : l_texte:= 'QUERY (Query related ) SQLG_DATEA ( 0x8c )';
        $2E8D : l_texte:= 'QUERY (Query related ) SQLG_BADPT ( 0x8d )';
        $2E8E : l_texte:= 'QUERY (Query related ) SQLG_RELPA ( 0x8e )';
        $2E8F : l_texte:= 'QUERY (Query related ) SQLG_PATRN ( 0x8f )';
        $2E90 : l_texte:= 'QUERY (Query related ) SQLG_FNDSU ( 0x90 )';
        $2E91 : l_texte:= 'QUERY (Query related ) SQLG_IFDCS ( 0x91 )';
        $2E92 : l_texte:= 'QUERY (Query related ) SQLG_IDCCO ( 0x92 )';
        $2E93 : l_texte:= 'QUERY (Query related ) SQLG_ONLYI ( 0x93 )';
        $2E94 : l_texte:= 'QUERY (Query related ) SQLG_SQLDIALECT ( 0x94 )';
        $2E95 : l_texte:= 'QUERY (Query related ) SQLG_NOQUERY ( 0x95 )';
        $2E96 : l_texte:= 'QUERY (Query related ) BLOBGROUP ( 0x96 )';
        $2E97 : l_texte:= 'QUERY (Query related ) QRYNOPROP ( 0x97 )';
        $2E98 : l_texte:= 'QUERY (Query related ) ANSTYPNOTSUP ( 0x98 )';
        $2E99 : l_texte:= 'QUERY (Query related ) ANSALIASNOTSUP ( 0x99 )';
        $2E9A : l_texte:= 'QUERY (Query related ) INSBLOBREQ ( 0x9a )';
        $2E9B : l_texte:= 'QUERY (Query related ) CHGUNIQUENDXREQ ( 0x9b )';
        $2E9C : l_texte:= 'QUERY (Query related ) DELUNIQUENDXREQ ( 0x9c )';
        $2E9D : l_texte:= 'QUERY (Query related ) SQLNOFULLUPDATE ( 0x9d )';
        $2E9E : l_texte:= 'QUERY (Query related ) CANTEXECREMOTE ( 0x9e )';
        $2E9F : l_texte:= 'QUERY (Query related ) UNEXPECTEDEOC ( 0x9f )';
        $2EA0 : l_texte:= 'QUERY (Query related ) SQLPARAMNOTSET ( 0xA0 )';
        $2EA1 : l_texte:= 'QUERY (Query related ) QUERYTOOLONG ( 0xA1 )';
        $2F01 : l_texte:= 'VERSION (Version Mismatch Category ) INTERFACEVER ( Interface mismatch )';
        $2F02 : l_texte:= 'VERSION (Version Mismatch Category ) INDEXOUTOFDATE ( Index is out of date )';
        $2F03 : l_texte:= 'VERSION (Version Mismatch Category ) OLDVERSION ( Older version (see context) )';
        $2F04 : l_texte:= 'VERSION (Version Mismatch Category ) VALFILEINVALID ( Val. file is out of date )';
        $2F05 : l_texte:= 'VERSION (Version Mismatch Category ) BLOBVERSION ( Old Blob file version )';
        $2F06 : l_texte:= 'VERSION (Version Mismatch Category ) ENGQRYMISMATCH ( Query and IDAPI are mismatched )';
        $2F07 : l_texte:= 'VERSION (Version Mismatch Category ) SERVERVERSION ( Server is incompatible version )';
        $3001 : l_texte:= 'CAPABILITY (Capability not supported ) NOTSUPPORTED ( Capability not supported )';
        $3002 : l_texte:= 'CAPABILITY (Capability not supported ) NIY ( Not Implemented Yet )';
        $3003 : l_texte:= 'CAPABILITY (Capability not supported ) TABLESQL ( Cannot access SQL replica )';
        $3004 : l_texte:= 'CAPABILITY (Capability not supported ) SEARCHCOLREQD ( Searchable (Non-blob column) required )';
        $3005 : l_texte:= 'CAPABILITY (Capability not supported ) NOMULTCONNECT ( Multiple connections not supported )';
        $3101 : l_texte:= 'CONFIG (System configuration error ) INVALIDDBSPEC ()';
        $3102 : l_texte:= 'CONFIG (System configuration error ) UNKNOWNDBTYPE ()';
        $3103 : l_texte:= 'CONFIG (System configuration error ) INVALIDSYSDATA ()';
        $3104 : l_texte:= 'CONFIG (System configuration error ) UNKNOWNNETTYPE ()';
        $3105 : l_texte:= 'CONFIG (System configuration error ) NOTONTHATNET ()';
        $3106 : l_texte:= 'CONFIG (System configuration error ) INVALIDCFGPARAM ( Generic invalid config param )';
        $3201 : l_texte:= 'WARNING () OBJIMPLICITLYDROPPED ()';
        $3202 : l_texte:= 'WARNING () OBJMAYBETRUNCATED ()';
        $3203 : l_texte:= 'WARNING () OBJIMPLICITLYMODIFIED ()';
        $3204 : l_texte:= 'WARNING () VALIDATEDATA ()';
        $3205 : l_texte:= 'WARNING () VALFIELDMODIFIED ()';
        $3206 : l_texte:= 'WARNING () TABLELEVELCHANGED ()';
        $3207 : l_texte:= 'WARNING () COPYLINKEDTABLES ()';
        $3208 : l_texte:= 'WARNING () OTHERSERVERLOADED ()';
        $320A : l_texte:= 'WARNING () VCHKMAYNOTBEENFORCED ()';
        $320B : l_texte:= 'WARNING () MULTIPLEUNIQRECS ()';
        $320C : l_texte:= 'WARNING () FIELDMUSTBETRIMMED ()';
        $3301 : l_texte:= 'OTHER (Miscellaneous ) FILEEXISTS ( File already exsits )';
        $3302 : l_texte:= 'OTHER (Miscellaneous ) BLOBMODIFIED ( Another user modified Blob )';
        $3303 : l_texte:= 'OTHER (Miscellaneous ) UNKNOWNSQL ( Unknown SQL error )';
        $3304 : l_texte:= 'OTHER (Miscellaneous ) TABLEEXISTS ( Table already exsits )';
        $3305 : l_texte:= 'OTHER (Miscellaneous ) PDX ( Paradox 1.0 tables not supported )';
        $3401 : l_texte:= 'COMPATIBILITY (Compatibility related ) DIFFSORTORDER ( Sortorders not compatible )';
        $3402 : l_texte:= 'COMPATIBILITY (Compatibility related ) DIRINUSEBYOLDVER ( Directory in use by old version )';
        $3403 : l_texte:= 'COMPATIBILITY (Compatibility related ) PDX ( Needs Pdox 3.5 compatible language driver )';
        $2D01 : l_texte:= 'OPTPARAM (Optional parameter related ) REQOPTPARAM ( Required optional parameter missing )';
        $2D02 : l_texte:= 'OPTPARAM (Optional parameter related ) INVALIDOPTPARAM ( Optional param out-of-range or bad )';

      else l_texte:= 'inconnu';
      end; (* case *)
      f_erreur_dbi:= ' $'+ IntToHex(p_code, 4)+ ' '+ l_texte;
    end;
